import { useState as tr, useEffect as wr, useRef as Ja, useMemo as Rn } from "react";
const Wa = {
  required: (e) => `${e.missingProperty} is required.`,
  minLength: (e) => e.limit === 1 ? "This field is required." : `Should be at least ${e.limit} characters long.`,
  maxLength: (e) => `Should not exceed ${e.limit} characters.`,
  pattern: () => "Invalid format.",
  minimum: (e) => `Should be greater than or equal to ${e.limit}.`,
  maximum: (e) => `Should be less than or equal to ${e.limit}.`,
  enum: (e) => {
    var t;
    return `${(t = e.allowedValues) == null ? void 0 : t.join(", ")} are the only allowed values.`;
  },
  type: (e) => `Should be of type ${e.type}.`,
  format: (e) => `Should be in ${e.format} format.`
}, Ba = (e) => e ? e.slice(1) : null, Ya = (e, t) => {
  const r = "Unknown validation error";
  try {
    const a = e, n = a.keyword, i = { ...Wa, ...t }[n];
    return typeof i == "function" ? i(a.params) : e.message || r;
  } catch {
    return r;
  }
}, Yt = (e, t) => e.reduce((r, a) => {
  const n = Ba(a == null ? void 0 : a.instancePath);
  return n ? {
    ...r,
    [n]: Ya(a, t)
  } : r;
}, {}), jn = (e) => {
  const t = {};
  for (const r in e)
    Object.prototype.hasOwnProperty.call(e, r) && (t[r] = { value: e[r], error: "" });
  return t;
}, It = (e) => e == null ? "" : e ?? "", Xa = (e, t) => {
  t.forEach((r) => {
    e.getKeyword(r.keyword) || e.addKeyword(r);
  });
};
var Qa = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function jr(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Er = { exports: {} }, Zn = {}, Oe = {}, yt = {}, gt = {}, X = {}, vt = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.regexpCode = e.getEsmExportName = e.getProperty = e.safeStringify = e.stringify = e.strConcat = e.addCodeArg = e.str = e._ = e.nil = e._Code = e.Name = e.IDENTIFIER = e._CodeOrName = void 0;
  class t {
  }
  e._CodeOrName = t, e.IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
  class r extends t {
    constructor(h) {
      if (super(), !e.IDENTIFIER.test(h))
        throw new Error("CodeGen: name must be a valid identifier");
      this.str = h;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      return !1;
    }
    get names() {
      return { [this.str]: 1 };
    }
  }
  e.Name = r;
  class a extends t {
    constructor(h) {
      super(), this._items = typeof h == "string" ? [h] : h;
    }
    toString() {
      return this.str;
    }
    emptyStr() {
      if (this._items.length > 1)
        return !1;
      const h = this._items[0];
      return h === "" || h === '""';
    }
    get str() {
      var h;
      return (h = this._str) !== null && h !== void 0 ? h : this._str = this._items.reduce((O, j) => `${O}${j}`, "");
    }
    get names() {
      var h;
      return (h = this._names) !== null && h !== void 0 ? h : this._names = this._items.reduce((O, j) => (j instanceof r && (O[j.str] = (O[j.str] || 0) + 1), O), {});
    }
  }
  e._Code = a, e.nil = new a("");
  function n(f, ...h) {
    const O = [f[0]];
    let j = 0;
    for (; j < h.length; )
      m(O, h[j]), O.push(f[++j]);
    return new a(O);
  }
  e._ = n;
  const i = new a("+");
  function u(f, ...h) {
    const O = [k(f[0])];
    let j = 0;
    for (; j < h.length; )
      O.push(i), m(O, h[j]), O.push(i, k(f[++j]));
    return y(O), new a(O);
  }
  e.str = u;
  function m(f, h) {
    h instanceof a ? f.push(...h._items) : h instanceof r ? f.push(h) : f.push(_(h));
  }
  e.addCodeArg = m;
  function y(f) {
    let h = 1;
    for (; h < f.length - 1; ) {
      if (f[h] === i) {
        const O = l(f[h - 1], f[h + 1]);
        if (O !== void 0) {
          f.splice(h - 1, 3, O);
          continue;
        }
        f[h++] = "+";
      }
      h++;
    }
  }
  function l(f, h) {
    if (h === '""')
      return f;
    if (f === '""')
      return h;
    if (typeof f == "string")
      return h instanceof r || f[f.length - 1] !== '"' ? void 0 : typeof h != "string" ? `${f.slice(0, -1)}${h}"` : h[0] === '"' ? f.slice(0, -1) + h.slice(1) : void 0;
    if (typeof h == "string" && h[0] === '"' && !(f instanceof r))
      return `"${f}${h.slice(1)}`;
  }
  function p(f, h) {
    return h.emptyStr() ? f : f.emptyStr() ? h : u`${f}${h}`;
  }
  e.strConcat = p;
  function _(f) {
    return typeof f == "number" || typeof f == "boolean" || f === null ? f : k(Array.isArray(f) ? f.join(",") : f);
  }
  function D(f) {
    return new a(k(f));
  }
  e.stringify = D;
  function k(f) {
    return JSON.stringify(f).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
  }
  e.safeStringify = k;
  function S(f) {
    return typeof f == "string" && e.IDENTIFIER.test(f) ? new a(`.${f}`) : n`[${f}]`;
  }
  e.getProperty = S;
  function P(f) {
    if (typeof f == "string" && e.IDENTIFIER.test(f))
      return new a(`${f}`);
    throw new Error(`CodeGen: invalid export name: ${f}, use explicit $id name mapping`);
  }
  e.getEsmExportName = P;
  function g(f) {
    return new a(f.toString());
  }
  e.regexpCode = g;
})(vt);
var br = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.ValueScope = e.ValueScopeName = e.Scope = e.varKinds = e.UsedValueState = void 0;
  const t = vt;
  class r extends Error {
    constructor(l) {
      super(`CodeGen: "code" for ${l} not defined`), this.value = l.value;
    }
  }
  var a;
  (function(y) {
    y[y.Started = 0] = "Started", y[y.Completed = 1] = "Completed";
  })(a = e.UsedValueState || (e.UsedValueState = {})), e.varKinds = {
    const: new t.Name("const"),
    let: new t.Name("let"),
    var: new t.Name("var")
  };
  class n {
    constructor({ prefixes: l, parent: p } = {}) {
      this._names = {}, this._prefixes = l, this._parent = p;
    }
    toName(l) {
      return l instanceof t.Name ? l : this.name(l);
    }
    name(l) {
      return new t.Name(this._newName(l));
    }
    _newName(l) {
      const p = this._names[l] || this._nameGroup(l);
      return `${l}${p.index++}`;
    }
    _nameGroup(l) {
      var p, _;
      if (!((_ = (p = this._parent) === null || p === void 0 ? void 0 : p._prefixes) === null || _ === void 0) && _.has(l) || this._prefixes && !this._prefixes.has(l))
        throw new Error(`CodeGen: prefix "${l}" is not allowed in this scope`);
      return this._names[l] = { prefix: l, index: 0 };
    }
  }
  e.Scope = n;
  class i extends t.Name {
    constructor(l, p) {
      super(p), this.prefix = l;
    }
    setValue(l, { property: p, itemIndex: _ }) {
      this.value = l, this.scopePath = (0, t._)`.${new t.Name(p)}[${_}]`;
    }
  }
  e.ValueScopeName = i;
  const u = (0, t._)`\n`;
  class m extends n {
    constructor(l) {
      super(l), this._values = {}, this._scope = l.scope, this.opts = { ...l, _n: l.lines ? u : t.nil };
    }
    get() {
      return this._scope;
    }
    name(l) {
      return new i(l, this._newName(l));
    }
    value(l, p) {
      var _;
      if (p.ref === void 0)
        throw new Error("CodeGen: ref must be passed in value");
      const D = this.toName(l), { prefix: k } = D, S = (_ = p.key) !== null && _ !== void 0 ? _ : p.ref;
      let P = this._values[k];
      if (P) {
        const h = P.get(S);
        if (h)
          return h;
      } else
        P = this._values[k] = /* @__PURE__ */ new Map();
      P.set(S, D);
      const g = this._scope[k] || (this._scope[k] = []), f = g.length;
      return g[f] = p.ref, D.setValue(p, { property: k, itemIndex: f }), D;
    }
    getValue(l, p) {
      const _ = this._values[l];
      if (_)
        return _.get(p);
    }
    scopeRefs(l, p = this._values) {
      return this._reduceValues(p, (_) => {
        if (_.scopePath === void 0)
          throw new Error(`CodeGen: name "${_}" has no value`);
        return (0, t._)`${l}${_.scopePath}`;
      });
    }
    scopeCode(l = this._values, p, _) {
      return this._reduceValues(l, (D) => {
        if (D.value === void 0)
          throw new Error(`CodeGen: name "${D}" has no value`);
        return D.value.code;
      }, p, _);
    }
    _reduceValues(l, p, _ = {}, D) {
      let k = t.nil;
      for (const S in l) {
        const P = l[S];
        if (!P)
          continue;
        const g = _[S] = _[S] || /* @__PURE__ */ new Map();
        P.forEach((f) => {
          if (g.has(f))
            return;
          g.set(f, a.Started);
          let h = p(f);
          if (h) {
            const O = this.opts.es5 ? e.varKinds.var : e.varKinds.const;
            k = (0, t._)`${k}${O} ${f} = ${h};${this.opts._n}`;
          } else if (h = D == null ? void 0 : D(f))
            k = (0, t._)`${k}${h}${this.opts._n}`;
          else
            throw new r(f);
          g.set(f, a.Completed);
        });
      }
      return k;
    }
  }
  e.ValueScope = m;
})(br);
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.or = e.and = e.not = e.CodeGen = e.operators = e.varKinds = e.ValueScopeName = e.ValueScope = e.Scope = e.Name = e.regexpCode = e.stringify = e.getProperty = e.nil = e.strConcat = e.str = e._ = void 0;
  const t = vt, r = br;
  var a = vt;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return a._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return a.str;
  } }), Object.defineProperty(e, "strConcat", { enumerable: !0, get: function() {
    return a.strConcat;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return a.nil;
  } }), Object.defineProperty(e, "getProperty", { enumerable: !0, get: function() {
    return a.getProperty;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return a.stringify;
  } }), Object.defineProperty(e, "regexpCode", { enumerable: !0, get: function() {
    return a.regexpCode;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return a.Name;
  } });
  var n = br;
  Object.defineProperty(e, "Scope", { enumerable: !0, get: function() {
    return n.Scope;
  } }), Object.defineProperty(e, "ValueScope", { enumerable: !0, get: function() {
    return n.ValueScope;
  } }), Object.defineProperty(e, "ValueScopeName", { enumerable: !0, get: function() {
    return n.ValueScopeName;
  } }), Object.defineProperty(e, "varKinds", { enumerable: !0, get: function() {
    return n.varKinds;
  } }), e.operators = {
    GT: new t._Code(">"),
    GTE: new t._Code(">="),
    LT: new t._Code("<"),
    LTE: new t._Code("<="),
    EQ: new t._Code("==="),
    NEQ: new t._Code("!=="),
    NOT: new t._Code("!"),
    OR: new t._Code("||"),
    AND: new t._Code("&&"),
    ADD: new t._Code("+")
  };
  class i {
    optimizeNodes() {
      return this;
    }
    optimizeNames(s, c) {
      return this;
    }
  }
  class u extends i {
    constructor(s, c, T) {
      super(), this.varKind = s, this.name = c, this.rhs = T;
    }
    render({ es5: s, _n: c }) {
      const T = s ? r.varKinds.var : this.varKind, F = this.rhs === void 0 ? "" : ` = ${this.rhs}`;
      return `${T} ${this.name}${F};` + c;
    }
    optimizeNames(s, c) {
      if (s[this.name.str])
        return this.rhs && (this.rhs = ne(this.rhs, s, c)), this;
    }
    get names() {
      return this.rhs instanceof t._CodeOrName ? this.rhs.names : {};
    }
  }
  class m extends i {
    constructor(s, c, T) {
      super(), this.lhs = s, this.rhs = c, this.sideEffects = T;
    }
    render({ _n: s }) {
      return `${this.lhs} = ${this.rhs};` + s;
    }
    optimizeNames(s, c) {
      if (!(this.lhs instanceof t.Name && !s[this.lhs.str] && !this.sideEffects))
        return this.rhs = ne(this.rhs, s, c), this;
    }
    get names() {
      const s = this.lhs instanceof t.Name ? {} : { ...this.lhs.names };
      return re(s, this.rhs);
    }
  }
  class y extends m {
    constructor(s, c, T, F) {
      super(s, T, F), this.op = c;
    }
    render({ _n: s }) {
      return `${this.lhs} ${this.op}= ${this.rhs};` + s;
    }
  }
  class l extends i {
    constructor(s) {
      super(), this.label = s, this.names = {};
    }
    render({ _n: s }) {
      return `${this.label}:` + s;
    }
  }
  class p extends i {
    constructor(s) {
      super(), this.label = s, this.names = {};
    }
    render({ _n: s }) {
      return `break${this.label ? ` ${this.label}` : ""};` + s;
    }
  }
  class _ extends i {
    constructor(s) {
      super(), this.error = s;
    }
    render({ _n: s }) {
      return `throw ${this.error};` + s;
    }
    get names() {
      return this.error.names;
    }
  }
  class D extends i {
    constructor(s) {
      super(), this.code = s;
    }
    render({ _n: s }) {
      return `${this.code};` + s;
    }
    optimizeNodes() {
      return `${this.code}` ? this : void 0;
    }
    optimizeNames(s, c) {
      return this.code = ne(this.code, s, c), this;
    }
    get names() {
      return this.code instanceof t._CodeOrName ? this.code.names : {};
    }
  }
  class k extends i {
    constructor(s = []) {
      super(), this.nodes = s;
    }
    render(s) {
      return this.nodes.reduce((c, T) => c + T.render(s), "");
    }
    optimizeNodes() {
      const { nodes: s } = this;
      let c = s.length;
      for (; c--; ) {
        const T = s[c].optimizeNodes();
        Array.isArray(T) ? s.splice(c, 1, ...T) : T ? s[c] = T : s.splice(c, 1);
      }
      return s.length > 0 ? this : void 0;
    }
    optimizeNames(s, c) {
      const { nodes: T } = this;
      let F = T.length;
      for (; F--; ) {
        const M = T[F];
        M.optimizeNames(s, c) || (ve(s, M.names), T.splice(F, 1));
      }
      return T.length > 0 ? this : void 0;
    }
    get names() {
      return this.nodes.reduce((s, c) => K(s, c.names), {});
    }
  }
  class S extends k {
    render(s) {
      return "{" + s._n + super.render(s) + "}" + s._n;
    }
  }
  class P extends k {
  }
  class g extends S {
  }
  g.kind = "else";
  class f extends S {
    constructor(s, c) {
      super(c), this.condition = s;
    }
    render(s) {
      let c = `if(${this.condition})` + super.render(s);
      return this.else && (c += "else " + this.else.render(s)), c;
    }
    optimizeNodes() {
      super.optimizeNodes();
      const s = this.condition;
      if (s === !0)
        return this.nodes;
      let c = this.else;
      if (c) {
        const T = c.optimizeNodes();
        c = this.else = Array.isArray(T) ? new g(T) : T;
      }
      if (c)
        return s === !1 ? c instanceof f ? c : c.nodes : this.nodes.length ? this : new f(je(s), c instanceof f ? [c] : c.nodes);
      if (!(s === !1 || !this.nodes.length))
        return this;
    }
    optimizeNames(s, c) {
      var T;
      if (this.else = (T = this.else) === null || T === void 0 ? void 0 : T.optimizeNames(s, c), !!(super.optimizeNames(s, c) || this.else))
        return this.condition = ne(this.condition, s, c), this;
    }
    get names() {
      const s = super.names;
      return re(s, this.condition), this.else && K(s, this.else.names), s;
    }
  }
  f.kind = "if";
  class h extends S {
  }
  h.kind = "for";
  class O extends h {
    constructor(s) {
      super(), this.iteration = s;
    }
    render(s) {
      return `for(${this.iteration})` + super.render(s);
    }
    optimizeNames(s, c) {
      if (super.optimizeNames(s, c))
        return this.iteration = ne(this.iteration, s, c), this;
    }
    get names() {
      return K(super.names, this.iteration.names);
    }
  }
  class j extends h {
    constructor(s, c, T, F) {
      super(), this.varKind = s, this.name = c, this.from = T, this.to = F;
    }
    render(s) {
      const c = s.es5 ? r.varKinds.var : this.varKind, { name: T, from: F, to: M } = this;
      return `for(${c} ${T}=${F}; ${T}<${M}; ${T}++)` + super.render(s);
    }
    get names() {
      const s = re(super.names, this.from);
      return re(s, this.to);
    }
  }
  class V extends h {
    constructor(s, c, T, F) {
      super(), this.loop = s, this.varKind = c, this.name = T, this.iterable = F;
    }
    render(s) {
      return `for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})` + super.render(s);
    }
    optimizeNames(s, c) {
      if (super.optimizeNames(s, c))
        return this.iterable = ne(this.iterable, s, c), this;
    }
    get names() {
      return K(super.names, this.iterable.names);
    }
  }
  class w extends S {
    constructor(s, c, T) {
      super(), this.name = s, this.args = c, this.async = T;
    }
    render(s) {
      return `${this.async ? "async " : ""}function ${this.name}(${this.args})` + super.render(s);
    }
  }
  w.kind = "func";
  class N extends k {
    render(s) {
      return "return " + super.render(s);
    }
  }
  N.kind = "return";
  class I extends S {
    render(s) {
      let c = "try" + super.render(s);
      return this.catch && (c += this.catch.render(s)), this.finally && (c += this.finally.render(s)), c;
    }
    optimizeNodes() {
      var s, c;
      return super.optimizeNodes(), (s = this.catch) === null || s === void 0 || s.optimizeNodes(), (c = this.finally) === null || c === void 0 || c.optimizeNodes(), this;
    }
    optimizeNames(s, c) {
      var T, F;
      return super.optimizeNames(s, c), (T = this.catch) === null || T === void 0 || T.optimizeNames(s, c), (F = this.finally) === null || F === void 0 || F.optimizeNames(s, c), this;
    }
    get names() {
      const s = super.names;
      return this.catch && K(s, this.catch.names), this.finally && K(s, this.finally.names), s;
    }
  }
  class A extends S {
    constructor(s) {
      super(), this.error = s;
    }
    render(s) {
      return `catch(${this.error})` + super.render(s);
    }
  }
  A.kind = "catch";
  class z extends S {
    render(s) {
      return "finally" + super.render(s);
    }
  }
  z.kind = "finally";
  class J {
    constructor(s, c = {}) {
      this._values = {}, this._blockStarts = [], this._constants = {}, this.opts = { ...c, _n: c.lines ? `
` : "" }, this._extScope = s, this._scope = new r.Scope({ parent: s }), this._nodes = [new P()];
    }
    toString() {
      return this._root.render(this.opts);
    }
    // returns unique name in the internal scope
    name(s) {
      return this._scope.name(s);
    }
    // reserves unique name in the external scope
    scopeName(s) {
      return this._extScope.name(s);
    }
    // reserves unique name in the external scope and assigns value to it
    scopeValue(s, c) {
      const T = this._extScope.value(s, c);
      return (this._values[T.prefix] || (this._values[T.prefix] = /* @__PURE__ */ new Set())).add(T), T;
    }
    getScopeValue(s, c) {
      return this._extScope.getValue(s, c);
    }
    // return code that assigns values in the external scope to the names that are used internally
    // (same names that were returned by gen.scopeName or gen.scopeValue)
    scopeRefs(s) {
      return this._extScope.scopeRefs(s, this._values);
    }
    scopeCode() {
      return this._extScope.scopeCode(this._values);
    }
    _def(s, c, T, F) {
      const M = this._scope.toName(c);
      return T !== void 0 && F && (this._constants[M.str] = T), this._leafNode(new u(s, M, T)), M;
    }
    // `const` declaration (`var` in es5 mode)
    const(s, c, T) {
      return this._def(r.varKinds.const, s, c, T);
    }
    // `let` declaration with optional assignment (`var` in es5 mode)
    let(s, c, T) {
      return this._def(r.varKinds.let, s, c, T);
    }
    // `var` declaration with optional assignment
    var(s, c, T) {
      return this._def(r.varKinds.var, s, c, T);
    }
    // assignment code
    assign(s, c, T) {
      return this._leafNode(new m(s, c, T));
    }
    // `+=` code
    add(s, c) {
      return this._leafNode(new y(s, e.operators.ADD, c));
    }
    // appends passed SafeExpr to code or executes Block
    code(s) {
      return typeof s == "function" ? s() : s !== t.nil && this._leafNode(new D(s)), this;
    }
    // returns code for object literal for the passed argument list of key-value pairs
    object(...s) {
      const c = ["{"];
      for (const [T, F] of s)
        c.length > 1 && c.push(","), c.push(T), (T !== F || this.opts.es5) && (c.push(":"), (0, t.addCodeArg)(c, F));
      return c.push("}"), new t._Code(c);
    }
    // `if` clause (or statement if `thenBody` and, optionally, `elseBody` are passed)
    if(s, c, T) {
      if (this._blockNode(new f(s)), c && T)
        this.code(c).else().code(T).endIf();
      else if (c)
        this.code(c).endIf();
      else if (T)
        throw new Error('CodeGen: "else" body without "then" body');
      return this;
    }
    // `else if` clause - invalid without `if` or after `else` clauses
    elseIf(s) {
      return this._elseNode(new f(s));
    }
    // `else` clause - only valid after `if` or `else if` clauses
    else() {
      return this._elseNode(new g());
    }
    // end `if` statement (needed if gen.if was used only with condition)
    endIf() {
      return this._endBlockNode(f, g);
    }
    _for(s, c) {
      return this._blockNode(s), c && this.code(c).endFor(), this;
    }
    // a generic `for` clause (or statement if `forBody` is passed)
    for(s, c) {
      return this._for(new O(s), c);
    }
    // `for` statement for a range of values
    forRange(s, c, T, F, M = this.opts.es5 ? r.varKinds.var : r.varKinds.let) {
      const q = this._scope.toName(s);
      return this._for(new j(M, q, c, T), () => F(q));
    }
    // `for-of` statement (in es5 mode replace with a normal for loop)
    forOf(s, c, T, F = r.varKinds.const) {
      const M = this._scope.toName(s);
      if (this.opts.es5) {
        const q = c instanceof t.Name ? c : this.var("_arr", c);
        return this.forRange("_i", 0, (0, t._)`${q}.length`, (W) => {
          this.var(M, (0, t._)`${q}[${W}]`), T(M);
        });
      }
      return this._for(new V("of", F, M, c), () => T(M));
    }
    // `for-in` statement.
    // With option `ownProperties` replaced with a `for-of` loop for object keys
    forIn(s, c, T, F = this.opts.es5 ? r.varKinds.var : r.varKinds.const) {
      if (this.opts.ownProperties)
        return this.forOf(s, (0, t._)`Object.keys(${c})`, T);
      const M = this._scope.toName(s);
      return this._for(new V("in", F, M, c), () => T(M));
    }
    // end `for` loop
    endFor() {
      return this._endBlockNode(h);
    }
    // `label` statement
    label(s) {
      return this._leafNode(new l(s));
    }
    // `break` statement
    break(s) {
      return this._leafNode(new p(s));
    }
    // `return` statement
    return(s) {
      const c = new N();
      if (this._blockNode(c), this.code(s), c.nodes.length !== 1)
        throw new Error('CodeGen: "return" should have one node');
      return this._endBlockNode(N);
    }
    // `try` statement
    try(s, c, T) {
      if (!c && !T)
        throw new Error('CodeGen: "try" without "catch" and "finally"');
      const F = new I();
      if (this._blockNode(F), this.code(s), c) {
        const M = this.name("e");
        this._currNode = F.catch = new A(M), c(M);
      }
      return T && (this._currNode = F.finally = new z(), this.code(T)), this._endBlockNode(A, z);
    }
    // `throw` statement
    throw(s) {
      return this._leafNode(new _(s));
    }
    // start self-balancing block
    block(s, c) {
      return this._blockStarts.push(this._nodes.length), s && this.code(s).endBlock(c), this;
    }
    // end the current self-balancing block
    endBlock(s) {
      const c = this._blockStarts.pop();
      if (c === void 0)
        throw new Error("CodeGen: not in self-balancing block");
      const T = this._nodes.length - c;
      if (T < 0 || s !== void 0 && T !== s)
        throw new Error(`CodeGen: wrong number of nodes: ${T} vs ${s} expected`);
      return this._nodes.length = c, this;
    }
    // `function` heading (or definition if funcBody is passed)
    func(s, c = t.nil, T, F) {
      return this._blockNode(new w(s, c, T)), F && this.code(F).endFunc(), this;
    }
    // end function definition
    endFunc() {
      return this._endBlockNode(w);
    }
    optimize(s = 1) {
      for (; s-- > 0; )
        this._root.optimizeNodes(), this._root.optimizeNames(this._root.names, this._constants);
    }
    _leafNode(s) {
      return this._currNode.nodes.push(s), this;
    }
    _blockNode(s) {
      this._currNode.nodes.push(s), this._nodes.push(s);
    }
    _endBlockNode(s, c) {
      const T = this._currNode;
      if (T instanceof s || c && T instanceof c)
        return this._nodes.pop(), this;
      throw new Error(`CodeGen: not in block "${c ? `${s.kind}/${c.kind}` : s.kind}"`);
    }
    _elseNode(s) {
      const c = this._currNode;
      if (!(c instanceof f))
        throw new Error('CodeGen: "else" without "if"');
      return this._currNode = c.else = s, this;
    }
    get _root() {
      return this._nodes[0];
    }
    get _currNode() {
      const s = this._nodes;
      return s[s.length - 1];
    }
    set _currNode(s) {
      const c = this._nodes;
      c[c.length - 1] = s;
    }
  }
  e.CodeGen = J;
  function K(v, s) {
    for (const c in s)
      v[c] = (v[c] || 0) + (s[c] || 0);
    return v;
  }
  function re(v, s) {
    return s instanceof t._CodeOrName ? K(v, s.names) : v;
  }
  function ne(v, s, c) {
    if (v instanceof t.Name)
      return T(v);
    if (!F(v))
      return v;
    return new t._Code(v._items.reduce((M, q) => (q instanceof t.Name && (q = T(q)), q instanceof t._Code ? M.push(...q._items) : M.push(q), M), []));
    function T(M) {
      const q = c[M.str];
      return q === void 0 || s[M.str] !== 1 ? M : (delete s[M.str], q);
    }
    function F(M) {
      return M instanceof t._Code && M._items.some((q) => q instanceof t.Name && s[q.str] === 1 && c[q.str] !== void 0);
    }
  }
  function ve(v, s) {
    for (const c in s)
      v[c] = (v[c] || 0) - (s[c] || 0);
  }
  function je(v) {
    return typeof v == "boolean" || typeof v == "number" || v === null ? !v : (0, t._)`!${b(v)}`;
  }
  e.not = je;
  const He = E(e.operators.AND);
  function Xe(...v) {
    return v.reduce(He);
  }
  e.and = Xe;
  const Ie = E(e.operators.OR);
  function U(...v) {
    return v.reduce(Ie);
  }
  e.or = U;
  function E(v) {
    return (s, c) => s === t.nil ? c : c === t.nil ? s : (0, t._)`${b(s)} ${v} ${b(c)}`;
  }
  function b(v) {
    return v instanceof t.Name ? v : (0, t._)`(${v})`;
  }
})(X);
var ee = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.checkStrictMode = e.getErrorPath = e.Type = e.useFunc = e.setEvaluated = e.evaluatedPropsToName = e.mergeEvaluated = e.eachItem = e.unescapeJsonPointer = e.escapeJsonPointer = e.escapeFragment = e.unescapeFragment = e.schemaRefOrVal = e.schemaHasRulesButRef = e.schemaHasRules = e.checkUnknownRules = e.alwaysValidSchema = e.toHash = void 0;
  const t = X, r = vt;
  function a(w) {
    const N = {};
    for (const I of w)
      N[I] = !0;
    return N;
  }
  e.toHash = a;
  function n(w, N) {
    return typeof N == "boolean" ? N : Object.keys(N).length === 0 ? !0 : (i(w, N), !u(N, w.self.RULES.all));
  }
  e.alwaysValidSchema = n;
  function i(w, N = w.schema) {
    const { opts: I, self: A } = w;
    if (!I.strictSchema || typeof N == "boolean")
      return;
    const z = A.RULES.keywords;
    for (const J in N)
      z[J] || V(w, `unknown keyword: "${J}"`);
  }
  e.checkUnknownRules = i;
  function u(w, N) {
    if (typeof w == "boolean")
      return !w;
    for (const I in w)
      if (N[I])
        return !0;
    return !1;
  }
  e.schemaHasRules = u;
  function m(w, N) {
    if (typeof w == "boolean")
      return !w;
    for (const I in w)
      if (I !== "$ref" && N.all[I])
        return !0;
    return !1;
  }
  e.schemaHasRulesButRef = m;
  function y({ topSchemaRef: w, schemaPath: N }, I, A, z) {
    if (!z) {
      if (typeof I == "number" || typeof I == "boolean")
        return I;
      if (typeof I == "string")
        return (0, t._)`${I}`;
    }
    return (0, t._)`${w}${N}${(0, t.getProperty)(A)}`;
  }
  e.schemaRefOrVal = y;
  function l(w) {
    return D(decodeURIComponent(w));
  }
  e.unescapeFragment = l;
  function p(w) {
    return encodeURIComponent(_(w));
  }
  e.escapeFragment = p;
  function _(w) {
    return typeof w == "number" ? `${w}` : w.replace(/~/g, "~0").replace(/\//g, "~1");
  }
  e.escapeJsonPointer = _;
  function D(w) {
    return w.replace(/~1/g, "/").replace(/~0/g, "~");
  }
  e.unescapeJsonPointer = D;
  function k(w, N) {
    if (Array.isArray(w))
      for (const I of w)
        N(I);
    else
      N(w);
  }
  e.eachItem = k;
  function S({ mergeNames: w, mergeToName: N, mergeValues: I, resultToName: A }) {
    return (z, J, K, re) => {
      const ne = K === void 0 ? J : K instanceof t.Name ? (J instanceof t.Name ? w(z, J, K) : N(z, J, K), K) : J instanceof t.Name ? (N(z, K, J), J) : I(J, K);
      return re === t.Name && !(ne instanceof t.Name) ? A(z, ne) : ne;
    };
  }
  e.mergeEvaluated = {
    props: S({
      mergeNames: (w, N, I) => w.if((0, t._)`${I} !== true && ${N} !== undefined`, () => {
        w.if((0, t._)`${N} === true`, () => w.assign(I, !0), () => w.assign(I, (0, t._)`${I} || {}`).code((0, t._)`Object.assign(${I}, ${N})`));
      }),
      mergeToName: (w, N, I) => w.if((0, t._)`${I} !== true`, () => {
        N === !0 ? w.assign(I, !0) : (w.assign(I, (0, t._)`${I} || {}`), g(w, I, N));
      }),
      mergeValues: (w, N) => w === !0 ? !0 : { ...w, ...N },
      resultToName: P
    }),
    items: S({
      mergeNames: (w, N, I) => w.if((0, t._)`${I} !== true && ${N} !== undefined`, () => w.assign(I, (0, t._)`${N} === true ? true : ${I} > ${N} ? ${I} : ${N}`)),
      mergeToName: (w, N, I) => w.if((0, t._)`${I} !== true`, () => w.assign(I, N === !0 ? !0 : (0, t._)`${I} > ${N} ? ${I} : ${N}`)),
      mergeValues: (w, N) => w === !0 ? !0 : Math.max(w, N),
      resultToName: (w, N) => w.var("items", N)
    })
  };
  function P(w, N) {
    if (N === !0)
      return w.var("props", !0);
    const I = w.var("props", (0, t._)`{}`);
    return N !== void 0 && g(w, I, N), I;
  }
  e.evaluatedPropsToName = P;
  function g(w, N, I) {
    Object.keys(I).forEach((A) => w.assign((0, t._)`${N}${(0, t.getProperty)(A)}`, !0));
  }
  e.setEvaluated = g;
  const f = {};
  function h(w, N) {
    return w.scopeValue("func", {
      ref: N,
      code: f[N.code] || (f[N.code] = new r._Code(N.code))
    });
  }
  e.useFunc = h;
  var O;
  (function(w) {
    w[w.Num = 0] = "Num", w[w.Str = 1] = "Str";
  })(O = e.Type || (e.Type = {}));
  function j(w, N, I) {
    if (w instanceof t.Name) {
      const A = N === O.Num;
      return I ? A ? (0, t._)`"[" + ${w} + "]"` : (0, t._)`"['" + ${w} + "']"` : A ? (0, t._)`"/" + ${w}` : (0, t._)`"/" + ${w}.replace(/~/g, "~0").replace(/\\//g, "~1")`;
    }
    return I ? (0, t.getProperty)(w).toString() : "/" + _(w);
  }
  e.getErrorPath = j;
  function V(w, N, I = w.opts.strictSchema) {
    if (I) {
      if (N = `strict mode: ${N}`, I === !0)
        throw new Error(N);
      w.self.logger.warn(N);
    }
  }
  e.checkStrictMode = V;
})(ee);
var Re = {};
Object.defineProperty(Re, "__esModule", { value: !0 });
const $e = X, Za = {
  // validation function arguments
  data: new $e.Name("data"),
  // args passed from referencing schema
  valCxt: new $e.Name("valCxt"),
  instancePath: new $e.Name("instancePath"),
  parentData: new $e.Name("parentData"),
  parentDataProperty: new $e.Name("parentDataProperty"),
  rootData: new $e.Name("rootData"),
  dynamicAnchors: new $e.Name("dynamicAnchors"),
  // function scoped variables
  vErrors: new $e.Name("vErrors"),
  errors: new $e.Name("errors"),
  this: new $e.Name("this"),
  // "globals"
  self: new $e.Name("self"),
  scope: new $e.Name("scope"),
  // JTD serialize/parse name for JSON string and position
  json: new $e.Name("json"),
  jsonPos: new $e.Name("jsonPos"),
  jsonLen: new $e.Name("jsonLen"),
  jsonPart: new $e.Name("jsonPart")
};
Re.default = Za;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.extendErrors = e.resetErrorsCount = e.reportExtraError = e.reportError = e.keyword$DataError = e.keywordError = void 0;
  const t = X, r = ee, a = Re;
  e.keywordError = {
    message: ({ keyword: g }) => (0, t.str)`must pass "${g}" keyword validation`
  }, e.keyword$DataError = {
    message: ({ keyword: g, schemaType: f }) => f ? (0, t.str)`"${g}" keyword must be ${f} ($data)` : (0, t.str)`"${g}" keyword is invalid ($data)`
  };
  function n(g, f = e.keywordError, h, O) {
    const { it: j } = g, { gen: V, compositeRule: w, allErrors: N } = j, I = _(g, f, h);
    O ?? (w || N) ? y(V, I) : l(j, (0, t._)`[${I}]`);
  }
  e.reportError = n;
  function i(g, f = e.keywordError, h) {
    const { it: O } = g, { gen: j, compositeRule: V, allErrors: w } = O, N = _(g, f, h);
    y(j, N), V || w || l(O, a.default.vErrors);
  }
  e.reportExtraError = i;
  function u(g, f) {
    g.assign(a.default.errors, f), g.if((0, t._)`${a.default.vErrors} !== null`, () => g.if(f, () => g.assign((0, t._)`${a.default.vErrors}.length`, f), () => g.assign(a.default.vErrors, null)));
  }
  e.resetErrorsCount = u;
  function m({ gen: g, keyword: f, schemaValue: h, data: O, errsCount: j, it: V }) {
    if (j === void 0)
      throw new Error("ajv implementation error");
    const w = g.name("err");
    g.forRange("i", j, a.default.errors, (N) => {
      g.const(w, (0, t._)`${a.default.vErrors}[${N}]`), g.if((0, t._)`${w}.instancePath === undefined`, () => g.assign((0, t._)`${w}.instancePath`, (0, t.strConcat)(a.default.instancePath, V.errorPath))), g.assign((0, t._)`${w}.schemaPath`, (0, t.str)`${V.errSchemaPath}/${f}`), V.opts.verbose && (g.assign((0, t._)`${w}.schema`, h), g.assign((0, t._)`${w}.data`, O));
    });
  }
  e.extendErrors = m;
  function y(g, f) {
    const h = g.const("err", f);
    g.if((0, t._)`${a.default.vErrors} === null`, () => g.assign(a.default.vErrors, (0, t._)`[${h}]`), (0, t._)`${a.default.vErrors}.push(${h})`), g.code((0, t._)`${a.default.errors}++`);
  }
  function l(g, f) {
    const { gen: h, validateName: O, schemaEnv: j } = g;
    j.$async ? h.throw((0, t._)`new ${g.ValidationError}(${f})`) : (h.assign((0, t._)`${O}.errors`, f), h.return(!1));
  }
  const p = {
    keyword: new t.Name("keyword"),
    schemaPath: new t.Name("schemaPath"),
    params: new t.Name("params"),
    propertyName: new t.Name("propertyName"),
    message: new t.Name("message"),
    schema: new t.Name("schema"),
    parentSchema: new t.Name("parentSchema")
  };
  function _(g, f, h) {
    const { createErrors: O } = g.it;
    return O === !1 ? (0, t._)`{}` : D(g, f, h);
  }
  function D(g, f, h = {}) {
    const { gen: O, it: j } = g, V = [
      k(j, h),
      S(g, h)
    ];
    return P(g, f, V), O.object(...V);
  }
  function k({ errorPath: g }, { instancePath: f }) {
    const h = f ? (0, t.str)`${g}${(0, r.getErrorPath)(f, r.Type.Str)}` : g;
    return [a.default.instancePath, (0, t.strConcat)(a.default.instancePath, h)];
  }
  function S({ keyword: g, it: { errSchemaPath: f } }, { schemaPath: h, parentSchema: O }) {
    let j = O ? f : (0, t.str)`${f}/${g}`;
    return h && (j = (0, t.str)`${j}${(0, r.getErrorPath)(h, r.Type.Str)}`), [p.schemaPath, j];
  }
  function P(g, { params: f, message: h }, O) {
    const { keyword: j, data: V, schemaValue: w, it: N } = g, { opts: I, propertyName: A, topSchemaRef: z, schemaPath: J } = N;
    O.push([p.keyword, j], [p.params, typeof f == "function" ? f(g) : f || (0, t._)`{}`]), I.messages && O.push([p.message, typeof h == "function" ? h(g) : h]), I.verbose && O.push([p.schema, w], [p.parentSchema, (0, t._)`${z}${J}`], [a.default.data, V]), A && O.push([p.propertyName, A]);
  }
})(gt);
Object.defineProperty(yt, "__esModule", { value: !0 });
yt.boolOrEmptySchema = yt.topBoolOrEmptySchema = void 0;
const xa = gt, es = X, ts = Re, rs = {
  message: "boolean schema is false"
};
function ns(e) {
  const { gen: t, schema: r, validateName: a } = e;
  r === !1 ? xn(e, !1) : typeof r == "object" && r.$async === !0 ? t.return(ts.default.data) : (t.assign((0, es._)`${a}.errors`, null), t.return(!0));
}
yt.topBoolOrEmptySchema = ns;
function as(e, t) {
  const { gen: r, schema: a } = e;
  a === !1 ? (r.var(t, !1), xn(e)) : r.var(t, !0);
}
yt.boolOrEmptySchema = as;
function xn(e, t) {
  const { gen: r, data: a } = e, n = {
    gen: r,
    keyword: "false schema",
    data: a,
    schema: !1,
    schemaCode: !1,
    schemaValue: !1,
    params: {},
    it: e
  };
  (0, xa.reportError)(n, rs, void 0, t);
}
var qt = {}, st = {};
Object.defineProperty(st, "__esModule", { value: !0 });
st.getRules = st.isJSONType = void 0;
const ss = ["string", "number", "integer", "boolean", "null", "object", "array"], os = new Set(ss);
function is(e) {
  return typeof e == "string" && os.has(e);
}
st.isJSONType = is;
function cs() {
  const e = {
    number: { type: "number", rules: [] },
    string: { type: "string", rules: [] },
    array: { type: "array", rules: [] },
    object: { type: "object", rules: [] }
  };
  return {
    types: { ...e, integer: !0, boolean: !0, null: !0 },
    rules: [{ rules: [] }, e.number, e.string, e.array, e.object],
    post: { rules: [] },
    all: {},
    keywords: {}
  };
}
st.getRules = cs;
var Ke = {};
Object.defineProperty(Ke, "__esModule", { value: !0 });
Ke.shouldUseRule = Ke.shouldUseGroup = Ke.schemaHasRulesForType = void 0;
function us({ schema: e, self: t }, r) {
  const a = t.RULES.types[r];
  return a && a !== !0 && ea(e, a);
}
Ke.schemaHasRulesForType = us;
function ea(e, t) {
  return t.rules.some((r) => ta(e, r));
}
Ke.shouldUseGroup = ea;
function ta(e, t) {
  var r;
  return e[t.keyword] !== void 0 || ((r = t.definition.implements) === null || r === void 0 ? void 0 : r.some((a) => e[a] !== void 0));
}
Ke.shouldUseRule = ta;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.reportTypeError = e.checkDataTypes = e.checkDataType = e.coerceAndCheckDataType = e.getJSONTypes = e.getSchemaTypes = e.DataType = void 0;
  const t = st, r = Ke, a = gt, n = X, i = ee;
  var u;
  (function(O) {
    O[O.Correct = 0] = "Correct", O[O.Wrong = 1] = "Wrong";
  })(u = e.DataType || (e.DataType = {}));
  function m(O) {
    const j = y(O.type);
    if (j.includes("null")) {
      if (O.nullable === !1)
        throw new Error("type: null contradicts nullable: false");
    } else {
      if (!j.length && O.nullable !== void 0)
        throw new Error('"nullable" cannot be used without "type"');
      O.nullable === !0 && j.push("null");
    }
    return j;
  }
  e.getSchemaTypes = m;
  function y(O) {
    const j = Array.isArray(O) ? O : O ? [O] : [];
    if (j.every(t.isJSONType))
      return j;
    throw new Error("type must be JSONType or JSONType[]: " + j.join(","));
  }
  e.getJSONTypes = y;
  function l(O, j) {
    const { gen: V, data: w, opts: N } = O, I = _(j, N.coerceTypes), A = j.length > 0 && !(I.length === 0 && j.length === 1 && (0, r.schemaHasRulesForType)(O, j[0]));
    if (A) {
      const z = P(j, w, N.strictNumbers, u.Wrong);
      V.if(z, () => {
        I.length ? D(O, j, I) : f(O);
      });
    }
    return A;
  }
  e.coerceAndCheckDataType = l;
  const p = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null"]);
  function _(O, j) {
    return j ? O.filter((V) => p.has(V) || j === "array" && V === "array") : [];
  }
  function D(O, j, V) {
    const { gen: w, data: N, opts: I } = O, A = w.let("dataType", (0, n._)`typeof ${N}`), z = w.let("coerced", (0, n._)`undefined`);
    I.coerceTypes === "array" && w.if((0, n._)`${A} == 'object' && Array.isArray(${N}) && ${N}.length == 1`, () => w.assign(N, (0, n._)`${N}[0]`).assign(A, (0, n._)`typeof ${N}`).if(P(j, N, I.strictNumbers), () => w.assign(z, N))), w.if((0, n._)`${z} !== undefined`);
    for (const K of V)
      (p.has(K) || K === "array" && I.coerceTypes === "array") && J(K);
    w.else(), f(O), w.endIf(), w.if((0, n._)`${z} !== undefined`, () => {
      w.assign(N, z), k(O, z);
    });
    function J(K) {
      switch (K) {
        case "string":
          w.elseIf((0, n._)`${A} == "number" || ${A} == "boolean"`).assign(z, (0, n._)`"" + ${N}`).elseIf((0, n._)`${N} === null`).assign(z, (0, n._)`""`);
          return;
        case "number":
          w.elseIf((0, n._)`${A} == "boolean" || ${N} === null
              || (${A} == "string" && ${N} && ${N} == +${N})`).assign(z, (0, n._)`+${N}`);
          return;
        case "integer":
          w.elseIf((0, n._)`${A} === "boolean" || ${N} === null
              || (${A} === "string" && ${N} && ${N} == +${N} && !(${N} % 1))`).assign(z, (0, n._)`+${N}`);
          return;
        case "boolean":
          w.elseIf((0, n._)`${N} === "false" || ${N} === 0 || ${N} === null`).assign(z, !1).elseIf((0, n._)`${N} === "true" || ${N} === 1`).assign(z, !0);
          return;
        case "null":
          w.elseIf((0, n._)`${N} === "" || ${N} === 0 || ${N} === false`), w.assign(z, null);
          return;
        case "array":
          w.elseIf((0, n._)`${A} === "string" || ${A} === "number"
              || ${A} === "boolean" || ${N} === null`).assign(z, (0, n._)`[${N}]`);
      }
    }
  }
  function k({ gen: O, parentData: j, parentDataProperty: V }, w) {
    O.if((0, n._)`${j} !== undefined`, () => O.assign((0, n._)`${j}[${V}]`, w));
  }
  function S(O, j, V, w = u.Correct) {
    const N = w === u.Correct ? n.operators.EQ : n.operators.NEQ;
    let I;
    switch (O) {
      case "null":
        return (0, n._)`${j} ${N} null`;
      case "array":
        I = (0, n._)`Array.isArray(${j})`;
        break;
      case "object":
        I = (0, n._)`${j} && typeof ${j} == "object" && !Array.isArray(${j})`;
        break;
      case "integer":
        I = A((0, n._)`!(${j} % 1) && !isNaN(${j})`);
        break;
      case "number":
        I = A();
        break;
      default:
        return (0, n._)`typeof ${j} ${N} ${O}`;
    }
    return w === u.Correct ? I : (0, n.not)(I);
    function A(z = n.nil) {
      return (0, n.and)((0, n._)`typeof ${j} == "number"`, z, V ? (0, n._)`isFinite(${j})` : n.nil);
    }
  }
  e.checkDataType = S;
  function P(O, j, V, w) {
    if (O.length === 1)
      return S(O[0], j, V, w);
    let N;
    const I = (0, i.toHash)(O);
    if (I.array && I.object) {
      const A = (0, n._)`typeof ${j} != "object"`;
      N = I.null ? A : (0, n._)`!${j} || ${A}`, delete I.null, delete I.array, delete I.object;
    } else
      N = n.nil;
    I.number && delete I.integer;
    for (const A in I)
      N = (0, n.and)(N, S(A, j, V, w));
    return N;
  }
  e.checkDataTypes = P;
  const g = {
    message: ({ schema: O }) => `must be ${O}`,
    params: ({ schema: O, schemaValue: j }) => typeof O == "string" ? (0, n._)`{type: ${O}}` : (0, n._)`{type: ${j}}`
  };
  function f(O) {
    const j = h(O);
    (0, a.reportError)(j, g);
  }
  e.reportTypeError = f;
  function h(O) {
    const { gen: j, data: V, schema: w } = O, N = (0, i.schemaRefOrVal)(O, w, "type");
    return {
      gen: j,
      keyword: "type",
      data: V,
      schema: w.type,
      schemaCode: N,
      schemaValue: N,
      parentSchema: w,
      params: {},
      it: O
    };
  }
})(qt);
var lr = {};
Object.defineProperty(lr, "__esModule", { value: !0 });
lr.assignDefaults = void 0;
const ht = X, ds = ee;
function ls(e, t) {
  const { properties: r, items: a } = e.schema;
  if (t === "object" && r)
    for (const n in r)
      In(e, n, r[n].default);
  else
    t === "array" && Array.isArray(a) && a.forEach((n, i) => In(e, i, n.default));
}
lr.assignDefaults = ls;
function In(e, t, r) {
  const { gen: a, compositeRule: n, data: i, opts: u } = e;
  if (r === void 0)
    return;
  const m = (0, ht._)`${i}${(0, ht.getProperty)(t)}`;
  if (n) {
    (0, ds.checkStrictMode)(e, `default is ignored for: ${m}`);
    return;
  }
  let y = (0, ht._)`${m} === undefined`;
  u.useDefaults === "empty" && (y = (0, ht._)`${y} || ${m} === null || ${m} === ""`), a.if(y, (0, ht._)`${m} = ${(0, ht.stringify)(r)}`);
}
var Ue = {}, Q = {};
Object.defineProperty(Q, "__esModule", { value: !0 });
Q.validateUnion = Q.validateArray = Q.usePattern = Q.callValidateCode = Q.schemaProperties = Q.allSchemaProperties = Q.noPropertyInData = Q.propertyInData = Q.isOwnProperty = Q.hasPropFunc = Q.reportMissingProp = Q.checkMissingProp = Q.checkReportMissingProp = void 0;
const oe = X, Ir = ee, Je = Re, fs = ee;
function hs(e, t) {
  const { gen: r, data: a, it: n } = e;
  r.if(Dr(r, a, t, n.opts.ownProperties), () => {
    e.setParams({ missingProperty: (0, oe._)`${t}` }, !0), e.error();
  });
}
Q.checkReportMissingProp = hs;
function ms({ gen: e, data: t, it: { opts: r } }, a, n) {
  return (0, oe.or)(...a.map((i) => (0, oe.and)(Dr(e, t, i, r.ownProperties), (0, oe._)`${n} = ${i}`)));
}
Q.checkMissingProp = ms;
function ps(e, t) {
  e.setParams({ missingProperty: t }, !0), e.error();
}
Q.reportMissingProp = ps;
function ra(e) {
  return e.scopeValue("func", {
    // eslint-disable-next-line @typescript-eslint/unbound-method
    ref: Object.prototype.hasOwnProperty,
    code: (0, oe._)`Object.prototype.hasOwnProperty`
  });
}
Q.hasPropFunc = ra;
function kr(e, t, r) {
  return (0, oe._)`${ra(e)}.call(${t}, ${r})`;
}
Q.isOwnProperty = kr;
function $s(e, t, r, a) {
  const n = (0, oe._)`${t}${(0, oe.getProperty)(r)} !== undefined`;
  return a ? (0, oe._)`${n} && ${kr(e, t, r)}` : n;
}
Q.propertyInData = $s;
function Dr(e, t, r, a) {
  const n = (0, oe._)`${t}${(0, oe.getProperty)(r)} === undefined`;
  return a ? (0, oe.or)(n, (0, oe.not)(kr(e, t, r))) : n;
}
Q.noPropertyInData = Dr;
function na(e) {
  return e ? Object.keys(e).filter((t) => t !== "__proto__") : [];
}
Q.allSchemaProperties = na;
function ys(e, t) {
  return na(t).filter((r) => !(0, Ir.alwaysValidSchema)(e, t[r]));
}
Q.schemaProperties = ys;
function vs({ schemaCode: e, data: t, it: { gen: r, topSchemaRef: a, schemaPath: n, errorPath: i }, it: u }, m, y, l) {
  const p = l ? (0, oe._)`${e}, ${t}, ${a}${n}` : t, _ = [
    [Je.default.instancePath, (0, oe.strConcat)(Je.default.instancePath, i)],
    [Je.default.parentData, u.parentData],
    [Je.default.parentDataProperty, u.parentDataProperty],
    [Je.default.rootData, Je.default.rootData]
  ];
  u.opts.dynamicRef && _.push([Je.default.dynamicAnchors, Je.default.dynamicAnchors]);
  const D = (0, oe._)`${p}, ${r.object(..._)}`;
  return y !== oe.nil ? (0, oe._)`${m}.call(${y}, ${D})` : (0, oe._)`${m}(${D})`;
}
Q.callValidateCode = vs;
const _s = (0, oe._)`new RegExp`;
function gs({ gen: e, it: { opts: t } }, r) {
  const a = t.unicodeRegExp ? "u" : "", { regExp: n } = t.code, i = n(r, a);
  return e.scopeValue("pattern", {
    key: i.toString(),
    ref: i,
    code: (0, oe._)`${n.code === "new RegExp" ? _s : (0, fs.useFunc)(e, n)}(${r}, ${a})`
  });
}
Q.usePattern = gs;
function ws(e) {
  const { gen: t, data: r, keyword: a, it: n } = e, i = t.name("valid");
  if (n.allErrors) {
    const m = t.let("valid", !0);
    return u(() => t.assign(m, !1)), m;
  }
  return t.var(i, !0), u(() => t.break()), i;
  function u(m) {
    const y = t.const("len", (0, oe._)`${r}.length`);
    t.forRange("i", 0, y, (l) => {
      e.subschema({
        keyword: a,
        dataProp: l,
        dataPropType: Ir.Type.Num
      }, i), t.if((0, oe.not)(i), m);
    });
  }
}
Q.validateArray = ws;
function Es(e) {
  const { gen: t, schema: r, keyword: a, it: n } = e;
  if (!Array.isArray(r))
    throw new Error("ajv implementation error");
  if (r.some((y) => (0, Ir.alwaysValidSchema)(n, y)) && !n.opts.unevaluated)
    return;
  const u = t.let("valid", !1), m = t.name("_valid");
  t.block(() => r.forEach((y, l) => {
    const p = e.subschema({
      keyword: a,
      schemaProp: l,
      compositeRule: !0
    }, m);
    t.assign(u, (0, oe._)`${u} || ${m}`), e.mergeValidEvaluated(p, m) || t.if((0, oe.not)(u));
  })), e.result(u, () => e.reset(), () => e.error(!0));
}
Q.validateUnion = Es;
Object.defineProperty(Ue, "__esModule", { value: !0 });
Ue.validateKeywordUsage = Ue.validSchemaType = Ue.funcKeywordCode = Ue.macroKeywordCode = void 0;
const ye = X, rt = Re, bs = Q, Ss = gt;
function Ps(e, t) {
  const { gen: r, keyword: a, schema: n, parentSchema: i, it: u } = e, m = t.macro.call(u.self, n, i, u), y = aa(r, a, m);
  u.opts.validateSchema !== !1 && u.self.validateSchema(m, !0);
  const l = r.name("valid");
  e.subschema({
    schema: m,
    schemaPath: ye.nil,
    errSchemaPath: `${u.errSchemaPath}/${a}`,
    topSchemaRef: y,
    compositeRule: !0
  }, l), e.pass(l, () => e.error(!0));
}
Ue.macroKeywordCode = Ps;
function Os(e, t) {
  var r;
  const { gen: a, keyword: n, schema: i, parentSchema: u, $data: m, it: y } = e;
  Ts(y, t);
  const l = !m && t.compile ? t.compile.call(y.self, i, u, y) : t.validate, p = aa(a, n, l), _ = a.let("valid");
  e.block$data(_, D), e.ok((r = t.valid) !== null && r !== void 0 ? r : _);
  function D() {
    if (t.errors === !1)
      P(), t.modifying && kn(e), g(() => e.error());
    else {
      const f = t.async ? k() : S();
      t.modifying && kn(e), g(() => Ns(e, f));
    }
  }
  function k() {
    const f = a.let("ruleErrs", null);
    return a.try(() => P((0, ye._)`await `), (h) => a.assign(_, !1).if((0, ye._)`${h} instanceof ${y.ValidationError}`, () => a.assign(f, (0, ye._)`${h}.errors`), () => a.throw(h))), f;
  }
  function S() {
    const f = (0, ye._)`${p}.errors`;
    return a.assign(f, null), P(ye.nil), f;
  }
  function P(f = t.async ? (0, ye._)`await ` : ye.nil) {
    const h = y.opts.passContext ? rt.default.this : rt.default.self, O = !("compile" in t && !m || t.schema === !1);
    a.assign(_, (0, ye._)`${f}${(0, bs.callValidateCode)(e, p, h, O)}`, t.modifying);
  }
  function g(f) {
    var h;
    a.if((0, ye.not)((h = t.valid) !== null && h !== void 0 ? h : _), f);
  }
}
Ue.funcKeywordCode = Os;
function kn(e) {
  const { gen: t, data: r, it: a } = e;
  t.if(a.parentData, () => t.assign(r, (0, ye._)`${a.parentData}[${a.parentDataProperty}]`));
}
function Ns(e, t) {
  const { gen: r } = e;
  r.if((0, ye._)`Array.isArray(${t})`, () => {
    r.assign(rt.default.vErrors, (0, ye._)`${rt.default.vErrors} === null ? ${t} : ${rt.default.vErrors}.concat(${t})`).assign(rt.default.errors, (0, ye._)`${rt.default.vErrors}.length`), (0, Ss.extendErrors)(e);
  }, () => e.error());
}
function Ts({ schemaEnv: e }, t) {
  if (t.async && !e.$async)
    throw new Error("async keyword in sync schema");
}
function aa(e, t, r) {
  if (r === void 0)
    throw new Error(`keyword "${t}" failed to compile`);
  return e.scopeValue("keyword", typeof r == "function" ? { ref: r } : { ref: r, code: (0, ye.stringify)(r) });
}
function Cs(e, t, r = !1) {
  return !t.length || t.some((a) => a === "array" ? Array.isArray(e) : a === "object" ? e && typeof e == "object" && !Array.isArray(e) : typeof e == a || r && typeof e > "u");
}
Ue.validSchemaType = Cs;
function Rs({ schema: e, opts: t, self: r, errSchemaPath: a }, n, i) {
  if (Array.isArray(n.keyword) ? !n.keyword.includes(i) : n.keyword !== i)
    throw new Error("ajv implementation error");
  const u = n.dependencies;
  if (u != null && u.some((m) => !Object.prototype.hasOwnProperty.call(e, m)))
    throw new Error(`parent schema must have dependencies of ${i}: ${u.join(",")}`);
  if (n.validateSchema && !n.validateSchema(e[i])) {
    const y = `keyword "${i}" value is invalid at path "${a}": ` + r.errorsText(n.validateSchema.errors);
    if (t.validateSchema === "log")
      r.logger.error(y);
    else
      throw new Error(y);
  }
}
Ue.validateKeywordUsage = Rs;
var Ye = {};
Object.defineProperty(Ye, "__esModule", { value: !0 });
Ye.extendSubschemaMode = Ye.extendSubschemaData = Ye.getSubschema = void 0;
const ze = X, sa = ee;
function js(e, { keyword: t, schemaProp: r, schema: a, schemaPath: n, errSchemaPath: i, topSchemaRef: u }) {
  if (t !== void 0 && a !== void 0)
    throw new Error('both "keyword" and "schema" passed, only one allowed');
  if (t !== void 0) {
    const m = e.schema[t];
    return r === void 0 ? {
      schema: m,
      schemaPath: (0, ze._)`${e.schemaPath}${(0, ze.getProperty)(t)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}`
    } : {
      schema: m[r],
      schemaPath: (0, ze._)`${e.schemaPath}${(0, ze.getProperty)(t)}${(0, ze.getProperty)(r)}`,
      errSchemaPath: `${e.errSchemaPath}/${t}/${(0, sa.escapeFragment)(r)}`
    };
  }
  if (a !== void 0) {
    if (n === void 0 || i === void 0 || u === void 0)
      throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');
    return {
      schema: a,
      schemaPath: n,
      topSchemaRef: u,
      errSchemaPath: i
    };
  }
  throw new Error('either "keyword" or "schema" must be passed');
}
Ye.getSubschema = js;
function Is(e, t, { dataProp: r, dataPropType: a, data: n, dataTypes: i, propertyName: u }) {
  if (n !== void 0 && r !== void 0)
    throw new Error('both "data" and "dataProp" passed, only one allowed');
  const { gen: m } = t;
  if (r !== void 0) {
    const { errorPath: l, dataPathArr: p, opts: _ } = t, D = m.let("data", (0, ze._)`${t.data}${(0, ze.getProperty)(r)}`, !0);
    y(D), e.errorPath = (0, ze.str)`${l}${(0, sa.getErrorPath)(r, a, _.jsPropertySyntax)}`, e.parentDataProperty = (0, ze._)`${r}`, e.dataPathArr = [...p, e.parentDataProperty];
  }
  if (n !== void 0) {
    const l = n instanceof ze.Name ? n : m.let("data", n, !0);
    y(l), u !== void 0 && (e.propertyName = u);
  }
  i && (e.dataTypes = i);
  function y(l) {
    e.data = l, e.dataLevel = t.dataLevel + 1, e.dataTypes = [], t.definedProperties = /* @__PURE__ */ new Set(), e.parentData = t.data, e.dataNames = [...t.dataNames, l];
  }
}
Ye.extendSubschemaData = Is;
function ks(e, { jtdDiscriminator: t, jtdMetadata: r, compositeRule: a, createErrors: n, allErrors: i }) {
  a !== void 0 && (e.compositeRule = a), n !== void 0 && (e.createErrors = n), i !== void 0 && (e.allErrors = i), e.jtdDiscriminator = t, e.jtdMetadata = r;
}
Ye.extendSubschemaMode = ks;
var pe = {}, oa = function e(t, r) {
  if (t === r)
    return !0;
  if (t && r && typeof t == "object" && typeof r == "object") {
    if (t.constructor !== r.constructor)
      return !1;
    var a, n, i;
    if (Array.isArray(t)) {
      if (a = t.length, a != r.length)
        return !1;
      for (n = a; n-- !== 0; )
        if (!e(t[n], r[n]))
          return !1;
      return !0;
    }
    if (t.constructor === RegExp)
      return t.source === r.source && t.flags === r.flags;
    if (t.valueOf !== Object.prototype.valueOf)
      return t.valueOf() === r.valueOf();
    if (t.toString !== Object.prototype.toString)
      return t.toString() === r.toString();
    if (i = Object.keys(t), a = i.length, a !== Object.keys(r).length)
      return !1;
    for (n = a; n-- !== 0; )
      if (!Object.prototype.hasOwnProperty.call(r, i[n]))
        return !1;
    for (n = a; n-- !== 0; ) {
      var u = i[n];
      if (!e(t[u], r[u]))
        return !1;
    }
    return !0;
  }
  return t !== t && r !== r;
}, ia = { exports: {} }, Be = ia.exports = function(e, t, r) {
  typeof t == "function" && (r = t, t = {}), r = t.cb || r;
  var a = typeof r == "function" ? r : r.pre || function() {
  }, n = r.post || function() {
  };
  rr(t, a, n, e, "", e);
};
Be.keywords = {
  additionalItems: !0,
  items: !0,
  contains: !0,
  additionalProperties: !0,
  propertyNames: !0,
  not: !0,
  if: !0,
  then: !0,
  else: !0
};
Be.arrayKeywords = {
  items: !0,
  allOf: !0,
  anyOf: !0,
  oneOf: !0
};
Be.propsKeywords = {
  $defs: !0,
  definitions: !0,
  properties: !0,
  patternProperties: !0,
  dependencies: !0
};
Be.skipKeywords = {
  default: !0,
  enum: !0,
  const: !0,
  required: !0,
  maximum: !0,
  minimum: !0,
  exclusiveMaximum: !0,
  exclusiveMinimum: !0,
  multipleOf: !0,
  maxLength: !0,
  minLength: !0,
  pattern: !0,
  format: !0,
  maxItems: !0,
  minItems: !0,
  uniqueItems: !0,
  maxProperties: !0,
  minProperties: !0
};
function rr(e, t, r, a, n, i, u, m, y, l) {
  if (a && typeof a == "object" && !Array.isArray(a)) {
    t(a, n, i, u, m, y, l);
    for (var p in a) {
      var _ = a[p];
      if (Array.isArray(_)) {
        if (p in Be.arrayKeywords)
          for (var D = 0; D < _.length; D++)
            rr(e, t, r, _[D], n + "/" + p + "/" + D, i, n, p, a, D);
      } else if (p in Be.propsKeywords) {
        if (_ && typeof _ == "object")
          for (var k in _)
            rr(e, t, r, _[k], n + "/" + p + "/" + Ds(k), i, n, p, a, k);
      } else
        (p in Be.keywords || e.allKeys && !(p in Be.skipKeywords)) && rr(e, t, r, _, n + "/" + p, i, n, p, a);
    }
    r(a, n, i, u, m, y, l);
  }
}
function Ds(e) {
  return e.replace(/~/g, "~0").replace(/\//g, "~1");
}
var As = ia.exports;
Object.defineProperty(pe, "__esModule", { value: !0 });
pe.getSchemaRefs = pe.resolveUrl = pe.normalizeId = pe._getFullPath = pe.getFullPath = pe.inlineRef = void 0;
const Ms = ee, Vs = oa, Fs = As, zs = /* @__PURE__ */ new Set([
  "type",
  "format",
  "pattern",
  "maxLength",
  "minLength",
  "maxProperties",
  "minProperties",
  "maxItems",
  "minItems",
  "maximum",
  "minimum",
  "uniqueItems",
  "multipleOf",
  "required",
  "enum",
  "const"
]);
function Us(e, t = !0) {
  return typeof e == "boolean" ? !0 : t === !0 ? !Sr(e) : t ? ca(e) <= t : !1;
}
pe.inlineRef = Us;
const qs = /* @__PURE__ */ new Set([
  "$ref",
  "$recursiveRef",
  "$recursiveAnchor",
  "$dynamicRef",
  "$dynamicAnchor"
]);
function Sr(e) {
  for (const t in e) {
    if (qs.has(t))
      return !0;
    const r = e[t];
    if (Array.isArray(r) && r.some(Sr) || typeof r == "object" && Sr(r))
      return !0;
  }
  return !1;
}
function ca(e) {
  let t = 0;
  for (const r in e) {
    if (r === "$ref")
      return 1 / 0;
    if (t++, !zs.has(r) && (typeof e[r] == "object" && (0, Ms.eachItem)(e[r], (a) => t += ca(a)), t === 1 / 0))
      return 1 / 0;
  }
  return t;
}
function ua(e, t = "", r) {
  r !== !1 && (t = $t(t));
  const a = e.parse(t);
  return da(e, a);
}
pe.getFullPath = ua;
function da(e, t) {
  return e.serialize(t).split("#")[0] + "#";
}
pe._getFullPath = da;
const Ks = /#\/?$/;
function $t(e) {
  return e ? e.replace(Ks, "") : "";
}
pe.normalizeId = $t;
function Ls(e, t, r) {
  return r = $t(r), e.resolve(t, r);
}
pe.resolveUrl = Ls;
const Hs = /^[a-z_][-a-z0-9._]*$/i;
function Gs(e, t) {
  if (typeof e == "boolean")
    return {};
  const { schemaId: r, uriResolver: a } = this.opts, n = $t(e[r] || t), i = { "": n }, u = ua(a, n, !1), m = {}, y = /* @__PURE__ */ new Set();
  return Fs(e, { allKeys: !0 }, (_, D, k, S) => {
    if (S === void 0)
      return;
    const P = u + D;
    let g = i[S];
    typeof _[r] == "string" && (g = f.call(this, _[r])), h.call(this, _.$anchor), h.call(this, _.$dynamicAnchor), i[D] = g;
    function f(O) {
      const j = this.opts.uriResolver.resolve;
      if (O = $t(g ? j(g, O) : O), y.has(O))
        throw p(O);
      y.add(O);
      let V = this.refs[O];
      return typeof V == "string" && (V = this.refs[V]), typeof V == "object" ? l(_, V.schema, O) : O !== $t(P) && (O[0] === "#" ? (l(_, m[O], O), m[O] = _) : this.refs[O] = P), O;
    }
    function h(O) {
      if (typeof O == "string") {
        if (!Hs.test(O))
          throw new Error(`invalid anchor "${O}"`);
        f.call(this, `#${O}`);
      }
    }
  }), m;
  function l(_, D, k) {
    if (D !== void 0 && !Vs(_, D))
      throw p(k);
  }
  function p(_) {
    return new Error(`reference "${_}" resolves to more than one schema`);
  }
}
pe.getSchemaRefs = Gs;
Object.defineProperty(Oe, "__esModule", { value: !0 });
Oe.getData = Oe.KeywordCxt = Oe.validateFunctionCode = void 0;
const la = yt, Dn = qt, Ar = Ke, or = qt, Js = lr, Mt = Ue, $r = Ye, L = X, B = Re, Ws = pe, Le = ee, kt = gt;
function Bs(e) {
  if (ma(e) && (pa(e), ha(e))) {
    Qs(e);
    return;
  }
  fa(e, () => (0, la.topBoolOrEmptySchema)(e));
}
Oe.validateFunctionCode = Bs;
function fa({ gen: e, validateName: t, schema: r, schemaEnv: a, opts: n }, i) {
  n.code.es5 ? e.func(t, (0, L._)`${B.default.data}, ${B.default.valCxt}`, a.$async, () => {
    e.code((0, L._)`"use strict"; ${An(r, n)}`), Xs(e, n), e.code(i);
  }) : e.func(t, (0, L._)`${B.default.data}, ${Ys(n)}`, a.$async, () => e.code(An(r, n)).code(i));
}
function Ys(e) {
  return (0, L._)`{${B.default.instancePath}="", ${B.default.parentData}, ${B.default.parentDataProperty}, ${B.default.rootData}=${B.default.data}${e.dynamicRef ? (0, L._)`, ${B.default.dynamicAnchors}={}` : L.nil}}={}`;
}
function Xs(e, t) {
  e.if(B.default.valCxt, () => {
    e.var(B.default.instancePath, (0, L._)`${B.default.valCxt}.${B.default.instancePath}`), e.var(B.default.parentData, (0, L._)`${B.default.valCxt}.${B.default.parentData}`), e.var(B.default.parentDataProperty, (0, L._)`${B.default.valCxt}.${B.default.parentDataProperty}`), e.var(B.default.rootData, (0, L._)`${B.default.valCxt}.${B.default.rootData}`), t.dynamicRef && e.var(B.default.dynamicAnchors, (0, L._)`${B.default.valCxt}.${B.default.dynamicAnchors}`);
  }, () => {
    e.var(B.default.instancePath, (0, L._)`""`), e.var(B.default.parentData, (0, L._)`undefined`), e.var(B.default.parentDataProperty, (0, L._)`undefined`), e.var(B.default.rootData, B.default.data), t.dynamicRef && e.var(B.default.dynamicAnchors, (0, L._)`{}`);
  });
}
function Qs(e) {
  const { schema: t, opts: r, gen: a } = e;
  fa(e, () => {
    r.$comment && t.$comment && ya(e), ro(e), a.let(B.default.vErrors, null), a.let(B.default.errors, 0), r.unevaluated && Zs(e), $a(e), so(e);
  });
}
function Zs(e) {
  const { gen: t, validateName: r } = e;
  e.evaluated = t.const("evaluated", (0, L._)`${r}.evaluated`), t.if((0, L._)`${e.evaluated}.dynamicProps`, () => t.assign((0, L._)`${e.evaluated}.props`, (0, L._)`undefined`)), t.if((0, L._)`${e.evaluated}.dynamicItems`, () => t.assign((0, L._)`${e.evaluated}.items`, (0, L._)`undefined`));
}
function An(e, t) {
  const r = typeof e == "object" && e[t.schemaId];
  return r && (t.code.source || t.code.process) ? (0, L._)`/*# sourceURL=${r} */` : L.nil;
}
function xs(e, t) {
  if (ma(e) && (pa(e), ha(e))) {
    eo(e, t);
    return;
  }
  (0, la.boolOrEmptySchema)(e, t);
}
function ha({ schema: e, self: t }) {
  if (typeof e == "boolean")
    return !e;
  for (const r in e)
    if (t.RULES.all[r])
      return !0;
  return !1;
}
function ma(e) {
  return typeof e.schema != "boolean";
}
function eo(e, t) {
  const { schema: r, gen: a, opts: n } = e;
  n.$comment && r.$comment && ya(e), no(e), ao(e);
  const i = a.const("_errs", B.default.errors);
  $a(e, i), a.var(t, (0, L._)`${i} === ${B.default.errors}`);
}
function pa(e) {
  (0, Le.checkUnknownRules)(e), to(e);
}
function $a(e, t) {
  if (e.opts.jtd)
    return Mn(e, [], !1, t);
  const r = (0, Dn.getSchemaTypes)(e.schema), a = (0, Dn.coerceAndCheckDataType)(e, r);
  Mn(e, r, !a, t);
}
function to(e) {
  const { schema: t, errSchemaPath: r, opts: a, self: n } = e;
  t.$ref && a.ignoreKeywordsWithRef && (0, Le.schemaHasRulesButRef)(t, n.RULES) && n.logger.warn(`$ref: keywords ignored in schema at path "${r}"`);
}
function ro(e) {
  const { schema: t, opts: r } = e;
  t.default !== void 0 && r.useDefaults && r.strictSchema && (0, Le.checkStrictMode)(e, "default is ignored in the schema root");
}
function no(e) {
  const t = e.schema[e.opts.schemaId];
  t && (e.baseId = (0, Ws.resolveUrl)(e.opts.uriResolver, e.baseId, t));
}
function ao(e) {
  if (e.schema.$async && !e.schemaEnv.$async)
    throw new Error("async schema in sync schema");
}
function ya({ gen: e, schemaEnv: t, schema: r, errSchemaPath: a, opts: n }) {
  const i = r.$comment;
  if (n.$comment === !0)
    e.code((0, L._)`${B.default.self}.logger.log(${i})`);
  else if (typeof n.$comment == "function") {
    const u = (0, L.str)`${a}/$comment`, m = e.scopeValue("root", { ref: t.root });
    e.code((0, L._)`${B.default.self}.opts.$comment(${i}, ${u}, ${m}.schema)`);
  }
}
function so(e) {
  const { gen: t, schemaEnv: r, validateName: a, ValidationError: n, opts: i } = e;
  r.$async ? t.if((0, L._)`${B.default.errors} === 0`, () => t.return(B.default.data), () => t.throw((0, L._)`new ${n}(${B.default.vErrors})`)) : (t.assign((0, L._)`${a}.errors`, B.default.vErrors), i.unevaluated && oo(e), t.return((0, L._)`${B.default.errors} === 0`));
}
function oo({ gen: e, evaluated: t, props: r, items: a }) {
  r instanceof L.Name && e.assign((0, L._)`${t}.props`, r), a instanceof L.Name && e.assign((0, L._)`${t}.items`, a);
}
function Mn(e, t, r, a) {
  const { gen: n, schema: i, data: u, allErrors: m, opts: y, self: l } = e, { RULES: p } = l;
  if (i.$ref && (y.ignoreKeywordsWithRef || !(0, Le.schemaHasRulesButRef)(i, p))) {
    n.block(() => ga(e, "$ref", p.all.$ref.definition));
    return;
  }
  y.jtd || io(e, t), n.block(() => {
    for (const D of p.rules)
      _(D);
    _(p.post);
  });
  function _(D) {
    (0, Ar.shouldUseGroup)(i, D) && (D.type ? (n.if((0, or.checkDataType)(D.type, u, y.strictNumbers)), Vn(e, D), t.length === 1 && t[0] === D.type && r && (n.else(), (0, or.reportTypeError)(e)), n.endIf()) : Vn(e, D), m || n.if((0, L._)`${B.default.errors} === ${a || 0}`));
  }
}
function Vn(e, t) {
  const { gen: r, schema: a, opts: { useDefaults: n } } = e;
  n && (0, Js.assignDefaults)(e, t.type), r.block(() => {
    for (const i of t.rules)
      (0, Ar.shouldUseRule)(a, i) && ga(e, i.keyword, i.definition, t.type);
  });
}
function io(e, t) {
  e.schemaEnv.meta || !e.opts.strictTypes || (co(e, t), e.opts.allowUnionTypes || uo(e, t), lo(e, e.dataTypes));
}
function co(e, t) {
  if (t.length) {
    if (!e.dataTypes.length) {
      e.dataTypes = t;
      return;
    }
    t.forEach((r) => {
      va(e.dataTypes, r) || Mr(e, `type "${r}" not allowed by context "${e.dataTypes.join(",")}"`);
    }), ho(e, t);
  }
}
function uo(e, t) {
  t.length > 1 && !(t.length === 2 && t.includes("null")) && Mr(e, "use allowUnionTypes to allow union type keyword");
}
function lo(e, t) {
  const r = e.self.RULES.all;
  for (const a in r) {
    const n = r[a];
    if (typeof n == "object" && (0, Ar.shouldUseRule)(e.schema, n)) {
      const { type: i } = n.definition;
      i.length && !i.some((u) => fo(t, u)) && Mr(e, `missing type "${i.join(",")}" for keyword "${a}"`);
    }
  }
}
function fo(e, t) {
  return e.includes(t) || t === "number" && e.includes("integer");
}
function va(e, t) {
  return e.includes(t) || t === "integer" && e.includes("number");
}
function ho(e, t) {
  const r = [];
  for (const a of e.dataTypes)
    va(t, a) ? r.push(a) : t.includes("integer") && a === "number" && r.push("integer");
  e.dataTypes = r;
}
function Mr(e, t) {
  const r = e.schemaEnv.baseId + e.errSchemaPath;
  t += ` at "${r}" (strictTypes)`, (0, Le.checkStrictMode)(e, t, e.opts.strictTypes);
}
class _a {
  constructor(t, r, a) {
    if ((0, Mt.validateKeywordUsage)(t, r, a), this.gen = t.gen, this.allErrors = t.allErrors, this.keyword = a, this.data = t.data, this.schema = t.schema[a], this.$data = r.$data && t.opts.$data && this.schema && this.schema.$data, this.schemaValue = (0, Le.schemaRefOrVal)(t, this.schema, a, this.$data), this.schemaType = r.schemaType, this.parentSchema = t.schema, this.params = {}, this.it = t, this.def = r, this.$data)
      this.schemaCode = t.gen.const("vSchema", wa(this.$data, t));
    else if (this.schemaCode = this.schemaValue, !(0, Mt.validSchemaType)(this.schema, r.schemaType, r.allowUndefined))
      throw new Error(`${a} value must be ${JSON.stringify(r.schemaType)}`);
    ("code" in r ? r.trackErrors : r.errors !== !1) && (this.errsCount = t.gen.const("_errs", B.default.errors));
  }
  result(t, r, a) {
    this.failResult((0, L.not)(t), r, a);
  }
  failResult(t, r, a) {
    this.gen.if(t), a ? a() : this.error(), r ? (this.gen.else(), r(), this.allErrors && this.gen.endIf()) : this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  pass(t, r) {
    this.failResult((0, L.not)(t), void 0, r);
  }
  fail(t) {
    if (t === void 0) {
      this.error(), this.allErrors || this.gen.if(!1);
      return;
    }
    this.gen.if(t), this.error(), this.allErrors ? this.gen.endIf() : this.gen.else();
  }
  fail$data(t) {
    if (!this.$data)
      return this.fail(t);
    const { schemaCode: r } = this;
    this.fail((0, L._)`${r} !== undefined && (${(0, L.or)(this.invalid$data(), t)})`);
  }
  error(t, r, a) {
    if (r) {
      this.setParams(r), this._error(t, a), this.setParams({});
      return;
    }
    this._error(t, a);
  }
  _error(t, r) {
    (t ? kt.reportExtraError : kt.reportError)(this, this.def.error, r);
  }
  $dataError() {
    (0, kt.reportError)(this, this.def.$dataError || kt.keyword$DataError);
  }
  reset() {
    if (this.errsCount === void 0)
      throw new Error('add "trackErrors" to keyword definition');
    (0, kt.resetErrorsCount)(this.gen, this.errsCount);
  }
  ok(t) {
    this.allErrors || this.gen.if(t);
  }
  setParams(t, r) {
    r ? Object.assign(this.params, t) : this.params = t;
  }
  block$data(t, r, a = L.nil) {
    this.gen.block(() => {
      this.check$data(t, a), r();
    });
  }
  check$data(t = L.nil, r = L.nil) {
    if (!this.$data)
      return;
    const { gen: a, schemaCode: n, schemaType: i, def: u } = this;
    a.if((0, L.or)((0, L._)`${n} === undefined`, r)), t !== L.nil && a.assign(t, !0), (i.length || u.validateSchema) && (a.elseIf(this.invalid$data()), this.$dataError(), t !== L.nil && a.assign(t, !1)), a.else();
  }
  invalid$data() {
    const { gen: t, schemaCode: r, schemaType: a, def: n, it: i } = this;
    return (0, L.or)(u(), m());
    function u() {
      if (a.length) {
        if (!(r instanceof L.Name))
          throw new Error("ajv implementation error");
        const y = Array.isArray(a) ? a : [a];
        return (0, L._)`${(0, or.checkDataTypes)(y, r, i.opts.strictNumbers, or.DataType.Wrong)}`;
      }
      return L.nil;
    }
    function m() {
      if (n.validateSchema) {
        const y = t.scopeValue("validate$data", { ref: n.validateSchema });
        return (0, L._)`!${y}(${r})`;
      }
      return L.nil;
    }
  }
  subschema(t, r) {
    const a = (0, $r.getSubschema)(this.it, t);
    (0, $r.extendSubschemaData)(a, this.it, t), (0, $r.extendSubschemaMode)(a, t);
    const n = { ...this.it, ...a, items: void 0, props: void 0 };
    return xs(n, r), n;
  }
  mergeEvaluated(t, r) {
    const { it: a, gen: n } = this;
    a.opts.unevaluated && (a.props !== !0 && t.props !== void 0 && (a.props = Le.mergeEvaluated.props(n, t.props, a.props, r)), a.items !== !0 && t.items !== void 0 && (a.items = Le.mergeEvaluated.items(n, t.items, a.items, r)));
  }
  mergeValidEvaluated(t, r) {
    const { it: a, gen: n } = this;
    if (a.opts.unevaluated && (a.props !== !0 || a.items !== !0))
      return n.if(r, () => this.mergeEvaluated(t, L.Name)), !0;
  }
}
Oe.KeywordCxt = _a;
function ga(e, t, r, a) {
  const n = new _a(e, r, t);
  "code" in r ? r.code(n, a) : n.$data && r.validate ? (0, Mt.funcKeywordCode)(n, r) : "macro" in r ? (0, Mt.macroKeywordCode)(n, r) : (r.compile || r.validate) && (0, Mt.funcKeywordCode)(n, r);
}
const mo = /^\/(?:[^~]|~0|~1)*$/, po = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
function wa(e, { dataLevel: t, dataNames: r, dataPathArr: a }) {
  let n, i;
  if (e === "")
    return B.default.rootData;
  if (e[0] === "/") {
    if (!mo.test(e))
      throw new Error(`Invalid JSON-pointer: ${e}`);
    n = e, i = B.default.rootData;
  } else {
    const l = po.exec(e);
    if (!l)
      throw new Error(`Invalid JSON-pointer: ${e}`);
    const p = +l[1];
    if (n = l[2], n === "#") {
      if (p >= t)
        throw new Error(y("property/index", p));
      return a[t - p];
    }
    if (p > t)
      throw new Error(y("data", p));
    if (i = r[t - p], !n)
      return i;
  }
  let u = i;
  const m = n.split("/");
  for (const l of m)
    l && (i = (0, L._)`${i}${(0, L.getProperty)((0, Le.unescapeJsonPointer)(l))}`, u = (0, L._)`${u} && ${i}`);
  return u;
  function y(l, p) {
    return `Cannot access ${l} ${p} levels up, current level is ${t}`;
  }
}
Oe.getData = wa;
var Kt = {};
Object.defineProperty(Kt, "__esModule", { value: !0 });
class $o extends Error {
  constructor(t) {
    super("validation failed"), this.errors = t, this.ajv = this.validation = !0;
  }
}
Kt.default = $o;
var Lt = {};
Object.defineProperty(Lt, "__esModule", { value: !0 });
const yr = pe;
class yo extends Error {
  constructor(t, r, a, n) {
    super(n || `can't resolve reference ${a} from id ${r}`), this.missingRef = (0, yr.resolveUrl)(t, r, a), this.missingSchema = (0, yr.normalizeId)((0, yr.getFullPath)(t, this.missingRef));
  }
}
Lt.default = yo;
var we = {};
Object.defineProperty(we, "__esModule", { value: !0 });
we.resolveSchema = we.getCompilingSchema = we.resolveRef = we.compileSchema = we.SchemaEnv = void 0;
const Ne = X, vo = Kt, tt = Re, Ce = pe, Fn = ee, _o = Oe;
class fr {
  constructor(t) {
    var r;
    this.refs = {}, this.dynamicAnchors = {};
    let a;
    typeof t.schema == "object" && (a = t.schema), this.schema = t.schema, this.schemaId = t.schemaId, this.root = t.root || this, this.baseId = (r = t.baseId) !== null && r !== void 0 ? r : (0, Ce.normalizeId)(a == null ? void 0 : a[t.schemaId || "$id"]), this.schemaPath = t.schemaPath, this.localRefs = t.localRefs, this.meta = t.meta, this.$async = a == null ? void 0 : a.$async, this.refs = {};
  }
}
we.SchemaEnv = fr;
function Vr(e) {
  const t = Ea.call(this, e);
  if (t)
    return t;
  const r = (0, Ce.getFullPath)(this.opts.uriResolver, e.root.baseId), { es5: a, lines: n } = this.opts.code, { ownProperties: i } = this.opts, u = new Ne.CodeGen(this.scope, { es5: a, lines: n, ownProperties: i });
  let m;
  e.$async && (m = u.scopeValue("Error", {
    ref: vo.default,
    code: (0, Ne._)`require("ajv/dist/runtime/validation_error").default`
  }));
  const y = u.scopeName("validate");
  e.validateName = y;
  const l = {
    gen: u,
    allErrors: this.opts.allErrors,
    data: tt.default.data,
    parentData: tt.default.parentData,
    parentDataProperty: tt.default.parentDataProperty,
    dataNames: [tt.default.data],
    dataPathArr: [Ne.nil],
    dataLevel: 0,
    dataTypes: [],
    definedProperties: /* @__PURE__ */ new Set(),
    topSchemaRef: u.scopeValue("schema", this.opts.code.source === !0 ? { ref: e.schema, code: (0, Ne.stringify)(e.schema) } : { ref: e.schema }),
    validateName: y,
    ValidationError: m,
    schema: e.schema,
    schemaEnv: e,
    rootId: r,
    baseId: e.baseId || r,
    schemaPath: Ne.nil,
    errSchemaPath: e.schemaPath || (this.opts.jtd ? "" : "#"),
    errorPath: (0, Ne._)`""`,
    opts: this.opts,
    self: this
  };
  let p;
  try {
    this._compilations.add(e), (0, _o.validateFunctionCode)(l), u.optimize(this.opts.code.optimize);
    const _ = u.toString();
    p = `${u.scopeRefs(tt.default.scope)}return ${_}`, this.opts.code.process && (p = this.opts.code.process(p, e));
    const k = new Function(`${tt.default.self}`, `${tt.default.scope}`, p)(this, this.scope.get());
    if (this.scope.value(y, { ref: k }), k.errors = null, k.schema = e.schema, k.schemaEnv = e, e.$async && (k.$async = !0), this.opts.code.source === !0 && (k.source = { validateName: y, validateCode: _, scopeValues: u._values }), this.opts.unevaluated) {
      const { props: S, items: P } = l;
      k.evaluated = {
        props: S instanceof Ne.Name ? void 0 : S,
        items: P instanceof Ne.Name ? void 0 : P,
        dynamicProps: S instanceof Ne.Name,
        dynamicItems: P instanceof Ne.Name
      }, k.source && (k.source.evaluated = (0, Ne.stringify)(k.evaluated));
    }
    return e.validate = k, e;
  } catch (_) {
    throw delete e.validate, delete e.validateName, p && this.logger.error("Error compiling schema, function code:", p), _;
  } finally {
    this._compilations.delete(e);
  }
}
we.compileSchema = Vr;
function go(e, t, r) {
  var a;
  r = (0, Ce.resolveUrl)(this.opts.uriResolver, t, r);
  const n = e.refs[r];
  if (n)
    return n;
  let i = bo.call(this, e, r);
  if (i === void 0) {
    const u = (a = e.localRefs) === null || a === void 0 ? void 0 : a[r], { schemaId: m } = this.opts;
    u && (i = new fr({ schema: u, schemaId: m, root: e, baseId: t }));
  }
  if (i !== void 0)
    return e.refs[r] = wo.call(this, i);
}
we.resolveRef = go;
function wo(e) {
  return (0, Ce.inlineRef)(e.schema, this.opts.inlineRefs) ? e.schema : e.validate ? e : Vr.call(this, e);
}
function Ea(e) {
  for (const t of this._compilations)
    if (Eo(t, e))
      return t;
}
we.getCompilingSchema = Ea;
function Eo(e, t) {
  return e.schema === t.schema && e.root === t.root && e.baseId === t.baseId;
}
function bo(e, t) {
  let r;
  for (; typeof (r = this.refs[t]) == "string"; )
    t = r;
  return r || this.schemas[t] || hr.call(this, e, t);
}
function hr(e, t) {
  const r = this.opts.uriResolver.parse(t), a = (0, Ce._getFullPath)(this.opts.uriResolver, r);
  let n = (0, Ce.getFullPath)(this.opts.uriResolver, e.baseId, void 0);
  if (Object.keys(e.schema).length > 0 && a === n)
    return vr.call(this, r, e);
  const i = (0, Ce.normalizeId)(a), u = this.refs[i] || this.schemas[i];
  if (typeof u == "string") {
    const m = hr.call(this, e, u);
    return typeof (m == null ? void 0 : m.schema) != "object" ? void 0 : vr.call(this, r, m);
  }
  if (typeof (u == null ? void 0 : u.schema) == "object") {
    if (u.validate || Vr.call(this, u), i === (0, Ce.normalizeId)(t)) {
      const { schema: m } = u, { schemaId: y } = this.opts, l = m[y];
      return l && (n = (0, Ce.resolveUrl)(this.opts.uriResolver, n, l)), new fr({ schema: m, schemaId: y, root: e, baseId: n });
    }
    return vr.call(this, r, u);
  }
}
we.resolveSchema = hr;
const So = /* @__PURE__ */ new Set([
  "properties",
  "patternProperties",
  "enum",
  "dependencies",
  "definitions"
]);
function vr(e, { baseId: t, schema: r, root: a }) {
  var n;
  if (((n = e.fragment) === null || n === void 0 ? void 0 : n[0]) !== "/")
    return;
  for (const m of e.fragment.slice(1).split("/")) {
    if (typeof r == "boolean")
      return;
    const y = r[(0, Fn.unescapeFragment)(m)];
    if (y === void 0)
      return;
    r = y;
    const l = typeof r == "object" && r[this.opts.schemaId];
    !So.has(m) && l && (t = (0, Ce.resolveUrl)(this.opts.uriResolver, t, l));
  }
  let i;
  if (typeof r != "boolean" && r.$ref && !(0, Fn.schemaHasRulesButRef)(r, this.RULES)) {
    const m = (0, Ce.resolveUrl)(this.opts.uriResolver, t, r.$ref);
    i = hr.call(this, a, m);
  }
  const { schemaId: u } = this.opts;
  if (i = i || new fr({ schema: r, schemaId: u, root: a, baseId: t }), i.schema !== i.root.schema)
    return i;
}
const Po = "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#", Oo = "Meta-schema for $data reference (JSON AnySchema extension proposal)", No = "object", To = [
  "$data"
], Co = {
  $data: {
    type: "string",
    anyOf: [
      {
        format: "relative-json-pointer"
      },
      {
        format: "json-pointer"
      }
    ]
  }
}, Ro = !1, jo = {
  $id: Po,
  description: Oo,
  type: No,
  required: To,
  properties: Co,
  additionalProperties: Ro
};
var Fr = {}, Pr = { exports: {} };
/** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js */
(function(e, t) {
  (function(r, a) {
    a(t);
  })(Qa, function(r) {
    function a() {
      for (var d = arguments.length, o = Array(d), $ = 0; $ < d; $++)
        o[$] = arguments[$];
      if (o.length > 1) {
        o[0] = o[0].slice(0, -1);
        for (var R = o.length - 1, C = 1; C < R; ++C)
          o[C] = o[C].slice(1, -1);
        return o[R] = o[R].slice(1), o.join("");
      } else
        return o[0];
    }
    function n(d) {
      return "(?:" + d + ")";
    }
    function i(d) {
      return d === void 0 ? "undefined" : d === null ? "null" : Object.prototype.toString.call(d).split(" ").pop().split("]").shift().toLowerCase();
    }
    function u(d) {
      return d.toUpperCase();
    }
    function m(d) {
      return d != null ? d instanceof Array ? d : typeof d.length != "number" || d.split || d.setInterval || d.call ? [d] : Array.prototype.slice.call(d) : [];
    }
    function y(d, o) {
      var $ = d;
      if (o)
        for (var R in o)
          $[R] = o[R];
      return $;
    }
    function l(d) {
      var o = "[A-Za-z]", $ = "[0-9]", R = a($, "[A-Fa-f]"), C = n(n("%[EFef]" + R + "%" + R + R + "%" + R + R) + "|" + n("%[89A-Fa-f]" + R + "%" + R + R) + "|" + n("%" + R + R)), H = "[\\:\\/\\?\\#\\[\\]\\@]", G = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]", x = a(H, G), se = d ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]", de = d ? "[\\uE000-\\uF8FF]" : "[]", Z = a(o, $, "[\\-\\.\\_\\~]", se);
      n(o + a(o, $, "[\\+\\-\\.]") + "*"), n(n(C + "|" + a(Z, G, "[\\:]")) + "*");
      var ae = n(n("25[0-5]") + "|" + n("2[0-4]" + $) + "|" + n("1" + $ + $) + "|" + n("0?[1-9]" + $) + "|0?0?" + $), le = n(ae + "\\." + ae + "\\." + ae + "\\." + ae), Y = n(R + "{1,4}"), ce = n(n(Y + "\\:" + Y) + "|" + le), he = n(n(Y + "\\:") + "{6}" + ce), ue = n("\\:\\:" + n(Y + "\\:") + "{5}" + ce), Ge = n(n(Y) + "?\\:\\:" + n(Y + "\\:") + "{4}" + ce), Me = n(n(n(Y + "\\:") + "{0,1}" + Y) + "?\\:\\:" + n(Y + "\\:") + "{3}" + ce), Ve = n(n(n(Y + "\\:") + "{0,2}" + Y) + "?\\:\\:" + n(Y + "\\:") + "{2}" + ce), ft = n(n(n(Y + "\\:") + "{0,3}" + Y) + "?\\:\\:" + Y + "\\:" + ce), xe = n(n(n(Y + "\\:") + "{0,4}" + Y) + "?\\:\\:" + ce), Se = n(n(n(Y + "\\:") + "{0,5}" + Y) + "?\\:\\:" + Y), Fe = n(n(n(Y + "\\:") + "{0,6}" + Y) + "?\\:\\:"), et = n([he, ue, Ge, Me, Ve, ft, xe, Se, Fe].join("|")), qe = n(n(Z + "|" + C) + "+");
      n("[vV]" + R + "+\\." + a(Z, G, "[\\:]") + "+"), n(n(C + "|" + a(Z, G)) + "*");
      var Rt = n(C + "|" + a(Z, G, "[\\:\\@]"));
      return n(n(C + "|" + a(Z, G, "[\\@]")) + "+"), n(n(Rt + "|" + a("[\\/\\?]", de)) + "*"), {
        NOT_SCHEME: new RegExp(a("[^]", o, $, "[\\+\\-\\.]"), "g"),
        NOT_USERINFO: new RegExp(a("[^\\%\\:]", Z, G), "g"),
        NOT_HOST: new RegExp(a("[^\\%\\[\\]\\:]", Z, G), "g"),
        NOT_PATH: new RegExp(a("[^\\%\\/\\:\\@]", Z, G), "g"),
        NOT_PATH_NOSCHEME: new RegExp(a("[^\\%\\/\\@]", Z, G), "g"),
        NOT_QUERY: new RegExp(a("[^\\%]", Z, G, "[\\:\\@\\/\\?]", de), "g"),
        NOT_FRAGMENT: new RegExp(a("[^\\%]", Z, G, "[\\:\\@\\/\\?]"), "g"),
        ESCAPE: new RegExp(a("[^]", Z, G), "g"),
        UNRESERVED: new RegExp(Z, "g"),
        OTHER_CHARS: new RegExp(a("[^\\%]", Z, x), "g"),
        PCT_ENCODED: new RegExp(C, "g"),
        IPV4ADDRESS: new RegExp("^(" + le + ")$"),
        IPV6ADDRESS: new RegExp("^\\[?(" + et + ")" + n(n("\\%25|\\%(?!" + R + "{2})") + "(" + qe + ")") + "?\\]?$")
        //RFC 6874, with relaxed parsing rules
      };
    }
    var p = l(!1), _ = l(!0), D = /* @__PURE__ */ function() {
      function d(o, $) {
        var R = [], C = !0, H = !1, G = void 0;
        try {
          for (var x = o[Symbol.iterator](), se; !(C = (se = x.next()).done) && (R.push(se.value), !($ && R.length === $)); C = !0)
            ;
        } catch (de) {
          H = !0, G = de;
        } finally {
          try {
            !C && x.return && x.return();
          } finally {
            if (H)
              throw G;
          }
        }
        return R;
      }
      return function(o, $) {
        if (Array.isArray(o))
          return o;
        if (Symbol.iterator in Object(o))
          return d(o, $);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }(), k = function(d) {
      if (Array.isArray(d)) {
        for (var o = 0, $ = Array(d.length); o < d.length; o++)
          $[o] = d[o];
        return $;
      } else
        return Array.from(d);
    }, S = 2147483647, P = 36, g = 1, f = 26, h = 38, O = 700, j = 72, V = 128, w = "-", N = /^xn--/, I = /[^\0-\x7E]/, A = /[\x2E\u3002\uFF0E\uFF61]/g, z = {
      overflow: "Overflow: input needs wider integers to process",
      "not-basic": "Illegal input >= 0x80 (not a basic code point)",
      "invalid-input": "Invalid input"
    }, J = P - g, K = Math.floor, re = String.fromCharCode;
    function ne(d) {
      throw new RangeError(z[d]);
    }
    function ve(d, o) {
      for (var $ = [], R = d.length; R--; )
        $[R] = o(d[R]);
      return $;
    }
    function je(d, o) {
      var $ = d.split("@"), R = "";
      $.length > 1 && (R = $[0] + "@", d = $[1]), d = d.replace(A, ".");
      var C = d.split("."), H = ve(C, o).join(".");
      return R + H;
    }
    function He(d) {
      for (var o = [], $ = 0, R = d.length; $ < R; ) {
        var C = d.charCodeAt($++);
        if (C >= 55296 && C <= 56319 && $ < R) {
          var H = d.charCodeAt($++);
          (H & 64512) == 56320 ? o.push(((C & 1023) << 10) + (H & 1023) + 65536) : (o.push(C), $--);
        } else
          o.push(C);
      }
      return o;
    }
    var Xe = function(o) {
      return String.fromCodePoint.apply(String, k(o));
    }, Ie = function(o) {
      return o - 48 < 10 ? o - 22 : o - 65 < 26 ? o - 65 : o - 97 < 26 ? o - 97 : P;
    }, U = function(o, $) {
      return o + 22 + 75 * (o < 26) - (($ != 0) << 5);
    }, E = function(o, $, R) {
      var C = 0;
      for (
        o = R ? K(o / O) : o >> 1, o += K(o / $);
        /* no initialization */
        o > J * f >> 1;
        C += P
      )
        o = K(o / J);
      return K(C + (J + 1) * o / (o + h));
    }, b = function(o) {
      var $ = [], R = o.length, C = 0, H = V, G = j, x = o.lastIndexOf(w);
      x < 0 && (x = 0);
      for (var se = 0; se < x; ++se)
        o.charCodeAt(se) >= 128 && ne("not-basic"), $.push(o.charCodeAt(se));
      for (var de = x > 0 ? x + 1 : 0; de < R; ) {
        for (
          var Z = C, ae = 1, le = P;
          ;
          /* no condition */
          le += P
        ) {
          de >= R && ne("invalid-input");
          var Y = Ie(o.charCodeAt(de++));
          (Y >= P || Y > K((S - C) / ae)) && ne("overflow"), C += Y * ae;
          var ce = le <= G ? g : le >= G + f ? f : le - G;
          if (Y < ce)
            break;
          var he = P - ce;
          ae > K(S / he) && ne("overflow"), ae *= he;
        }
        var ue = $.length + 1;
        G = E(C - Z, ue, Z == 0), K(C / ue) > S - H && ne("overflow"), H += K(C / ue), C %= ue, $.splice(C++, 0, H);
      }
      return String.fromCodePoint.apply(String, $);
    }, v = function(o) {
      var $ = [];
      o = He(o);
      var R = o.length, C = V, H = 0, G = j, x = !0, se = !1, de = void 0;
      try {
        for (var Z = o[Symbol.iterator](), ae; !(x = (ae = Z.next()).done); x = !0) {
          var le = ae.value;
          le < 128 && $.push(re(le));
        }
      } catch (jt) {
        se = !0, de = jt;
      } finally {
        try {
          !x && Z.return && Z.return();
        } finally {
          if (se)
            throw de;
        }
      }
      var Y = $.length, ce = Y;
      for (Y && $.push(w); ce < R; ) {
        var he = S, ue = !0, Ge = !1, Me = void 0;
        try {
          for (var Ve = o[Symbol.iterator](), ft; !(ue = (ft = Ve.next()).done); ue = !0) {
            var xe = ft.value;
            xe >= C && xe < he && (he = xe);
          }
        } catch (jt) {
          Ge = !0, Me = jt;
        } finally {
          try {
            !ue && Ve.return && Ve.return();
          } finally {
            if (Ge)
              throw Me;
          }
        }
        var Se = ce + 1;
        he - C > K((S - H) / Se) && ne("overflow"), H += (he - C) * Se, C = he;
        var Fe = !0, et = !1, qe = void 0;
        try {
          for (var Rt = o[Symbol.iterator](), On; !(Fe = (On = Rt.next()).done); Fe = !0) {
            var Nn = On.value;
            if (Nn < C && ++H > S && ne("overflow"), Nn == C) {
              for (
                var Jt = H, Wt = P;
                ;
                /* no condition */
                Wt += P
              ) {
                var Bt = Wt <= G ? g : Wt >= G + f ? f : Wt - G;
                if (Jt < Bt)
                  break;
                var Tn = Jt - Bt, Cn = P - Bt;
                $.push(re(U(Bt + Tn % Cn, 0))), Jt = K(Tn / Cn);
              }
              $.push(re(U(Jt, 0))), G = E(H, Se, ce == Y), H = 0, ++ce;
            }
          }
        } catch (jt) {
          et = !0, qe = jt;
        } finally {
          try {
            !Fe && Rt.return && Rt.return();
          } finally {
            if (et)
              throw qe;
          }
        }
        ++H, ++C;
      }
      return $.join("");
    }, s = function(o) {
      return je(o, function($) {
        return N.test($) ? b($.slice(4).toLowerCase()) : $;
      });
    }, c = function(o) {
      return je(o, function($) {
        return I.test($) ? "xn--" + v($) : $;
      });
    }, T = {
      /**
       * A string representing the current Punycode.js version number.
       * @memberOf punycode
       * @type String
       */
      version: "2.1.0",
      /**
       * An object of methods to convert from JavaScript's internal character
       * representation (UCS-2) to Unicode code points, and back.
       * @see <https://mathiasbynens.be/notes/javascript-encoding>
       * @memberOf punycode
       * @type Object
       */
      ucs2: {
        decode: He,
        encode: Xe
      },
      decode: b,
      encode: v,
      toASCII: c,
      toUnicode: s
    }, F = {};
    function M(d) {
      var o = d.charCodeAt(0), $ = void 0;
      return o < 16 ? $ = "%0" + o.toString(16).toUpperCase() : o < 128 ? $ = "%" + o.toString(16).toUpperCase() : o < 2048 ? $ = "%" + (o >> 6 | 192).toString(16).toUpperCase() + "%" + (o & 63 | 128).toString(16).toUpperCase() : $ = "%" + (o >> 12 | 224).toString(16).toUpperCase() + "%" + (o >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (o & 63 | 128).toString(16).toUpperCase(), $;
    }
    function q(d) {
      for (var o = "", $ = 0, R = d.length; $ < R; ) {
        var C = parseInt(d.substr($ + 1, 2), 16);
        if (C < 128)
          o += String.fromCharCode(C), $ += 3;
        else if (C >= 194 && C < 224) {
          if (R - $ >= 6) {
            var H = parseInt(d.substr($ + 4, 2), 16);
            o += String.fromCharCode((C & 31) << 6 | H & 63);
          } else
            o += d.substr($, 6);
          $ += 6;
        } else if (C >= 224) {
          if (R - $ >= 9) {
            var G = parseInt(d.substr($ + 4, 2), 16), x = parseInt(d.substr($ + 7, 2), 16);
            o += String.fromCharCode((C & 15) << 12 | (G & 63) << 6 | x & 63);
          } else
            o += d.substr($, 9);
          $ += 9;
        } else
          o += d.substr($, 3), $ += 3;
      }
      return o;
    }
    function W(d, o) {
      function $(R) {
        var C = q(R);
        return C.match(o.UNRESERVED) ? C : R;
      }
      return d.scheme && (d.scheme = String(d.scheme).replace(o.PCT_ENCODED, $).toLowerCase().replace(o.NOT_SCHEME, "")), d.userinfo !== void 0 && (d.userinfo = String(d.userinfo).replace(o.PCT_ENCODED, $).replace(o.NOT_USERINFO, M).replace(o.PCT_ENCODED, u)), d.host !== void 0 && (d.host = String(d.host).replace(o.PCT_ENCODED, $).toLowerCase().replace(o.NOT_HOST, M).replace(o.PCT_ENCODED, u)), d.path !== void 0 && (d.path = String(d.path).replace(o.PCT_ENCODED, $).replace(d.scheme ? o.NOT_PATH : o.NOT_PATH_NOSCHEME, M).replace(o.PCT_ENCODED, u)), d.query !== void 0 && (d.query = String(d.query).replace(o.PCT_ENCODED, $).replace(o.NOT_QUERY, M).replace(o.PCT_ENCODED, u)), d.fragment !== void 0 && (d.fragment = String(d.fragment).replace(o.PCT_ENCODED, $).replace(o.NOT_FRAGMENT, M).replace(o.PCT_ENCODED, u)), d;
    }
    function te(d) {
      return d.replace(/^0*(.*)/, "$1") || "0";
    }
    function ie(d, o) {
      var $ = d.match(o.IPV4ADDRESS) || [], R = D($, 2), C = R[1];
      return C ? C.split(".").map(te).join(".") : d;
    }
    function ke(d, o) {
      var $ = d.match(o.IPV6ADDRESS) || [], R = D($, 3), C = R[1], H = R[2];
      if (C) {
        for (var G = C.toLowerCase().split("::").reverse(), x = D(G, 2), se = x[0], de = x[1], Z = de ? de.split(":").map(te) : [], ae = se.split(":").map(te), le = o.IPV4ADDRESS.test(ae[ae.length - 1]), Y = le ? 7 : 8, ce = ae.length - Y, he = Array(Y), ue = 0; ue < Y; ++ue)
          he[ue] = Z[ue] || ae[ce + ue] || "";
        le && (he[Y - 1] = ie(he[Y - 1], o));
        var Ge = he.reduce(function(Se, Fe, et) {
          if (!Fe || Fe === "0") {
            var qe = Se[Se.length - 1];
            qe && qe.index + qe.length === et ? qe.length++ : Se.push({ index: et, length: 1 });
          }
          return Se;
        }, []), Me = Ge.sort(function(Se, Fe) {
          return Fe.length - Se.length;
        })[0], Ve = void 0;
        if (Me && Me.length > 1) {
          var ft = he.slice(0, Me.index), xe = he.slice(Me.index + Me.length);
          Ve = ft.join(":") + "::" + xe.join(":");
        } else
          Ve = he.join(":");
        return H && (Ve += "%" + H), Ve;
      } else
        return d;
    }
    var bt = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i, St = "".match(/(){0}/)[1] === void 0;
    function Ee(d) {
      var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, $ = {}, R = o.iri !== !1 ? _ : p;
      o.reference === "suffix" && (d = (o.scheme ? o.scheme + ":" : "") + "//" + d);
      var C = d.match(bt);
      if (C) {
        St ? ($.scheme = C[1], $.userinfo = C[3], $.host = C[4], $.port = parseInt(C[5], 10), $.path = C[6] || "", $.query = C[7], $.fragment = C[8], isNaN($.port) && ($.port = C[5])) : ($.scheme = C[1] || void 0, $.userinfo = d.indexOf("@") !== -1 ? C[3] : void 0, $.host = d.indexOf("//") !== -1 ? C[4] : void 0, $.port = parseInt(C[5], 10), $.path = C[6] || "", $.query = d.indexOf("?") !== -1 ? C[7] : void 0, $.fragment = d.indexOf("#") !== -1 ? C[8] : void 0, isNaN($.port) && ($.port = d.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? C[4] : void 0)), $.host && ($.host = ke(ie($.host, R), R)), $.scheme === void 0 && $.userinfo === void 0 && $.host === void 0 && $.port === void 0 && !$.path && $.query === void 0 ? $.reference = "same-document" : $.scheme === void 0 ? $.reference = "relative" : $.fragment === void 0 ? $.reference = "absolute" : $.reference = "uri", o.reference && o.reference !== "suffix" && o.reference !== $.reference && ($.error = $.error || "URI is not a " + o.reference + " reference.");
        var H = F[(o.scheme || $.scheme || "").toLowerCase()];
        if (!o.unicodeSupport && (!H || !H.unicodeSupport)) {
          if ($.host && (o.domainHost || H && H.domainHost))
            try {
              $.host = T.toASCII($.host.replace(R.PCT_ENCODED, q).toLowerCase());
            } catch (G) {
              $.error = $.error || "Host's domain name can not be converted to ASCII via punycode: " + G;
            }
          W($, p);
        } else
          W($, R);
        H && H.parse && H.parse($, o);
      } else
        $.error = $.error || "URI can not be parsed.";
      return $;
    }
    function Pt(d, o) {
      var $ = o.iri !== !1 ? _ : p, R = [];
      return d.userinfo !== void 0 && (R.push(d.userinfo), R.push("@")), d.host !== void 0 && R.push(ke(ie(String(d.host), $), $).replace($.IPV6ADDRESS, function(C, H, G) {
        return "[" + H + (G ? "%25" + G : "") + "]";
      })), (typeof d.port == "number" || typeof d.port == "string") && (R.push(":"), R.push(String(d.port))), R.length ? R.join("") : void 0;
    }
    var it = /^\.\.?\//, ct = /^\/\.(\/|$)/, ut = /^\/\.\.(\/|$)/, Ot = /^\/?(?:.|\n)*?(?=\/|$)/;
    function De(d) {
      for (var o = []; d.length; )
        if (d.match(it))
          d = d.replace(it, "");
        else if (d.match(ct))
          d = d.replace(ct, "/");
        else if (d.match(ut))
          d = d.replace(ut, "/"), o.pop();
        else if (d === "." || d === "..")
          d = "";
        else {
          var $ = d.match(Ot);
          if ($) {
            var R = $[0];
            d = d.slice(R.length), o.push(R);
          } else
            throw new Error("Unexpected dot segment condition");
        }
      return o.join("");
    }
    function _e(d) {
      var o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, $ = o.iri ? _ : p, R = [], C = F[(o.scheme || d.scheme || "").toLowerCase()];
      if (C && C.serialize && C.serialize(d, o), d.host && !$.IPV6ADDRESS.test(d.host)) {
        if (o.domainHost || C && C.domainHost)
          try {
            d.host = o.iri ? T.toUnicode(d.host) : T.toASCII(d.host.replace($.PCT_ENCODED, q).toLowerCase());
          } catch (x) {
            d.error = d.error || "Host's domain name can not be converted to " + (o.iri ? "Unicode" : "ASCII") + " via punycode: " + x;
          }
      }
      W(d, $), o.reference !== "suffix" && d.scheme && (R.push(d.scheme), R.push(":"));
      var H = Pt(d, o);
      if (H !== void 0 && (o.reference !== "suffix" && R.push("//"), R.push(H), d.path && d.path.charAt(0) !== "/" && R.push("/")), d.path !== void 0) {
        var G = d.path;
        !o.absolutePath && (!C || !C.absolutePath) && (G = De(G)), H === void 0 && (G = G.replace(/^\/\//, "/%2F")), R.push(G);
      }
      return d.query !== void 0 && (R.push("?"), R.push(d.query)), d.fragment !== void 0 && (R.push("#"), R.push(d.fragment)), R.join("");
    }
    function dt(d, o) {
      var $ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, R = arguments[3], C = {};
      return R || (d = Ee(_e(d, $), $), o = Ee(_e(o, $), $)), $ = $ || {}, !$.tolerant && o.scheme ? (C.scheme = o.scheme, C.userinfo = o.userinfo, C.host = o.host, C.port = o.port, C.path = De(o.path || ""), C.query = o.query) : (o.userinfo !== void 0 || o.host !== void 0 || o.port !== void 0 ? (C.userinfo = o.userinfo, C.host = o.host, C.port = o.port, C.path = De(o.path || ""), C.query = o.query) : (o.path ? (o.path.charAt(0) === "/" ? C.path = De(o.path) : ((d.userinfo !== void 0 || d.host !== void 0 || d.port !== void 0) && !d.path ? C.path = "/" + o.path : d.path ? C.path = d.path.slice(0, d.path.lastIndexOf("/") + 1) + o.path : C.path = o.path, C.path = De(C.path)), C.query = o.query) : (C.path = d.path, o.query !== void 0 ? C.query = o.query : C.query = d.query), C.userinfo = d.userinfo, C.host = d.host, C.port = d.port), C.scheme = d.scheme), C.fragment = o.fragment, C;
    }
    function Nt(d, o, $) {
      var R = y({ scheme: "null" }, $);
      return _e(dt(Ee(d, R), Ee(o, R), R, !0), R);
    }
    function Qe(d, o) {
      return typeof d == "string" ? d = _e(Ee(d, o), o) : i(d) === "object" && (d = Ee(_e(d, o), o)), d;
    }
    function Tt(d, o, $) {
      return typeof d == "string" ? d = _e(Ee(d, $), $) : i(d) === "object" && (d = _e(d, $)), typeof o == "string" ? o = _e(Ee(o, $), $) : i(o) === "object" && (o = _e(o, $)), d === o;
    }
    function Gt(d, o) {
      return d && d.toString().replace(!o || !o.iri ? p.ESCAPE : _.ESCAPE, M);
    }
    function be(d, o) {
      return d && d.toString().replace(!o || !o.iri ? p.PCT_ENCODED : _.PCT_ENCODED, q);
    }
    var Ze = {
      scheme: "http",
      domainHost: !0,
      parse: function(o, $) {
        return o.host || (o.error = o.error || "HTTP URIs must have a host."), o;
      },
      serialize: function(o, $) {
        var R = String(o.scheme).toLowerCase() === "https";
        return (o.port === (R ? 443 : 80) || o.port === "") && (o.port = void 0), o.path || (o.path = "/"), o;
      }
    }, vn = {
      scheme: "https",
      domainHost: Ze.domainHost,
      parse: Ze.parse,
      serialize: Ze.serialize
    };
    function _n(d) {
      return typeof d.secure == "boolean" ? d.secure : String(d.scheme).toLowerCase() === "wss";
    }
    var Ct = {
      scheme: "ws",
      domainHost: !0,
      parse: function(o, $) {
        var R = o;
        return R.secure = _n(R), R.resourceName = (R.path || "/") + (R.query ? "?" + R.query : ""), R.path = void 0, R.query = void 0, R;
      },
      serialize: function(o, $) {
        if ((o.port === (_n(o) ? 443 : 80) || o.port === "") && (o.port = void 0), typeof o.secure == "boolean" && (o.scheme = o.secure ? "wss" : "ws", o.secure = void 0), o.resourceName) {
          var R = o.resourceName.split("?"), C = D(R, 2), H = C[0], G = C[1];
          o.path = H && H !== "/" ? H : void 0, o.query = G, o.resourceName = void 0;
        }
        return o.fragment = void 0, o;
      }
    }, gn = {
      scheme: "wss",
      domainHost: Ct.domainHost,
      parse: Ct.parse,
      serialize: Ct.serialize
    }, Aa = {}, wn = "[A-Za-z0-9\\-\\.\\_\\~\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]", Ae = "[0-9A-Fa-f]", Ma = n(n("%[EFef]" + Ae + "%" + Ae + Ae + "%" + Ae + Ae) + "|" + n("%[89A-Fa-f]" + Ae + "%" + Ae + Ae) + "|" + n("%" + Ae + Ae)), Va = "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]", Fa = "[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]", za = a(Fa, '[\\"\\\\]'), Ua = "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]", qa = new RegExp(wn, "g"), lt = new RegExp(Ma, "g"), Ka = new RegExp(a("[^]", Va, "[\\.]", '[\\"]', za), "g"), En = new RegExp(a("[^]", wn, Ua), "g"), La = En;
    function pr(d) {
      var o = q(d);
      return o.match(qa) ? o : d;
    }
    var bn = {
      scheme: "mailto",
      parse: function(o, $) {
        var R = o, C = R.to = R.path ? R.path.split(",") : [];
        if (R.path = void 0, R.query) {
          for (var H = !1, G = {}, x = R.query.split("&"), se = 0, de = x.length; se < de; ++se) {
            var Z = x[se].split("=");
            switch (Z[0]) {
              case "to":
                for (var ae = Z[1].split(","), le = 0, Y = ae.length; le < Y; ++le)
                  C.push(ae[le]);
                break;
              case "subject":
                R.subject = be(Z[1], $);
                break;
              case "body":
                R.body = be(Z[1], $);
                break;
              default:
                H = !0, G[be(Z[0], $)] = be(Z[1], $);
                break;
            }
          }
          H && (R.headers = G);
        }
        R.query = void 0;
        for (var ce = 0, he = C.length; ce < he; ++ce) {
          var ue = C[ce].split("@");
          if (ue[0] = be(ue[0]), $.unicodeSupport)
            ue[1] = be(ue[1], $).toLowerCase();
          else
            try {
              ue[1] = T.toASCII(be(ue[1], $).toLowerCase());
            } catch (Ge) {
              R.error = R.error || "Email address's domain name can not be converted to ASCII via punycode: " + Ge;
            }
          C[ce] = ue.join("@");
        }
        return R;
      },
      serialize: function(o, $) {
        var R = o, C = m(o.to);
        if (C) {
          for (var H = 0, G = C.length; H < G; ++H) {
            var x = String(C[H]), se = x.lastIndexOf("@"), de = x.slice(0, se).replace(lt, pr).replace(lt, u).replace(Ka, M), Z = x.slice(se + 1);
            try {
              Z = $.iri ? T.toUnicode(Z) : T.toASCII(be(Z, $).toLowerCase());
            } catch (ce) {
              R.error = R.error || "Email address's domain name can not be converted to " + ($.iri ? "Unicode" : "ASCII") + " via punycode: " + ce;
            }
            C[H] = de + "@" + Z;
          }
          R.path = C.join(",");
        }
        var ae = o.headers = o.headers || {};
        o.subject && (ae.subject = o.subject), o.body && (ae.body = o.body);
        var le = [];
        for (var Y in ae)
          ae[Y] !== Aa[Y] && le.push(Y.replace(lt, pr).replace(lt, u).replace(En, M) + "=" + ae[Y].replace(lt, pr).replace(lt, u).replace(La, M));
        return le.length && (R.query = le.join("&")), R;
      }
    }, Ha = /^([^\:]+)\:(.*)/, Sn = {
      scheme: "urn",
      parse: function(o, $) {
        var R = o.path && o.path.match(Ha), C = o;
        if (R) {
          var H = $.scheme || C.scheme || "urn", G = R[1].toLowerCase(), x = R[2], se = H + ":" + ($.nid || G), de = F[se];
          C.nid = G, C.nss = x, C.path = void 0, de && (C = de.parse(C, $));
        } else
          C.error = C.error || "URN can not be parsed.";
        return C;
      },
      serialize: function(o, $) {
        var R = $.scheme || o.scheme || "urn", C = o.nid, H = R + ":" + ($.nid || C), G = F[H];
        G && (o = G.serialize(o, $));
        var x = o, se = o.nss;
        return x.path = (C || $.nid) + ":" + se, x;
      }
    }, Ga = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/, Pn = {
      scheme: "urn:uuid",
      parse: function(o, $) {
        var R = o;
        return R.uuid = R.nss, R.nss = void 0, !$.tolerant && (!R.uuid || !R.uuid.match(Ga)) && (R.error = R.error || "UUID is not valid."), R;
      },
      serialize: function(o, $) {
        var R = o;
        return R.nss = (o.uuid || "").toLowerCase(), R;
      }
    };
    F[Ze.scheme] = Ze, F[vn.scheme] = vn, F[Ct.scheme] = Ct, F[gn.scheme] = gn, F[bn.scheme] = bn, F[Sn.scheme] = Sn, F[Pn.scheme] = Pn, r.SCHEMES = F, r.pctEncChar = M, r.pctDecChars = q, r.parse = Ee, r.removeDotSegments = De, r.serialize = _e, r.resolveComponents = dt, r.resolve = Nt, r.normalize = Qe, r.equal = Tt, r.escapeComponent = Gt, r.unescapeComponent = be, Object.defineProperty(r, "__esModule", { value: !0 });
  });
})(Pr, Pr.exports);
var Io = Pr.exports;
Object.defineProperty(Fr, "__esModule", { value: !0 });
const ba = Io;
ba.code = 'require("ajv/dist/runtime/uri").default';
Fr.default = ba;
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.CodeGen = e.Name = e.nil = e.stringify = e.str = e._ = e.KeywordCxt = void 0;
  var t = Oe;
  Object.defineProperty(e, "KeywordCxt", { enumerable: !0, get: function() {
    return t.KeywordCxt;
  } });
  var r = X;
  Object.defineProperty(e, "_", { enumerable: !0, get: function() {
    return r._;
  } }), Object.defineProperty(e, "str", { enumerable: !0, get: function() {
    return r.str;
  } }), Object.defineProperty(e, "stringify", { enumerable: !0, get: function() {
    return r.stringify;
  } }), Object.defineProperty(e, "nil", { enumerable: !0, get: function() {
    return r.nil;
  } }), Object.defineProperty(e, "Name", { enumerable: !0, get: function() {
    return r.Name;
  } }), Object.defineProperty(e, "CodeGen", { enumerable: !0, get: function() {
    return r.CodeGen;
  } });
  const a = Kt, n = Lt, i = st, u = we, m = X, y = pe, l = qt, p = ee, _ = jo, D = Fr, k = (U, E) => new RegExp(U, E);
  k.code = "new RegExp";
  const S = ["removeAdditional", "useDefaults", "coerceTypes"], P = /* @__PURE__ */ new Set([
    "validate",
    "serialize",
    "parse",
    "wrapper",
    "root",
    "schema",
    "keyword",
    "pattern",
    "formats",
    "validate$data",
    "func",
    "obj",
    "Error"
  ]), g = {
    errorDataPath: "",
    format: "`validateFormats: false` can be used instead.",
    nullable: '"nullable" keyword is supported by default.',
    jsonPointers: "Deprecated jsPropertySyntax can be used instead.",
    extendRefs: "Deprecated ignoreKeywordsWithRef can be used instead.",
    missingRefs: "Pass empty schema with $id that should be ignored to ajv.addSchema.",
    processCode: "Use option `code: {process: (code, schemaEnv: object) => string}`",
    sourceCode: "Use option `code: {source: true}`",
    strictDefaults: "It is default now, see option `strict`.",
    strictKeywords: "It is default now, see option `strict`.",
    uniqueItems: '"uniqueItems" keyword is always validated.',
    unknownFormats: "Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",
    cache: "Map is used as cache, schema object as key.",
    serialize: "Map is used as cache, schema object as key.",
    ajvErrors: "It is default now."
  }, f = {
    ignoreKeywordsWithRef: "",
    jsPropertySyntax: "",
    unicode: '"minLength"/"maxLength" account for unicode characters by default.'
  }, h = 200;
  function O(U) {
    var E, b, v, s, c, T, F, M, q, W, te, ie, ke, bt, St, Ee, Pt, it, ct, ut, Ot, De, _e, dt, Nt;
    const Qe = U.strict, Tt = (E = U.code) === null || E === void 0 ? void 0 : E.optimize, Gt = Tt === !0 || Tt === void 0 ? 1 : Tt || 0, be = (v = (b = U.code) === null || b === void 0 ? void 0 : b.regExp) !== null && v !== void 0 ? v : k, Ze = (s = U.uriResolver) !== null && s !== void 0 ? s : D.default;
    return {
      strictSchema: (T = (c = U.strictSchema) !== null && c !== void 0 ? c : Qe) !== null && T !== void 0 ? T : !0,
      strictNumbers: (M = (F = U.strictNumbers) !== null && F !== void 0 ? F : Qe) !== null && M !== void 0 ? M : !0,
      strictTypes: (W = (q = U.strictTypes) !== null && q !== void 0 ? q : Qe) !== null && W !== void 0 ? W : "log",
      strictTuples: (ie = (te = U.strictTuples) !== null && te !== void 0 ? te : Qe) !== null && ie !== void 0 ? ie : "log",
      strictRequired: (bt = (ke = U.strictRequired) !== null && ke !== void 0 ? ke : Qe) !== null && bt !== void 0 ? bt : !1,
      code: U.code ? { ...U.code, optimize: Gt, regExp: be } : { optimize: Gt, regExp: be },
      loopRequired: (St = U.loopRequired) !== null && St !== void 0 ? St : h,
      loopEnum: (Ee = U.loopEnum) !== null && Ee !== void 0 ? Ee : h,
      meta: (Pt = U.meta) !== null && Pt !== void 0 ? Pt : !0,
      messages: (it = U.messages) !== null && it !== void 0 ? it : !0,
      inlineRefs: (ct = U.inlineRefs) !== null && ct !== void 0 ? ct : !0,
      schemaId: (ut = U.schemaId) !== null && ut !== void 0 ? ut : "$id",
      addUsedSchema: (Ot = U.addUsedSchema) !== null && Ot !== void 0 ? Ot : !0,
      validateSchema: (De = U.validateSchema) !== null && De !== void 0 ? De : !0,
      validateFormats: (_e = U.validateFormats) !== null && _e !== void 0 ? _e : !0,
      unicodeRegExp: (dt = U.unicodeRegExp) !== null && dt !== void 0 ? dt : !0,
      int32range: (Nt = U.int32range) !== null && Nt !== void 0 ? Nt : !0,
      uriResolver: Ze
    };
  }
  class j {
    constructor(E = {}) {
      this.schemas = {}, this.refs = {}, this.formats = {}, this._compilations = /* @__PURE__ */ new Set(), this._loading = {}, this._cache = /* @__PURE__ */ new Map(), E = this.opts = { ...E, ...O(E) };
      const { es5: b, lines: v } = this.opts.code;
      this.scope = new m.ValueScope({ scope: {}, prefixes: P, es5: b, lines: v }), this.logger = K(E.logger);
      const s = E.validateFormats;
      E.validateFormats = !1, this.RULES = (0, i.getRules)(), V.call(this, g, E, "NOT SUPPORTED"), V.call(this, f, E, "DEPRECATED", "warn"), this._metaOpts = z.call(this), E.formats && I.call(this), this._addVocabularies(), this._addDefaultMetaSchema(), E.keywords && A.call(this, E.keywords), typeof E.meta == "object" && this.addMetaSchema(E.meta), N.call(this), E.validateFormats = s;
    }
    _addVocabularies() {
      this.addKeyword("$async");
    }
    _addDefaultMetaSchema() {
      const { $data: E, meta: b, schemaId: v } = this.opts;
      let s = _;
      v === "id" && (s = { ..._ }, s.id = s.$id, delete s.$id), b && E && this.addMetaSchema(s, s[v], !1);
    }
    defaultMeta() {
      const { meta: E, schemaId: b } = this.opts;
      return this.opts.defaultMeta = typeof E == "object" ? E[b] || E : void 0;
    }
    validate(E, b) {
      let v;
      if (typeof E == "string") {
        if (v = this.getSchema(E), !v)
          throw new Error(`no schema with key or ref "${E}"`);
      } else
        v = this.compile(E);
      const s = v(b);
      return "$async" in v || (this.errors = v.errors), s;
    }
    compile(E, b) {
      const v = this._addSchema(E, b);
      return v.validate || this._compileSchemaEnv(v);
    }
    compileAsync(E, b) {
      if (typeof this.opts.loadSchema != "function")
        throw new Error("options.loadSchema should be a function");
      const { loadSchema: v } = this.opts;
      return s.call(this, E, b);
      async function s(W, te) {
        await c.call(this, W.$schema);
        const ie = this._addSchema(W, te);
        return ie.validate || T.call(this, ie);
      }
      async function c(W) {
        W && !this.getSchema(W) && await s.call(this, { $ref: W }, !0);
      }
      async function T(W) {
        try {
          return this._compileSchemaEnv(W);
        } catch (te) {
          if (!(te instanceof n.default))
            throw te;
          return F.call(this, te), await M.call(this, te.missingSchema), T.call(this, W);
        }
      }
      function F({ missingSchema: W, missingRef: te }) {
        if (this.refs[W])
          throw new Error(`AnySchema ${W} is loaded but ${te} cannot be resolved`);
      }
      async function M(W) {
        const te = await q.call(this, W);
        this.refs[W] || await c.call(this, te.$schema), this.refs[W] || this.addSchema(te, W, b);
      }
      async function q(W) {
        const te = this._loading[W];
        if (te)
          return te;
        try {
          return await (this._loading[W] = v(W));
        } finally {
          delete this._loading[W];
        }
      }
    }
    // Adds schema to the instance
    addSchema(E, b, v, s = this.opts.validateSchema) {
      if (Array.isArray(E)) {
        for (const T of E)
          this.addSchema(T, void 0, v, s);
        return this;
      }
      let c;
      if (typeof E == "object") {
        const { schemaId: T } = this.opts;
        if (c = E[T], c !== void 0 && typeof c != "string")
          throw new Error(`schema ${T} must be string`);
      }
      return b = (0, y.normalizeId)(b || c), this._checkUnique(b), this.schemas[b] = this._addSchema(E, v, b, s, !0), this;
    }
    // Add schema that will be used to validate other schemas
    // options in META_IGNORE_OPTIONS are alway set to false
    addMetaSchema(E, b, v = this.opts.validateSchema) {
      return this.addSchema(E, b, !0, v), this;
    }
    //  Validate schema against its meta-schema
    validateSchema(E, b) {
      if (typeof E == "boolean")
        return !0;
      let v;
      if (v = E.$schema, v !== void 0 && typeof v != "string")
        throw new Error("$schema must be a string");
      if (v = v || this.opts.defaultMeta || this.defaultMeta(), !v)
        return this.logger.warn("meta-schema not available"), this.errors = null, !0;
      const s = this.validate(v, E);
      if (!s && b) {
        const c = "schema is invalid: " + this.errorsText();
        if (this.opts.validateSchema === "log")
          this.logger.error(c);
        else
          throw new Error(c);
      }
      return s;
    }
    // Get compiled schema by `key` or `ref`.
    // (`key` that was passed to `addSchema` or full schema reference - `schema.$id` or resolved id)
    getSchema(E) {
      let b;
      for (; typeof (b = w.call(this, E)) == "string"; )
        E = b;
      if (b === void 0) {
        const { schemaId: v } = this.opts, s = new u.SchemaEnv({ schema: {}, schemaId: v });
        if (b = u.resolveSchema.call(this, s, E), !b)
          return;
        this.refs[E] = b;
      }
      return b.validate || this._compileSchemaEnv(b);
    }
    // Remove cached schema(s).
    // If no parameter is passed all schemas but meta-schemas are removed.
    // If RegExp is passed all schemas with key/id matching pattern but meta-schemas are removed.
    // Even if schema is referenced by other schemas it still can be removed as other schemas have local references.
    removeSchema(E) {
      if (E instanceof RegExp)
        return this._removeAllSchemas(this.schemas, E), this._removeAllSchemas(this.refs, E), this;
      switch (typeof E) {
        case "undefined":
          return this._removeAllSchemas(this.schemas), this._removeAllSchemas(this.refs), this._cache.clear(), this;
        case "string": {
          const b = w.call(this, E);
          return typeof b == "object" && this._cache.delete(b.schema), delete this.schemas[E], delete this.refs[E], this;
        }
        case "object": {
          const b = E;
          this._cache.delete(b);
          let v = E[this.opts.schemaId];
          return v && (v = (0, y.normalizeId)(v), delete this.schemas[v], delete this.refs[v]), this;
        }
        default:
          throw new Error("ajv.removeSchema: invalid parameter");
      }
    }
    // add "vocabulary" - a collection of keywords
    addVocabulary(E) {
      for (const b of E)
        this.addKeyword(b);
      return this;
    }
    addKeyword(E, b) {
      let v;
      if (typeof E == "string")
        v = E, typeof b == "object" && (this.logger.warn("these parameters are deprecated, see docs for addKeyword"), b.keyword = v);
      else if (typeof E == "object" && b === void 0) {
        if (b = E, v = b.keyword, Array.isArray(v) && !v.length)
          throw new Error("addKeywords: keyword must be string or non-empty array");
      } else
        throw new Error("invalid addKeywords parameters");
      if (ne.call(this, v, b), !b)
        return (0, p.eachItem)(v, (c) => ve.call(this, c)), this;
      He.call(this, b);
      const s = {
        ...b,
        type: (0, l.getJSONTypes)(b.type),
        schemaType: (0, l.getJSONTypes)(b.schemaType)
      };
      return (0, p.eachItem)(v, s.type.length === 0 ? (c) => ve.call(this, c, s) : (c) => s.type.forEach((T) => ve.call(this, c, s, T))), this;
    }
    getKeyword(E) {
      const b = this.RULES.all[E];
      return typeof b == "object" ? b.definition : !!b;
    }
    // Remove keyword
    removeKeyword(E) {
      const { RULES: b } = this;
      delete b.keywords[E], delete b.all[E];
      for (const v of b.rules) {
        const s = v.rules.findIndex((c) => c.keyword === E);
        s >= 0 && v.rules.splice(s, 1);
      }
      return this;
    }
    // Add format
    addFormat(E, b) {
      return typeof b == "string" && (b = new RegExp(b)), this.formats[E] = b, this;
    }
    errorsText(E = this.errors, { separator: b = ", ", dataVar: v = "data" } = {}) {
      return !E || E.length === 0 ? "No errors" : E.map((s) => `${v}${s.instancePath} ${s.message}`).reduce((s, c) => s + b + c);
    }
    $dataMetaSchema(E, b) {
      const v = this.RULES.all;
      E = JSON.parse(JSON.stringify(E));
      for (const s of b) {
        const c = s.split("/").slice(1);
        let T = E;
        for (const F of c)
          T = T[F];
        for (const F in v) {
          const M = v[F];
          if (typeof M != "object")
            continue;
          const { $data: q } = M.definition, W = T[F];
          q && W && (T[F] = Ie(W));
        }
      }
      return E;
    }
    _removeAllSchemas(E, b) {
      for (const v in E) {
        const s = E[v];
        (!b || b.test(v)) && (typeof s == "string" ? delete E[v] : s && !s.meta && (this._cache.delete(s.schema), delete E[v]));
      }
    }
    _addSchema(E, b, v, s = this.opts.validateSchema, c = this.opts.addUsedSchema) {
      let T;
      const { schemaId: F } = this.opts;
      if (typeof E == "object")
        T = E[F];
      else {
        if (this.opts.jtd)
          throw new Error("schema must be object");
        if (typeof E != "boolean")
          throw new Error("schema must be object or boolean");
      }
      let M = this._cache.get(E);
      if (M !== void 0)
        return M;
      v = (0, y.normalizeId)(T || v);
      const q = y.getSchemaRefs.call(this, E, v);
      return M = new u.SchemaEnv({ schema: E, schemaId: F, meta: b, baseId: v, localRefs: q }), this._cache.set(M.schema, M), c && !v.startsWith("#") && (v && this._checkUnique(v), this.refs[v] = M), s && this.validateSchema(E, !0), M;
    }
    _checkUnique(E) {
      if (this.schemas[E] || this.refs[E])
        throw new Error(`schema with key or id "${E}" already exists`);
    }
    _compileSchemaEnv(E) {
      if (E.meta ? this._compileMetaSchema(E) : u.compileSchema.call(this, E), !E.validate)
        throw new Error("ajv implementation error");
      return E.validate;
    }
    _compileMetaSchema(E) {
      const b = this.opts;
      this.opts = this._metaOpts;
      try {
        u.compileSchema.call(this, E);
      } finally {
        this.opts = b;
      }
    }
  }
  e.default = j, j.ValidationError = a.default, j.MissingRefError = n.default;
  function V(U, E, b, v = "error") {
    for (const s in U) {
      const c = s;
      c in E && this.logger[v](`${b}: option ${s}. ${U[c]}`);
    }
  }
  function w(U) {
    return U = (0, y.normalizeId)(U), this.schemas[U] || this.refs[U];
  }
  function N() {
    const U = this.opts.schemas;
    if (U)
      if (Array.isArray(U))
        this.addSchema(U);
      else
        for (const E in U)
          this.addSchema(U[E], E);
  }
  function I() {
    for (const U in this.opts.formats) {
      const E = this.opts.formats[U];
      E && this.addFormat(U, E);
    }
  }
  function A(U) {
    if (Array.isArray(U)) {
      this.addVocabulary(U);
      return;
    }
    this.logger.warn("keywords option as map is deprecated, pass array");
    for (const E in U) {
      const b = U[E];
      b.keyword || (b.keyword = E), this.addKeyword(b);
    }
  }
  function z() {
    const U = { ...this.opts };
    for (const E of S)
      delete U[E];
    return U;
  }
  const J = { log() {
  }, warn() {
  }, error() {
  } };
  function K(U) {
    if (U === !1)
      return J;
    if (U === void 0)
      return console;
    if (U.log && U.warn && U.error)
      return U;
    throw new Error("logger must implement log, warn and error methods");
  }
  const re = /^[a-z_$][a-z0-9_$:-]*$/i;
  function ne(U, E) {
    const { RULES: b } = this;
    if ((0, p.eachItem)(U, (v) => {
      if (b.keywords[v])
        throw new Error(`Keyword ${v} is already defined`);
      if (!re.test(v))
        throw new Error(`Keyword ${v} has invalid name`);
    }), !!E && E.$data && !("code" in E || "validate" in E))
      throw new Error('$data keyword must have "code" or "validate" function');
  }
  function ve(U, E, b) {
    var v;
    const s = E == null ? void 0 : E.post;
    if (b && s)
      throw new Error('keyword with "post" flag cannot have "type"');
    const { RULES: c } = this;
    let T = s ? c.post : c.rules.find(({ type: M }) => M === b);
    if (T || (T = { type: b, rules: [] }, c.rules.push(T)), c.keywords[U] = !0, !E)
      return;
    const F = {
      keyword: U,
      definition: {
        ...E,
        type: (0, l.getJSONTypes)(E.type),
        schemaType: (0, l.getJSONTypes)(E.schemaType)
      }
    };
    E.before ? je.call(this, T, F, E.before) : T.rules.push(F), c.all[U] = F, (v = E.implements) === null || v === void 0 || v.forEach((M) => this.addKeyword(M));
  }
  function je(U, E, b) {
    const v = U.rules.findIndex((s) => s.keyword === b);
    v >= 0 ? U.rules.splice(v, 0, E) : (U.rules.push(E), this.logger.warn(`rule ${b} is not defined`));
  }
  function He(U) {
    let { metaSchema: E } = U;
    E !== void 0 && (U.$data && this.opts.$data && (E = Ie(E)), U.validateSchema = this.compile(E, !0));
  }
  const Xe = {
    $ref: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"
  };
  function Ie(U) {
    return { anyOf: [U, Xe] };
  }
})(Zn);
var zr = {}, Ur = {}, qr = {};
Object.defineProperty(qr, "__esModule", { value: !0 });
const ko = {
  keyword: "id",
  code() {
    throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID');
  }
};
qr.default = ko;
var ot = {};
Object.defineProperty(ot, "__esModule", { value: !0 });
ot.callRef = ot.getValidate = void 0;
const Do = Lt, zn = Q, ge = X, mt = Re, Un = we, Xt = ee, Ao = {
  keyword: "$ref",
  schemaType: "string",
  code(e) {
    const { gen: t, schema: r, it: a } = e, { baseId: n, schemaEnv: i, validateName: u, opts: m, self: y } = a, { root: l } = i;
    if ((r === "#" || r === "#/") && n === l.baseId)
      return _();
    const p = Un.resolveRef.call(y, l, n, r);
    if (p === void 0)
      throw new Do.default(a.opts.uriResolver, n, r);
    if (p instanceof Un.SchemaEnv)
      return D(p);
    return k(p);
    function _() {
      if (i === l)
        return nr(e, u, i, i.$async);
      const S = t.scopeValue("root", { ref: l });
      return nr(e, (0, ge._)`${S}.validate`, l, l.$async);
    }
    function D(S) {
      const P = Sa(e, S);
      nr(e, P, S, S.$async);
    }
    function k(S) {
      const P = t.scopeValue("schema", m.code.source === !0 ? { ref: S, code: (0, ge.stringify)(S) } : { ref: S }), g = t.name("valid"), f = e.subschema({
        schema: S,
        dataTypes: [],
        schemaPath: ge.nil,
        topSchemaRef: P,
        errSchemaPath: r
      }, g);
      e.mergeEvaluated(f), e.ok(g);
    }
  }
};
function Sa(e, t) {
  const { gen: r } = e;
  return t.validate ? r.scopeValue("validate", { ref: t.validate }) : (0, ge._)`${r.scopeValue("wrapper", { ref: t })}.validate`;
}
ot.getValidate = Sa;
function nr(e, t, r, a) {
  const { gen: n, it: i } = e, { allErrors: u, schemaEnv: m, opts: y } = i, l = y.passContext ? mt.default.this : ge.nil;
  a ? p() : _();
  function p() {
    if (!m.$async)
      throw new Error("async schema referenced by sync schema");
    const S = n.let("valid");
    n.try(() => {
      n.code((0, ge._)`await ${(0, zn.callValidateCode)(e, t, l)}`), k(t), u || n.assign(S, !0);
    }, (P) => {
      n.if((0, ge._)`!(${P} instanceof ${i.ValidationError})`, () => n.throw(P)), D(P), u || n.assign(S, !1);
    }), e.ok(S);
  }
  function _() {
    e.result((0, zn.callValidateCode)(e, t, l), () => k(t), () => D(t));
  }
  function D(S) {
    const P = (0, ge._)`${S}.errors`;
    n.assign(mt.default.vErrors, (0, ge._)`${mt.default.vErrors} === null ? ${P} : ${mt.default.vErrors}.concat(${P})`), n.assign(mt.default.errors, (0, ge._)`${mt.default.vErrors}.length`);
  }
  function k(S) {
    var P;
    if (!i.opts.unevaluated)
      return;
    const g = (P = r == null ? void 0 : r.validate) === null || P === void 0 ? void 0 : P.evaluated;
    if (i.props !== !0)
      if (g && !g.dynamicProps)
        g.props !== void 0 && (i.props = Xt.mergeEvaluated.props(n, g.props, i.props));
      else {
        const f = n.var("props", (0, ge._)`${S}.evaluated.props`);
        i.props = Xt.mergeEvaluated.props(n, f, i.props, ge.Name);
      }
    if (i.items !== !0)
      if (g && !g.dynamicItems)
        g.items !== void 0 && (i.items = Xt.mergeEvaluated.items(n, g.items, i.items));
      else {
        const f = n.var("items", (0, ge._)`${S}.evaluated.items`);
        i.items = Xt.mergeEvaluated.items(n, f, i.items, ge.Name);
      }
  }
}
ot.callRef = nr;
ot.default = Ao;
Object.defineProperty(Ur, "__esModule", { value: !0 });
const Mo = qr, Vo = ot, Fo = [
  "$schema",
  "$id",
  "$defs",
  "$vocabulary",
  { keyword: "$comment" },
  "definitions",
  Mo.default,
  Vo.default
];
Ur.default = Fo;
var Kr = {}, Lr = {};
Object.defineProperty(Lr, "__esModule", { value: !0 });
const ir = X, We = ir.operators, cr = {
  maximum: { okStr: "<=", ok: We.LTE, fail: We.GT },
  minimum: { okStr: ">=", ok: We.GTE, fail: We.LT },
  exclusiveMaximum: { okStr: "<", ok: We.LT, fail: We.GTE },
  exclusiveMinimum: { okStr: ">", ok: We.GT, fail: We.LTE }
}, zo = {
  message: ({ keyword: e, schemaCode: t }) => (0, ir.str)`must be ${cr[e].okStr} ${t}`,
  params: ({ keyword: e, schemaCode: t }) => (0, ir._)`{comparison: ${cr[e].okStr}, limit: ${t}}`
}, Uo = {
  keyword: Object.keys(cr),
  type: "number",
  schemaType: "number",
  $data: !0,
  error: zo,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e;
    e.fail$data((0, ir._)`${r} ${cr[t].fail} ${a} || isNaN(${r})`);
  }
};
Lr.default = Uo;
var Hr = {};
Object.defineProperty(Hr, "__esModule", { value: !0 });
const Vt = X, qo = {
  message: ({ schemaCode: e }) => (0, Vt.str)`must be multiple of ${e}`,
  params: ({ schemaCode: e }) => (0, Vt._)`{multipleOf: ${e}}`
}, Ko = {
  keyword: "multipleOf",
  type: "number",
  schemaType: "number",
  $data: !0,
  error: qo,
  code(e) {
    const { gen: t, data: r, schemaCode: a, it: n } = e, i = n.opts.multipleOfPrecision, u = t.let("res"), m = i ? (0, Vt._)`Math.abs(Math.round(${u}) - ${u}) > 1e-${i}` : (0, Vt._)`${u} !== parseInt(${u})`;
    e.fail$data((0, Vt._)`(${a} === 0 || (${u} = ${r}/${a}, ${m}))`);
  }
};
Hr.default = Ko;
var Gr = {}, Jr = {};
Object.defineProperty(Jr, "__esModule", { value: !0 });
function Pa(e) {
  const t = e.length;
  let r = 0, a = 0, n;
  for (; a < t; )
    r++, n = e.charCodeAt(a++), n >= 55296 && n <= 56319 && a < t && (n = e.charCodeAt(a), (n & 64512) === 56320 && a++);
  return r;
}
Jr.default = Pa;
Pa.code = 'require("ajv/dist/runtime/ucs2length").default';
Object.defineProperty(Gr, "__esModule", { value: !0 });
const nt = X, Lo = ee, Ho = Jr, Go = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxLength" ? "more" : "fewer";
    return (0, nt.str)`must NOT have ${r} than ${t} characters`;
  },
  params: ({ schemaCode: e }) => (0, nt._)`{limit: ${e}}`
}, Jo = {
  keyword: ["maxLength", "minLength"],
  type: "string",
  schemaType: "number",
  $data: !0,
  error: Go,
  code(e) {
    const { keyword: t, data: r, schemaCode: a, it: n } = e, i = t === "maxLength" ? nt.operators.GT : nt.operators.LT, u = n.opts.unicode === !1 ? (0, nt._)`${r}.length` : (0, nt._)`${(0, Lo.useFunc)(e.gen, Ho.default)}(${r})`;
    e.fail$data((0, nt._)`${u} ${i} ${a}`);
  }
};
Gr.default = Jo;
var Wr = {};
Object.defineProperty(Wr, "__esModule", { value: !0 });
const Wo = Q, ur = X, Bo = {
  message: ({ schemaCode: e }) => (0, ur.str)`must match pattern "${e}"`,
  params: ({ schemaCode: e }) => (0, ur._)`{pattern: ${e}}`
}, Yo = {
  keyword: "pattern",
  type: "string",
  schemaType: "string",
  $data: !0,
  error: Bo,
  code(e) {
    const { data: t, $data: r, schema: a, schemaCode: n, it: i } = e, u = i.opts.unicodeRegExp ? "u" : "", m = r ? (0, ur._)`(new RegExp(${n}, ${u}))` : (0, Wo.usePattern)(e, a);
    e.fail$data((0, ur._)`!${m}.test(${t})`);
  }
};
Wr.default = Yo;
var Br = {};
Object.defineProperty(Br, "__esModule", { value: !0 });
const Ft = X, Xo = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxProperties" ? "more" : "fewer";
    return (0, Ft.str)`must NOT have ${r} than ${t} properties`;
  },
  params: ({ schemaCode: e }) => (0, Ft._)`{limit: ${e}}`
}, Qo = {
  keyword: ["maxProperties", "minProperties"],
  type: "object",
  schemaType: "number",
  $data: !0,
  error: Xo,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e, n = t === "maxProperties" ? Ft.operators.GT : Ft.operators.LT;
    e.fail$data((0, Ft._)`Object.keys(${r}).length ${n} ${a}`);
  }
};
Br.default = Qo;
var Yr = {};
Object.defineProperty(Yr, "__esModule", { value: !0 });
const Dt = Q, zt = X, Zo = ee, xo = {
  message: ({ params: { missingProperty: e } }) => (0, zt.str)`must have required property '${e}'`,
  params: ({ params: { missingProperty: e } }) => (0, zt._)`{missingProperty: ${e}}`
}, ei = {
  keyword: "required",
  type: "object",
  schemaType: "array",
  $data: !0,
  error: xo,
  code(e) {
    const { gen: t, schema: r, schemaCode: a, data: n, $data: i, it: u } = e, { opts: m } = u;
    if (!i && r.length === 0)
      return;
    const y = r.length >= m.loopRequired;
    if (u.allErrors ? l() : p(), m.strictRequired) {
      const k = e.parentSchema.properties, { definedProperties: S } = e.it;
      for (const P of r)
        if ((k == null ? void 0 : k[P]) === void 0 && !S.has(P)) {
          const g = u.schemaEnv.baseId + u.errSchemaPath, f = `required property "${P}" is not defined at "${g}" (strictRequired)`;
          (0, Zo.checkStrictMode)(u, f, u.opts.strictRequired);
        }
    }
    function l() {
      if (y || i)
        e.block$data(zt.nil, _);
      else
        for (const k of r)
          (0, Dt.checkReportMissingProp)(e, k);
    }
    function p() {
      const k = t.let("missing");
      if (y || i) {
        const S = t.let("valid", !0);
        e.block$data(S, () => D(k, S)), e.ok(S);
      } else
        t.if((0, Dt.checkMissingProp)(e, r, k)), (0, Dt.reportMissingProp)(e, k), t.else();
    }
    function _() {
      t.forOf("prop", a, (k) => {
        e.setParams({ missingProperty: k }), t.if((0, Dt.noPropertyInData)(t, n, k, m.ownProperties), () => e.error());
      });
    }
    function D(k, S) {
      e.setParams({ missingProperty: k }), t.forOf(k, a, () => {
        t.assign(S, (0, Dt.propertyInData)(t, n, k, m.ownProperties)), t.if((0, zt.not)(S), () => {
          e.error(), t.break();
        });
      }, zt.nil);
    }
  }
};
Yr.default = ei;
var Xr = {};
Object.defineProperty(Xr, "__esModule", { value: !0 });
const Ut = X, ti = {
  message({ keyword: e, schemaCode: t }) {
    const r = e === "maxItems" ? "more" : "fewer";
    return (0, Ut.str)`must NOT have ${r} than ${t} items`;
  },
  params: ({ schemaCode: e }) => (0, Ut._)`{limit: ${e}}`
}, ri = {
  keyword: ["maxItems", "minItems"],
  type: "array",
  schemaType: "number",
  $data: !0,
  error: ti,
  code(e) {
    const { keyword: t, data: r, schemaCode: a } = e, n = t === "maxItems" ? Ut.operators.GT : Ut.operators.LT;
    e.fail$data((0, Ut._)`${r}.length ${n} ${a}`);
  }
};
Xr.default = ri;
var Qr = {}, Ht = {};
Object.defineProperty(Ht, "__esModule", { value: !0 });
const Oa = oa;
Oa.code = 'require("ajv/dist/runtime/equal").default';
Ht.default = Oa;
Object.defineProperty(Qr, "__esModule", { value: !0 });
const _r = qt, me = X, ni = ee, ai = Ht, si = {
  message: ({ params: { i: e, j: t } }) => (0, me.str)`must NOT have duplicate items (items ## ${t} and ${e} are identical)`,
  params: ({ params: { i: e, j: t } }) => (0, me._)`{i: ${e}, j: ${t}}`
}, oi = {
  keyword: "uniqueItems",
  type: "array",
  schemaType: "boolean",
  $data: !0,
  error: si,
  code(e) {
    const { gen: t, data: r, $data: a, schema: n, parentSchema: i, schemaCode: u, it: m } = e;
    if (!a && !n)
      return;
    const y = t.let("valid"), l = i.items ? (0, _r.getSchemaTypes)(i.items) : [];
    e.block$data(y, p, (0, me._)`${u} === false`), e.ok(y);
    function p() {
      const S = t.let("i", (0, me._)`${r}.length`), P = t.let("j");
      e.setParams({ i: S, j: P }), t.assign(y, !0), t.if((0, me._)`${S} > 1`, () => (_() ? D : k)(S, P));
    }
    function _() {
      return l.length > 0 && !l.some((S) => S === "object" || S === "array");
    }
    function D(S, P) {
      const g = t.name("item"), f = (0, _r.checkDataTypes)(l, g, m.opts.strictNumbers, _r.DataType.Wrong), h = t.const("indices", (0, me._)`{}`);
      t.for((0, me._)`;${S}--;`, () => {
        t.let(g, (0, me._)`${r}[${S}]`), t.if(f, (0, me._)`continue`), l.length > 1 && t.if((0, me._)`typeof ${g} == "string"`, (0, me._)`${g} += "_"`), t.if((0, me._)`typeof ${h}[${g}] == "number"`, () => {
          t.assign(P, (0, me._)`${h}[${g}]`), e.error(), t.assign(y, !1).break();
        }).code((0, me._)`${h}[${g}] = ${S}`);
      });
    }
    function k(S, P) {
      const g = (0, ni.useFunc)(t, ai.default), f = t.name("outer");
      t.label(f).for((0, me._)`;${S}--;`, () => t.for((0, me._)`${P} = ${S}; ${P}--;`, () => t.if((0, me._)`${g}(${r}[${S}], ${r}[${P}])`, () => {
        e.error(), t.assign(y, !1).break(f);
      })));
    }
  }
};
Qr.default = oi;
var Zr = {};
Object.defineProperty(Zr, "__esModule", { value: !0 });
const Or = X, ii = ee, ci = Ht, ui = {
  message: "must be equal to constant",
  params: ({ schemaCode: e }) => (0, Or._)`{allowedValue: ${e}}`
}, di = {
  keyword: "const",
  $data: !0,
  error: ui,
  code(e) {
    const { gen: t, data: r, $data: a, schemaCode: n, schema: i } = e;
    a || i && typeof i == "object" ? e.fail$data((0, Or._)`!${(0, ii.useFunc)(t, ci.default)}(${r}, ${n})`) : e.fail((0, Or._)`${i} !== ${r}`);
  }
};
Zr.default = di;
var xr = {};
Object.defineProperty(xr, "__esModule", { value: !0 });
const At = X, li = ee, fi = Ht, hi = {
  message: "must be equal to one of the allowed values",
  params: ({ schemaCode: e }) => (0, At._)`{allowedValues: ${e}}`
}, mi = {
  keyword: "enum",
  schemaType: "array",
  $data: !0,
  error: hi,
  code(e) {
    const { gen: t, data: r, $data: a, schema: n, schemaCode: i, it: u } = e;
    if (!a && n.length === 0)
      throw new Error("enum must have non-empty array");
    const m = n.length >= u.opts.loopEnum;
    let y;
    const l = () => y ?? (y = (0, li.useFunc)(t, fi.default));
    let p;
    if (m || a)
      p = t.let("valid"), e.block$data(p, _);
    else {
      if (!Array.isArray(n))
        throw new Error("ajv implementation error");
      const k = t.const("vSchema", i);
      p = (0, At.or)(...n.map((S, P) => D(k, P)));
    }
    e.pass(p);
    function _() {
      t.assign(p, !1), t.forOf("v", i, (k) => t.if((0, At._)`${l()}(${r}, ${k})`, () => t.assign(p, !0).break()));
    }
    function D(k, S) {
      const P = n[S];
      return typeof P == "object" && P !== null ? (0, At._)`${l()}(${r}, ${k}[${S}])` : (0, At._)`${r} === ${P}`;
    }
  }
};
xr.default = mi;
Object.defineProperty(Kr, "__esModule", { value: !0 });
const pi = Lr, $i = Hr, yi = Gr, vi = Wr, _i = Br, gi = Yr, wi = Xr, Ei = Qr, bi = Zr, Si = xr, Pi = [
  // number
  pi.default,
  $i.default,
  // string
  yi.default,
  vi.default,
  // object
  _i.default,
  gi.default,
  // array
  wi.default,
  Ei.default,
  // any
  { keyword: "type", schemaType: ["string", "array"] },
  { keyword: "nullable", schemaType: "boolean" },
  bi.default,
  Si.default
];
Kr.default = Pi;
var en = {}, wt = {};
Object.defineProperty(wt, "__esModule", { value: !0 });
wt.validateAdditionalItems = void 0;
const at = X, Nr = ee, Oi = {
  message: ({ params: { len: e } }) => (0, at.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, at._)`{limit: ${e}}`
}, Ni = {
  keyword: "additionalItems",
  type: "array",
  schemaType: ["boolean", "object"],
  before: "uniqueItems",
  error: Oi,
  code(e) {
    const { parentSchema: t, it: r } = e, { items: a } = t;
    if (!Array.isArray(a)) {
      (0, Nr.checkStrictMode)(r, '"additionalItems" is ignored when "items" is not an array of schemas');
      return;
    }
    Na(e, a);
  }
};
function Na(e, t) {
  const { gen: r, schema: a, data: n, keyword: i, it: u } = e;
  u.items = !0;
  const m = r.const("len", (0, at._)`${n}.length`);
  if (a === !1)
    e.setParams({ len: t.length }), e.pass((0, at._)`${m} <= ${t.length}`);
  else if (typeof a == "object" && !(0, Nr.alwaysValidSchema)(u, a)) {
    const l = r.var("valid", (0, at._)`${m} <= ${t.length}`);
    r.if((0, at.not)(l), () => y(l)), e.ok(l);
  }
  function y(l) {
    r.forRange("i", t.length, m, (p) => {
      e.subschema({ keyword: i, dataProp: p, dataPropType: Nr.Type.Num }, l), u.allErrors || r.if((0, at.not)(l), () => r.break());
    });
  }
}
wt.validateAdditionalItems = Na;
wt.default = Ni;
var tn = {}, Et = {};
Object.defineProperty(Et, "__esModule", { value: !0 });
Et.validateTuple = void 0;
const qn = X, ar = ee, Ti = Q, Ci = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "array", "boolean"],
  before: "uniqueItems",
  code(e) {
    const { schema: t, it: r } = e;
    if (Array.isArray(t))
      return Ta(e, "additionalItems", t);
    r.items = !0, !(0, ar.alwaysValidSchema)(r, t) && e.ok((0, Ti.validateArray)(e));
  }
};
function Ta(e, t, r = e.schema) {
  const { gen: a, parentSchema: n, data: i, keyword: u, it: m } = e;
  p(n), m.opts.unevaluated && r.length && m.items !== !0 && (m.items = ar.mergeEvaluated.items(a, r.length, m.items));
  const y = a.name("valid"), l = a.const("len", (0, qn._)`${i}.length`);
  r.forEach((_, D) => {
    (0, ar.alwaysValidSchema)(m, _) || (a.if((0, qn._)`${l} > ${D}`, () => e.subschema({
      keyword: u,
      schemaProp: D,
      dataProp: D
    }, y)), e.ok(y));
  });
  function p(_) {
    const { opts: D, errSchemaPath: k } = m, S = r.length, P = S === _.minItems && (S === _.maxItems || _[t] === !1);
    if (D.strictTuples && !P) {
      const g = `"${u}" is ${S}-tuple, but minItems or maxItems/${t} are not specified or different at path "${k}"`;
      (0, ar.checkStrictMode)(m, g, D.strictTuples);
    }
  }
}
Et.validateTuple = Ta;
Et.default = Ci;
Object.defineProperty(tn, "__esModule", { value: !0 });
const Ri = Et, ji = {
  keyword: "prefixItems",
  type: "array",
  schemaType: ["array"],
  before: "uniqueItems",
  code: (e) => (0, Ri.validateTuple)(e, "items")
};
tn.default = ji;
var rn = {};
Object.defineProperty(rn, "__esModule", { value: !0 });
const Kn = X, Ii = ee, ki = Q, Di = wt, Ai = {
  message: ({ params: { len: e } }) => (0, Kn.str)`must NOT have more than ${e} items`,
  params: ({ params: { len: e } }) => (0, Kn._)`{limit: ${e}}`
}, Mi = {
  keyword: "items",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  error: Ai,
  code(e) {
    const { schema: t, parentSchema: r, it: a } = e, { prefixItems: n } = r;
    a.items = !0, !(0, Ii.alwaysValidSchema)(a, t) && (n ? (0, Di.validateAdditionalItems)(e, n) : e.ok((0, ki.validateArray)(e)));
  }
};
rn.default = Mi;
var nn = {};
Object.defineProperty(nn, "__esModule", { value: !0 });
const Pe = X, Qt = ee, Vi = {
  message: ({ params: { min: e, max: t } }) => t === void 0 ? (0, Pe.str)`must contain at least ${e} valid item(s)` : (0, Pe.str)`must contain at least ${e} and no more than ${t} valid item(s)`,
  params: ({ params: { min: e, max: t } }) => t === void 0 ? (0, Pe._)`{minContains: ${e}}` : (0, Pe._)`{minContains: ${e}, maxContains: ${t}}`
}, Fi = {
  keyword: "contains",
  type: "array",
  schemaType: ["object", "boolean"],
  before: "uniqueItems",
  trackErrors: !0,
  error: Vi,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, it: i } = e;
    let u, m;
    const { minContains: y, maxContains: l } = a;
    i.opts.next ? (u = y === void 0 ? 1 : y, m = l) : u = 1;
    const p = t.const("len", (0, Pe._)`${n}.length`);
    if (e.setParams({ min: u, max: m }), m === void 0 && u === 0) {
      (0, Qt.checkStrictMode)(i, '"minContains" == 0 without "maxContains": "contains" keyword ignored');
      return;
    }
    if (m !== void 0 && u > m) {
      (0, Qt.checkStrictMode)(i, '"minContains" > "maxContains" is always invalid'), e.fail();
      return;
    }
    if ((0, Qt.alwaysValidSchema)(i, r)) {
      let P = (0, Pe._)`${p} >= ${u}`;
      m !== void 0 && (P = (0, Pe._)`${P} && ${p} <= ${m}`), e.pass(P);
      return;
    }
    i.items = !0;
    const _ = t.name("valid");
    m === void 0 && u === 1 ? k(_, () => t.if(_, () => t.break())) : u === 0 ? (t.let(_, !0), m !== void 0 && t.if((0, Pe._)`${n}.length > 0`, D)) : (t.let(_, !1), D()), e.result(_, () => e.reset());
    function D() {
      const P = t.name("_valid"), g = t.let("count", 0);
      k(P, () => t.if(P, () => S(g)));
    }
    function k(P, g) {
      t.forRange("i", 0, p, (f) => {
        e.subschema({
          keyword: "contains",
          dataProp: f,
          dataPropType: Qt.Type.Num,
          compositeRule: !0
        }, P), g();
      });
    }
    function S(P) {
      t.code((0, Pe._)`${P}++`), m === void 0 ? t.if((0, Pe._)`${P} >= ${u}`, () => t.assign(_, !0).break()) : (t.if((0, Pe._)`${P} > ${m}`, () => t.assign(_, !1).break()), u === 1 ? t.assign(_, !0) : t.if((0, Pe._)`${P} >= ${u}`, () => t.assign(_, !0)));
    }
  }
};
nn.default = Fi;
var Ca = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.validateSchemaDeps = e.validatePropertyDeps = e.error = void 0;
  const t = X, r = ee, a = Q;
  e.error = {
    message: ({ params: { property: y, depsCount: l, deps: p } }) => {
      const _ = l === 1 ? "property" : "properties";
      return (0, t.str)`must have ${_} ${p} when property ${y} is present`;
    },
    params: ({ params: { property: y, depsCount: l, deps: p, missingProperty: _ } }) => (0, t._)`{property: ${y},
    missingProperty: ${_},
    depsCount: ${l},
    deps: ${p}}`
    // TODO change to reference
  };
  const n = {
    keyword: "dependencies",
    type: "object",
    schemaType: "object",
    error: e.error,
    code(y) {
      const [l, p] = i(y);
      u(y, l), m(y, p);
    }
  };
  function i({ schema: y }) {
    const l = {}, p = {};
    for (const _ in y) {
      if (_ === "__proto__")
        continue;
      const D = Array.isArray(y[_]) ? l : p;
      D[_] = y[_];
    }
    return [l, p];
  }
  function u(y, l = y.schema) {
    const { gen: p, data: _, it: D } = y;
    if (Object.keys(l).length === 0)
      return;
    const k = p.let("missing");
    for (const S in l) {
      const P = l[S];
      if (P.length === 0)
        continue;
      const g = (0, a.propertyInData)(p, _, S, D.opts.ownProperties);
      y.setParams({
        property: S,
        depsCount: P.length,
        deps: P.join(", ")
      }), D.allErrors ? p.if(g, () => {
        for (const f of P)
          (0, a.checkReportMissingProp)(y, f);
      }) : (p.if((0, t._)`${g} && (${(0, a.checkMissingProp)(y, P, k)})`), (0, a.reportMissingProp)(y, k), p.else());
    }
  }
  e.validatePropertyDeps = u;
  function m(y, l = y.schema) {
    const { gen: p, data: _, keyword: D, it: k } = y, S = p.name("valid");
    for (const P in l)
      (0, r.alwaysValidSchema)(k, l[P]) || (p.if(
        (0, a.propertyInData)(p, _, P, k.opts.ownProperties),
        () => {
          const g = y.subschema({ keyword: D, schemaProp: P }, S);
          y.mergeValidEvaluated(g, S);
        },
        () => p.var(S, !0)
        // TODO var
      ), y.ok(S));
  }
  e.validateSchemaDeps = m, e.default = n;
})(Ca);
var an = {};
Object.defineProperty(an, "__esModule", { value: !0 });
const Ra = X, zi = ee, Ui = {
  message: "property name must be valid",
  params: ({ params: e }) => (0, Ra._)`{propertyName: ${e.propertyName}}`
}, qi = {
  keyword: "propertyNames",
  type: "object",
  schemaType: ["object", "boolean"],
  error: Ui,
  code(e) {
    const { gen: t, schema: r, data: a, it: n } = e;
    if ((0, zi.alwaysValidSchema)(n, r))
      return;
    const i = t.name("valid");
    t.forIn("key", a, (u) => {
      e.setParams({ propertyName: u }), e.subschema({
        keyword: "propertyNames",
        data: u,
        dataTypes: ["string"],
        propertyName: u,
        compositeRule: !0
      }, i), t.if((0, Ra.not)(i), () => {
        e.error(!0), n.allErrors || t.break();
      });
    }), e.ok(i);
  }
};
an.default = qi;
var mr = {};
Object.defineProperty(mr, "__esModule", { value: !0 });
const Zt = Q, Te = X, Ki = Re, xt = ee, Li = {
  message: "must NOT have additional properties",
  params: ({ params: e }) => (0, Te._)`{additionalProperty: ${e.additionalProperty}}`
}, Hi = {
  keyword: "additionalProperties",
  type: ["object"],
  schemaType: ["boolean", "object"],
  allowUndefined: !0,
  trackErrors: !0,
  error: Li,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, errsCount: i, it: u } = e;
    if (!i)
      throw new Error("ajv implementation error");
    const { allErrors: m, opts: y } = u;
    if (u.props = !0, y.removeAdditional !== "all" && (0, xt.alwaysValidSchema)(u, r))
      return;
    const l = (0, Zt.allSchemaProperties)(a.properties), p = (0, Zt.allSchemaProperties)(a.patternProperties);
    _(), e.ok((0, Te._)`${i} === ${Ki.default.errors}`);
    function _() {
      t.forIn("key", n, (g) => {
        !l.length && !p.length ? S(g) : t.if(D(g), () => S(g));
      });
    }
    function D(g) {
      let f;
      if (l.length > 8) {
        const h = (0, xt.schemaRefOrVal)(u, a.properties, "properties");
        f = (0, Zt.isOwnProperty)(t, h, g);
      } else
        l.length ? f = (0, Te.or)(...l.map((h) => (0, Te._)`${g} === ${h}`)) : f = Te.nil;
      return p.length && (f = (0, Te.or)(f, ...p.map((h) => (0, Te._)`${(0, Zt.usePattern)(e, h)}.test(${g})`))), (0, Te.not)(f);
    }
    function k(g) {
      t.code((0, Te._)`delete ${n}[${g}]`);
    }
    function S(g) {
      if (y.removeAdditional === "all" || y.removeAdditional && r === !1) {
        k(g);
        return;
      }
      if (r === !1) {
        e.setParams({ additionalProperty: g }), e.error(), m || t.break();
        return;
      }
      if (typeof r == "object" && !(0, xt.alwaysValidSchema)(u, r)) {
        const f = t.name("valid");
        y.removeAdditional === "failing" ? (P(g, f, !1), t.if((0, Te.not)(f), () => {
          e.reset(), k(g);
        })) : (P(g, f), m || t.if((0, Te.not)(f), () => t.break()));
      }
    }
    function P(g, f, h) {
      const O = {
        keyword: "additionalProperties",
        dataProp: g,
        dataPropType: xt.Type.Str
      };
      h === !1 && Object.assign(O, {
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }), e.subschema(O, f);
    }
  }
};
mr.default = Hi;
var sn = {};
Object.defineProperty(sn, "__esModule", { value: !0 });
const Gi = Oe, Ln = Q, gr = ee, Hn = mr, Ji = {
  keyword: "properties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, parentSchema: a, data: n, it: i } = e;
    i.opts.removeAdditional === "all" && a.additionalProperties === void 0 && Hn.default.code(new Gi.KeywordCxt(i, Hn.default, "additionalProperties"));
    const u = (0, Ln.allSchemaProperties)(r);
    for (const _ of u)
      i.definedProperties.add(_);
    i.opts.unevaluated && u.length && i.props !== !0 && (i.props = gr.mergeEvaluated.props(t, (0, gr.toHash)(u), i.props));
    const m = u.filter((_) => !(0, gr.alwaysValidSchema)(i, r[_]));
    if (m.length === 0)
      return;
    const y = t.name("valid");
    for (const _ of m)
      l(_) ? p(_) : (t.if((0, Ln.propertyInData)(t, n, _, i.opts.ownProperties)), p(_), i.allErrors || t.else().var(y, !0), t.endIf()), e.it.definedProperties.add(_), e.ok(y);
    function l(_) {
      return i.opts.useDefaults && !i.compositeRule && r[_].default !== void 0;
    }
    function p(_) {
      e.subschema({
        keyword: "properties",
        schemaProp: _,
        dataProp: _
      }, y);
    }
  }
};
sn.default = Ji;
var on = {};
Object.defineProperty(on, "__esModule", { value: !0 });
const Gn = Q, er = X, Jn = ee, Wn = ee, Wi = {
  keyword: "patternProperties",
  type: "object",
  schemaType: "object",
  code(e) {
    const { gen: t, schema: r, data: a, parentSchema: n, it: i } = e, { opts: u } = i, m = (0, Gn.allSchemaProperties)(r), y = m.filter((P) => (0, Jn.alwaysValidSchema)(i, r[P]));
    if (m.length === 0 || y.length === m.length && (!i.opts.unevaluated || i.props === !0))
      return;
    const l = u.strictSchema && !u.allowMatchingProperties && n.properties, p = t.name("valid");
    i.props !== !0 && !(i.props instanceof er.Name) && (i.props = (0, Wn.evaluatedPropsToName)(t, i.props));
    const { props: _ } = i;
    D();
    function D() {
      for (const P of m)
        l && k(P), i.allErrors ? S(P) : (t.var(p, !0), S(P), t.if(p));
    }
    function k(P) {
      for (const g in l)
        new RegExp(P).test(g) && (0, Jn.checkStrictMode)(i, `property ${g} matches pattern ${P} (use allowMatchingProperties)`);
    }
    function S(P) {
      t.forIn("key", a, (g) => {
        t.if((0, er._)`${(0, Gn.usePattern)(e, P)}.test(${g})`, () => {
          const f = y.includes(P);
          f || e.subschema({
            keyword: "patternProperties",
            schemaProp: P,
            dataProp: g,
            dataPropType: Wn.Type.Str
          }, p), i.opts.unevaluated && _ !== !0 ? t.assign((0, er._)`${_}[${g}]`, !0) : !f && !i.allErrors && t.if((0, er.not)(p), () => t.break());
        });
      });
    }
  }
};
on.default = Wi;
var cn = {};
Object.defineProperty(cn, "__esModule", { value: !0 });
const Bi = ee, Yi = {
  keyword: "not",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  code(e) {
    const { gen: t, schema: r, it: a } = e;
    if ((0, Bi.alwaysValidSchema)(a, r)) {
      e.fail();
      return;
    }
    const n = t.name("valid");
    e.subschema({
      keyword: "not",
      compositeRule: !0,
      createErrors: !1,
      allErrors: !1
    }, n), e.failResult(n, () => e.reset(), () => e.error());
  },
  error: { message: "must NOT be valid" }
};
cn.default = Yi;
var un = {};
Object.defineProperty(un, "__esModule", { value: !0 });
const Xi = Q, Qi = {
  keyword: "anyOf",
  schemaType: "array",
  trackErrors: !0,
  code: Xi.validateUnion,
  error: { message: "must match a schema in anyOf" }
};
un.default = Qi;
var dn = {};
Object.defineProperty(dn, "__esModule", { value: !0 });
const sr = X, Zi = ee, xi = {
  message: "must match exactly one schema in oneOf",
  params: ({ params: e }) => (0, sr._)`{passingSchemas: ${e.passing}}`
}, ec = {
  keyword: "oneOf",
  schemaType: "array",
  trackErrors: !0,
  error: xi,
  code(e) {
    const { gen: t, schema: r, parentSchema: a, it: n } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    if (n.opts.discriminator && a.discriminator)
      return;
    const i = r, u = t.let("valid", !1), m = t.let("passing", null), y = t.name("_valid");
    e.setParams({ passing: m }), t.block(l), e.result(u, () => e.reset(), () => e.error(!0));
    function l() {
      i.forEach((p, _) => {
        let D;
        (0, Zi.alwaysValidSchema)(n, p) ? t.var(y, !0) : D = e.subschema({
          keyword: "oneOf",
          schemaProp: _,
          compositeRule: !0
        }, y), _ > 0 && t.if((0, sr._)`${y} && ${u}`).assign(u, !1).assign(m, (0, sr._)`[${m}, ${_}]`).else(), t.if(y, () => {
          t.assign(u, !0), t.assign(m, _), D && e.mergeEvaluated(D, sr.Name);
        });
      });
    }
  }
};
dn.default = ec;
var ln = {};
Object.defineProperty(ln, "__esModule", { value: !0 });
const tc = ee, rc = {
  keyword: "allOf",
  schemaType: "array",
  code(e) {
    const { gen: t, schema: r, it: a } = e;
    if (!Array.isArray(r))
      throw new Error("ajv implementation error");
    const n = t.name("valid");
    r.forEach((i, u) => {
      if ((0, tc.alwaysValidSchema)(a, i))
        return;
      const m = e.subschema({ keyword: "allOf", schemaProp: u }, n);
      e.ok(n), e.mergeEvaluated(m);
    });
  }
};
ln.default = rc;
var fn = {};
Object.defineProperty(fn, "__esModule", { value: !0 });
const dr = X, ja = ee, nc = {
  message: ({ params: e }) => (0, dr.str)`must match "${e.ifClause}" schema`,
  params: ({ params: e }) => (0, dr._)`{failingKeyword: ${e.ifClause}}`
}, ac = {
  keyword: "if",
  schemaType: ["object", "boolean"],
  trackErrors: !0,
  error: nc,
  code(e) {
    const { gen: t, parentSchema: r, it: a } = e;
    r.then === void 0 && r.else === void 0 && (0, ja.checkStrictMode)(a, '"if" without "then" and "else" is ignored');
    const n = Bn(a, "then"), i = Bn(a, "else");
    if (!n && !i)
      return;
    const u = t.let("valid", !0), m = t.name("_valid");
    if (y(), e.reset(), n && i) {
      const p = t.let("ifClause");
      e.setParams({ ifClause: p }), t.if(m, l("then", p), l("else", p));
    } else
      n ? t.if(m, l("then")) : t.if((0, dr.not)(m), l("else"));
    e.pass(u, () => e.error(!0));
    function y() {
      const p = e.subschema({
        keyword: "if",
        compositeRule: !0,
        createErrors: !1,
        allErrors: !1
      }, m);
      e.mergeEvaluated(p);
    }
    function l(p, _) {
      return () => {
        const D = e.subschema({ keyword: p }, m);
        t.assign(u, m), e.mergeValidEvaluated(D, u), _ ? t.assign(_, (0, dr._)`${p}`) : e.setParams({ ifClause: p });
      };
    }
  }
};
function Bn(e, t) {
  const r = e.schema[t];
  return r !== void 0 && !(0, ja.alwaysValidSchema)(e, r);
}
fn.default = ac;
var hn = {};
Object.defineProperty(hn, "__esModule", { value: !0 });
const sc = ee, oc = {
  keyword: ["then", "else"],
  schemaType: ["object", "boolean"],
  code({ keyword: e, parentSchema: t, it: r }) {
    t.if === void 0 && (0, sc.checkStrictMode)(r, `"${e}" without "if" is ignored`);
  }
};
hn.default = oc;
Object.defineProperty(en, "__esModule", { value: !0 });
const ic = wt, cc = tn, uc = Et, dc = rn, lc = nn, fc = Ca, hc = an, mc = mr, pc = sn, $c = on, yc = cn, vc = un, _c = dn, gc = ln, wc = fn, Ec = hn;
function bc(e = !1) {
  const t = [
    // any
    yc.default,
    vc.default,
    _c.default,
    gc.default,
    wc.default,
    Ec.default,
    // object
    hc.default,
    mc.default,
    fc.default,
    pc.default,
    $c.default
  ];
  return e ? t.push(cc.default, dc.default) : t.push(ic.default, uc.default), t.push(lc.default), t;
}
en.default = bc;
var mn = {}, pn = {};
Object.defineProperty(pn, "__esModule", { value: !0 });
const fe = X, Sc = {
  message: ({ schemaCode: e }) => (0, fe.str)`must match format "${e}"`,
  params: ({ schemaCode: e }) => (0, fe._)`{format: ${e}}`
}, Pc = {
  keyword: "format",
  type: ["number", "string"],
  schemaType: "string",
  $data: !0,
  error: Sc,
  code(e, t) {
    const { gen: r, data: a, $data: n, schema: i, schemaCode: u, it: m } = e, { opts: y, errSchemaPath: l, schemaEnv: p, self: _ } = m;
    if (!y.validateFormats)
      return;
    n ? D() : k();
    function D() {
      const S = r.scopeValue("formats", {
        ref: _.formats,
        code: y.code.formats
      }), P = r.const("fDef", (0, fe._)`${S}[${u}]`), g = r.let("fType"), f = r.let("format");
      r.if((0, fe._)`typeof ${P} == "object" && !(${P} instanceof RegExp)`, () => r.assign(g, (0, fe._)`${P}.type || "string"`).assign(f, (0, fe._)`${P}.validate`), () => r.assign(g, (0, fe._)`"string"`).assign(f, P)), e.fail$data((0, fe.or)(h(), O()));
      function h() {
        return y.strictSchema === !1 ? fe.nil : (0, fe._)`${u} && !${f}`;
      }
      function O() {
        const j = p.$async ? (0, fe._)`(${P}.async ? await ${f}(${a}) : ${f}(${a}))` : (0, fe._)`${f}(${a})`, V = (0, fe._)`(typeof ${f} == "function" ? ${j} : ${f}.test(${a}))`;
        return (0, fe._)`${f} && ${f} !== true && ${g} === ${t} && !${V}`;
      }
    }
    function k() {
      const S = _.formats[i];
      if (!S) {
        h();
        return;
      }
      if (S === !0)
        return;
      const [P, g, f] = O(S);
      P === t && e.pass(j());
      function h() {
        if (y.strictSchema === !1) {
          _.logger.warn(V());
          return;
        }
        throw new Error(V());
        function V() {
          return `unknown format "${i}" ignored in schema at path "${l}"`;
        }
      }
      function O(V) {
        const w = V instanceof RegExp ? (0, fe.regexpCode)(V) : y.code.formats ? (0, fe._)`${y.code.formats}${(0, fe.getProperty)(i)}` : void 0, N = r.scopeValue("formats", { key: i, ref: V, code: w });
        return typeof V == "object" && !(V instanceof RegExp) ? [V.type || "string", V.validate, (0, fe._)`${N}.validate`] : ["string", V, N];
      }
      function j() {
        if (typeof S == "object" && !(S instanceof RegExp) && S.async) {
          if (!p.$async)
            throw new Error("async format in sync schema");
          return (0, fe._)`await ${f}(${a})`;
        }
        return typeof g == "function" ? (0, fe._)`${f}(${a})` : (0, fe._)`${f}.test(${a})`;
      }
    }
  }
};
pn.default = Pc;
Object.defineProperty(mn, "__esModule", { value: !0 });
const Oc = pn, Nc = [Oc.default];
mn.default = Nc;
var _t = {};
Object.defineProperty(_t, "__esModule", { value: !0 });
_t.contentVocabulary = _t.metadataVocabulary = void 0;
_t.metadataVocabulary = [
  "title",
  "description",
  "default",
  "deprecated",
  "readOnly",
  "writeOnly",
  "examples"
];
_t.contentVocabulary = [
  "contentMediaType",
  "contentEncoding",
  "contentSchema"
];
Object.defineProperty(zr, "__esModule", { value: !0 });
const Tc = Ur, Cc = Kr, Rc = en, jc = mn, Yn = _t, Ic = [
  Tc.default,
  Cc.default,
  (0, Rc.default)(),
  jc.default,
  Yn.metadataVocabulary,
  Yn.contentVocabulary
];
zr.default = Ic;
var $n = {}, Ia = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.DiscrError = void 0, function(t) {
    t.Tag = "tag", t.Mapping = "mapping";
  }(e.DiscrError || (e.DiscrError = {}));
})(Ia);
Object.defineProperty($n, "__esModule", { value: !0 });
const pt = X, Tr = Ia, Xn = we, kc = ee, Dc = {
  message: ({ params: { discrError: e, tagName: t } }) => e === Tr.DiscrError.Tag ? `tag "${t}" must be string` : `value of tag "${t}" must be in oneOf`,
  params: ({ params: { discrError: e, tag: t, tagName: r } }) => (0, pt._)`{error: ${e}, tag: ${r}, tagValue: ${t}}`
}, Ac = {
  keyword: "discriminator",
  type: "object",
  schemaType: "object",
  error: Dc,
  code(e) {
    const { gen: t, data: r, schema: a, parentSchema: n, it: i } = e, { oneOf: u } = n;
    if (!i.opts.discriminator)
      throw new Error("discriminator: requires discriminator option");
    const m = a.propertyName;
    if (typeof m != "string")
      throw new Error("discriminator: requires propertyName");
    if (a.mapping)
      throw new Error("discriminator: mapping is not supported");
    if (!u)
      throw new Error("discriminator: requires oneOf keyword");
    const y = t.let("valid", !1), l = t.const("tag", (0, pt._)`${r}${(0, pt.getProperty)(m)}`);
    t.if((0, pt._)`typeof ${l} == "string"`, () => p(), () => e.error(!1, { discrError: Tr.DiscrError.Tag, tag: l, tagName: m })), e.ok(y);
    function p() {
      const k = D();
      t.if(!1);
      for (const S in k)
        t.elseIf((0, pt._)`${l} === ${S}`), t.assign(y, _(k[S]));
      t.else(), e.error(!1, { discrError: Tr.DiscrError.Mapping, tag: l, tagName: m }), t.endIf();
    }
    function _(k) {
      const S = t.name("valid"), P = e.subschema({ keyword: "oneOf", schemaProp: k }, S);
      return e.mergeEvaluated(P, pt.Name), S;
    }
    function D() {
      var k;
      const S = {}, P = f(n);
      let g = !0;
      for (let j = 0; j < u.length; j++) {
        let V = u[j];
        V != null && V.$ref && !(0, kc.schemaHasRulesButRef)(V, i.self.RULES) && (V = Xn.resolveRef.call(i.self, i.schemaEnv.root, i.baseId, V == null ? void 0 : V.$ref), V instanceof Xn.SchemaEnv && (V = V.schema));
        const w = (k = V == null ? void 0 : V.properties) === null || k === void 0 ? void 0 : k[m];
        if (typeof w != "object")
          throw new Error(`discriminator: oneOf subschemas (or referenced schemas) must have "properties/${m}"`);
        g = g && (P || f(V)), h(w, j);
      }
      if (!g)
        throw new Error(`discriminator: "${m}" must be required`);
      return S;
      function f({ required: j }) {
        return Array.isArray(j) && j.includes(m);
      }
      function h(j, V) {
        if (j.const)
          O(j.const, V);
        else if (j.enum)
          for (const w of j.enum)
            O(w, V);
        else
          throw new Error(`discriminator: "properties/${m}" must have "const" or "enum"`);
      }
      function O(j, V) {
        if (typeof j != "string" || j in S)
          throw new Error(`discriminator: "${m}" values must be unique strings`);
        S[j] = V;
      }
    }
  }
};
$n.default = Ac;
const Mc = "http://json-schema.org/draft-07/schema#", Vc = "http://json-schema.org/draft-07/schema#", Fc = "Core schema meta-schema", zc = {
  schemaArray: {
    type: "array",
    minItems: 1,
    items: {
      $ref: "#"
    }
  },
  nonNegativeInteger: {
    type: "integer",
    minimum: 0
  },
  nonNegativeIntegerDefault0: {
    allOf: [
      {
        $ref: "#/definitions/nonNegativeInteger"
      },
      {
        default: 0
      }
    ]
  },
  simpleTypes: {
    enum: [
      "array",
      "boolean",
      "integer",
      "null",
      "number",
      "object",
      "string"
    ]
  },
  stringArray: {
    type: "array",
    items: {
      type: "string"
    },
    uniqueItems: !0,
    default: []
  }
}, Uc = [
  "object",
  "boolean"
], qc = {
  $id: {
    type: "string",
    format: "uri-reference"
  },
  $schema: {
    type: "string",
    format: "uri"
  },
  $ref: {
    type: "string",
    format: "uri-reference"
  },
  $comment: {
    type: "string"
  },
  title: {
    type: "string"
  },
  description: {
    type: "string"
  },
  default: !0,
  readOnly: {
    type: "boolean",
    default: !1
  },
  examples: {
    type: "array",
    items: !0
  },
  multipleOf: {
    type: "number",
    exclusiveMinimum: 0
  },
  maximum: {
    type: "number"
  },
  exclusiveMaximum: {
    type: "number"
  },
  minimum: {
    type: "number"
  },
  exclusiveMinimum: {
    type: "number"
  },
  maxLength: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minLength: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  pattern: {
    type: "string",
    format: "regex"
  },
  additionalItems: {
    $ref: "#"
  },
  items: {
    anyOf: [
      {
        $ref: "#"
      },
      {
        $ref: "#/definitions/schemaArray"
      }
    ],
    default: !0
  },
  maxItems: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minItems: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  uniqueItems: {
    type: "boolean",
    default: !1
  },
  contains: {
    $ref: "#"
  },
  maxProperties: {
    $ref: "#/definitions/nonNegativeInteger"
  },
  minProperties: {
    $ref: "#/definitions/nonNegativeIntegerDefault0"
  },
  required: {
    $ref: "#/definitions/stringArray"
  },
  additionalProperties: {
    $ref: "#"
  },
  definitions: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  properties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    default: {}
  },
  patternProperties: {
    type: "object",
    additionalProperties: {
      $ref: "#"
    },
    propertyNames: {
      format: "regex"
    },
    default: {}
  },
  dependencies: {
    type: "object",
    additionalProperties: {
      anyOf: [
        {
          $ref: "#"
        },
        {
          $ref: "#/definitions/stringArray"
        }
      ]
    }
  },
  propertyNames: {
    $ref: "#"
  },
  const: !0,
  enum: {
    type: "array",
    items: !0,
    minItems: 1,
    uniqueItems: !0
  },
  type: {
    anyOf: [
      {
        $ref: "#/definitions/simpleTypes"
      },
      {
        type: "array",
        items: {
          $ref: "#/definitions/simpleTypes"
        },
        minItems: 1,
        uniqueItems: !0
      }
    ]
  },
  format: {
    type: "string"
  },
  contentMediaType: {
    type: "string"
  },
  contentEncoding: {
    type: "string"
  },
  if: {
    $ref: "#"
  },
  then: {
    $ref: "#"
  },
  else: {
    $ref: "#"
  },
  allOf: {
    $ref: "#/definitions/schemaArray"
  },
  anyOf: {
    $ref: "#/definitions/schemaArray"
  },
  oneOf: {
    $ref: "#/definitions/schemaArray"
  },
  not: {
    $ref: "#"
  }
}, Kc = {
  $schema: Mc,
  $id: Vc,
  title: Fc,
  definitions: zc,
  type: Uc,
  properties: qc,
  default: !0
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.MissingRefError = t.ValidationError = t.CodeGen = t.Name = t.nil = t.stringify = t.str = t._ = t.KeywordCxt = void 0;
  const r = Zn, a = zr, n = $n, i = Kc, u = ["/properties"], m = "http://json-schema.org/draft-07/schema";
  class y extends r.default {
    _addVocabularies() {
      super._addVocabularies(), a.default.forEach((S) => this.addVocabulary(S)), this.opts.discriminator && this.addKeyword(n.default);
    }
    _addDefaultMetaSchema() {
      if (super._addDefaultMetaSchema(), !this.opts.meta)
        return;
      const S = this.opts.$data ? this.$dataMetaSchema(i, u) : i;
      this.addMetaSchema(S, m, !1), this.refs["http://json-schema.org/schema"] = m;
    }
    defaultMeta() {
      return this.opts.defaultMeta = super.defaultMeta() || (this.getSchema(m) ? m : void 0);
    }
  }
  e.exports = t = y, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = y;
  var l = Oe;
  Object.defineProperty(t, "KeywordCxt", { enumerable: !0, get: function() {
    return l.KeywordCxt;
  } });
  var p = X;
  Object.defineProperty(t, "_", { enumerable: !0, get: function() {
    return p._;
  } }), Object.defineProperty(t, "str", { enumerable: !0, get: function() {
    return p.str;
  } }), Object.defineProperty(t, "stringify", { enumerable: !0, get: function() {
    return p.stringify;
  } }), Object.defineProperty(t, "nil", { enumerable: !0, get: function() {
    return p.nil;
  } }), Object.defineProperty(t, "Name", { enumerable: !0, get: function() {
    return p.Name;
  } }), Object.defineProperty(t, "CodeGen", { enumerable: !0, get: function() {
    return p.CodeGen;
  } });
  var _ = Kt;
  Object.defineProperty(t, "ValidationError", { enumerable: !0, get: function() {
    return _.default;
  } });
  var D = Lt;
  Object.defineProperty(t, "MissingRefError", { enumerable: !0, get: function() {
    return D.default;
  } });
})(Er, Er.exports);
var yn = Er.exports;
const Lc = /* @__PURE__ */ jr(yn);
var Cr = { exports: {} };
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = yn, a = X, n = vt, i = Oe, u = gt, m = Re, y = "errorMessage", l = new r.Name("emUsed"), p = {
    required: "missingProperty",
    dependencies: "property",
    dependentRequired: "property"
  }, _ = /\$\{[^}]+\}/, D = /\$\{([^}]+)\}/g, k = /^""\s*\+\s*|\s*\+\s*""$/g;
  function S(g) {
    return {
      keyword: y,
      schemaType: ["string", "object"],
      post: !0,
      code(f) {
        const { gen: h, data: O, schema: j, schemaValue: V, it: w } = f;
        if (w.createErrors === !1)
          return;
        const N = j, I = a.strConcat(m.default.instancePath, w.errorPath);
        h.if(r._`${m.default.errors} > 0`, () => {
          if (typeof N == "object") {
            const [v, s] = z(N);
            s && J(s), v && K(v), re(A(N));
          }
          const b = typeof N == "string" ? N : N._;
          b && ne(b), g.keepErrors || ve();
        });
        function A({ properties: b, items: v }) {
          const s = {};
          if (b) {
            s.props = {};
            for (const c in b)
              s.props[c] = [];
          }
          if (v) {
            s.items = {};
            for (let c = 0; c < v.length; c++)
              s.items[c] = [];
          }
          return s;
        }
        function z(b) {
          let v, s;
          for (const c in b) {
            if (c === "properties" || c === "items")
              continue;
            const T = b[c];
            if (typeof T == "object") {
              v || (v = {});
              const F = v[c] = {};
              for (const M in T)
                F[M] = [];
            } else
              s || (s = {}), s[c] = [];
          }
          return [v, s];
        }
        function J(b) {
          const v = h.const("emErrors", r.stringify(b)), s = h.const("templates", Ie(b, j));
          h.forOf("err", m.default.vErrors, (M) => h.if(je(M, v), () => h.code(r._`${v}[${M}.keyword].push(${M})`).assign(r._`${M}.${l}`, !0)));
          const { singleError: c } = g;
          if (c) {
            const M = h.let("message", r._`""`), q = h.let("paramsErrors", r._`[]`);
            T((W) => {
              h.if(M, () => h.code(r._`${M} += ${typeof c == "string" ? c : ";"}`)), h.code(r._`${M} += ${F(W)}`), h.assign(q, r._`${q}.concat(${v}[${W}])`);
            }), u.reportError(f, { message: M, params: r._`{errors: ${q}}` });
          } else
            T((M) => u.reportError(f, {
              message: F(M),
              params: r._`{errors: ${v}[${M}]}`
            }));
          function T(M) {
            h.forIn("key", v, (q) => h.if(r._`${v}[${q}].length`, () => M(q)));
          }
          function F(M) {
            return r._`${M} in ${s} ? ${s}[${M}]() : ${V}[${M}]`;
          }
        }
        function K(b) {
          const v = h.const("emErrors", r.stringify(b)), s = [];
          for (const q in b)
            s.push([
              q,
              Ie(b[q], j[q])
            ]);
          const c = h.const("templates", h.object(...s)), T = h.scopeValue("obj", {
            ref: p,
            code: r.stringify(p)
          }), F = h.let("emPropParams"), M = h.let("emParamsErrors");
          h.forOf("err", m.default.vErrors, (q) => h.if(je(q, v), () => {
            h.assign(F, r._`${T}[${q}.keyword]`), h.assign(M, r._`${v}[${q}.keyword][${q}.params[${F}]]`), h.if(M, () => h.code(r._`${M}.push(${q})`).assign(r._`${q}.${l}`, !0));
          })), h.forIn("key", v, (q) => h.forIn("keyProp", r._`${v}[${q}]`, (W) => {
            h.assign(M, r._`${v}[${q}][${W}]`), h.if(r._`${M}.length`, () => {
              const te = h.const("tmpl", r._`${c}[${q}] && ${c}[${q}][${W}]`);
              u.reportError(f, {
                message: r._`${te} ? ${te}() : ${V}[${q}][${W}]`,
                params: r._`{errors: ${M}}`
              });
            });
          }));
        }
        function re(b) {
          const { props: v, items: s } = b;
          if (!v && !s)
            return;
          const c = r._`typeof ${O} == "object"`, T = r._`Array.isArray(${O})`, F = h.let("emErrors");
          let M, q;
          const W = h.let("templates");
          v && s ? (M = h.let("emChildKwd"), h.if(c), h.if(T, () => {
            te(s, j.items), h.assign(M, r.str`items`);
          }, () => {
            te(v, j.properties), h.assign(M, r.str`properties`);
          }), q = r._`[${M}]`) : s ? (h.if(T), te(s, j.items), q = r._`.items`) : v && (h.if(a.and(c, a.not(T))), te(v, j.properties), q = r._`.properties`), h.forOf("err", m.default.vErrors, (ie) => He(ie, F, (ke) => h.code(r._`${F}[${ke}].push(${ie})`).assign(r._`${ie}.${l}`, !0))), h.forIn("key", F, (ie) => h.if(r._`${F}[${ie}].length`, () => {
            u.reportError(f, {
              message: r._`${ie} in ${W} ? ${W}[${ie}]() : ${V}${q}[${ie}]`,
              params: r._`{errors: ${F}[${ie}]}`
            }), h.assign(r._`${m.default.vErrors}[${m.default.errors}-1].instancePath`, r._`${I} + "/" + ${ie}.replace(/~/g, "~0").replace(/\\//g, "~1")`);
          })), h.endIf();
          function te(ie, ke) {
            h.assign(F, r.stringify(ie)), h.assign(W, Ie(ie, ke));
          }
        }
        function ne(b) {
          const v = h.const("emErrs", r._`[]`);
          h.forOf("err", m.default.vErrors, (s) => h.if(Xe(s), () => h.code(r._`${v}.push(${s})`).assign(r._`${s}.${l}`, !0))), h.if(r._`${v}.length`, () => u.reportError(f, {
            message: U(b),
            params: r._`{errors: ${v}}`
          }));
        }
        function ve() {
          const b = h.const("emErrs", r._`[]`);
          h.forOf("err", m.default.vErrors, (v) => h.if(r._`!${v}.${l}`, () => h.code(r._`${b}.push(${v})`))), h.assign(m.default.vErrors, b).assign(m.default.errors, r._`${b}.length`);
        }
        function je(b, v) {
          return a.and(
            r._`${b}.keyword !== ${y}`,
            r._`!${b}.${l}`,
            r._`${b}.instancePath === ${I}`,
            r._`${b}.keyword in ${v}`,
            // TODO match the end of the string?
            r._`${b}.schemaPath.indexOf(${w.errSchemaPath}) === 0`,
            r._`/^\\/[^\\/]*$/.test(${b}.schemaPath.slice(${w.errSchemaPath.length}))`
          );
        }
        function He(b, v, s) {
          h.if(a.and(r._`${b}.keyword !== ${y}`, r._`!${b}.${l}`, r._`${b}.instancePath.indexOf(${I}) === 0`), () => {
            const c = h.scopeValue("pattern", {
              ref: /^\/([^/]*)(?:\/|$)/,
              code: r._`new RegExp("^\\\/([^/]*)(?:\\\/|$)")`
            }), T = h.const("emMatches", r._`${c}.exec(${b}.instancePath.slice(${I}.length))`), F = h.const("emChild", r._`${T} && ${T}[1].replace(/~1/g, "/").replace(/~0/g, "~")`);
            h.if(r._`${F} !== undefined && ${F} in ${v}`, () => s(F));
          });
        }
        function Xe(b) {
          return a.and(r._`${b}.keyword !== ${y}`, r._`!${b}.${l}`, a.or(r._`${b}.instancePath === ${I}`, a.and(r._`${b}.instancePath.indexOf(${I}) === 0`, r._`${b}.instancePath[${I}.length] === "/"`)), r._`${b}.schemaPath.indexOf(${w.errSchemaPath}) === 0`, r._`${b}.schemaPath[${w.errSchemaPath}.length] === "/"`);
        }
        function Ie(b, v) {
          const s = [];
          for (const c in b) {
            const T = v[c];
            _.test(T) && s.push([c, E(T)]);
          }
          return h.object(...s);
        }
        function U(b) {
          return _.test(b) ? new n._Code(n.safeStringify(b).replace(D, (v, s) => `" + JSON.stringify(${i.getData(s, w)}) + "`).replace(k, "")) : r.stringify(b);
        }
        function E(b) {
          return r._`function(){return ${U(b)}}`;
        }
      },
      metaSchema: {
        anyOf: [
          { type: "string" },
          {
            type: "object",
            properties: {
              properties: { $ref: "#/$defs/stringMap" },
              items: { $ref: "#/$defs/stringList" },
              required: { $ref: "#/$defs/stringOrMap" },
              dependencies: { $ref: "#/$defs/stringOrMap" }
            },
            additionalProperties: { type: "string" }
          }
        ],
        $defs: {
          stringMap: {
            type: "object",
            additionalProperties: { type: "string" }
          },
          stringOrMap: {
            anyOf: [{ type: "string" }, { $ref: "#/$defs/stringMap" }]
          },
          stringList: { type: "array", items: { type: "string" } }
        }
      }
    };
  }
  const P = (g, f = {}) => {
    if (!g.opts.allErrors)
      throw new Error("ajv-errors: Ajv option allErrors must be true");
    if (g.opts.jsPropertySyntax)
      throw new Error("ajv-errors: ajv option jsPropertySyntax is not supported");
    return g.addKeyword(S(f));
  };
  t.default = P, e.exports = P, e.exports.default = P;
})(Cr, Cr.exports);
var Hc = Cr.exports;
const Gc = /* @__PURE__ */ jr(Hc);
var Rr = { exports: {} }, ka = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatNames = e.fastFormats = e.fullFormats = void 0;
  function t(A, z) {
    return { validate: A, compare: z };
  }
  e.fullFormats = {
    // date: http://tools.ietf.org/html/rfc3339#section-5.6
    date: t(i, u),
    // date-time: http://tools.ietf.org/html/rfc3339#section-5.6
    time: t(y, l),
    "date-time": t(_, D),
    // duration: https://tools.ietf.org/html/rfc3339#appendix-A
    duration: /^P(?!$)((\d+Y)?(\d+M)?(\d+D)?(T(?=\d)(\d+H)?(\d+M)?(\d+S)?)?|(\d+W)?)$/,
    uri: P,
    "uri-reference": /^(?:[a-z][a-z0-9+\-.]*:)?(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'"()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'"()*+,;=:@]|%[0-9a-f]{2})*)*)?(?:\?(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'"()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i,
    // uri-template: https://tools.ietf.org/html/rfc6570
    "uri-template": /^(?:(?:[^\x00-\x20"'<>%\\^`{|}]|%[0-9a-f]{2})|\{[+#./;?&=,!@|]?(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?(?:,(?:[a-z0-9_]|%[0-9a-f]{2})+(?::[1-9][0-9]{0,3}|\*)?)*\})*$/i,
    // For the source: https://gist.github.com/dperini/729294
    // For test cases: https://mathiasbynens.be/demo/url-regex
    url: /^(?:https?|ftp):\/\/(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)(?:\.(?:[a-z0-9\u{00a1}-\u{ffff}]+-)*[a-z0-9\u{00a1}-\u{ffff}]+)*(?:\.(?:[a-z\u{00a1}-\u{ffff}]{2,})))(?::\d{2,5})?(?:\/[^\s]*)?$/iu,
    email: /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i,
    hostname: /^(?=.{1,253}\.?$)[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[-0-9a-z]{0,61}[0-9a-z])?)*\.?$/i,
    // optimized https://www.safaribooksonline.com/library/view/regular-expressions-cookbook/9780596802837/ch07s16.html
    ipv4: /^(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)$/,
    ipv6: /^((([0-9a-f]{1,4}:){7}([0-9a-f]{1,4}|:))|(([0-9a-f]{1,4}:){6}(:[0-9a-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){5}(((:[0-9a-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){4}(((:[0-9a-f]{1,4}){1,3})|((:[0-9a-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){3}(((:[0-9a-f]{1,4}){1,4})|((:[0-9a-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){2}(((:[0-9a-f]{1,4}){1,5})|((:[0-9a-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){1}(((:[0-9a-f]{1,4}){1,6})|((:[0-9a-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9a-f]{1,4}){1,7})|((:[0-9a-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))$/i,
    regex: I,
    // uuid: http://tools.ietf.org/html/rfc4122
    uuid: /^(?:urn:uuid:)?[0-9a-f]{8}-(?:[0-9a-f]{4}-){3}[0-9a-f]{12}$/i,
    // JSON-pointer: https://tools.ietf.org/html/rfc6901
    // uri fragment: https://tools.ietf.org/html/rfc3986#appendix-A
    "json-pointer": /^(?:\/(?:[^~/]|~0|~1)*)*$/,
    "json-pointer-uri-fragment": /^#(?:\/(?:[a-z0-9_\-.!$&'()*+,;:=@]|%[0-9a-f]{2}|~0|~1)*)*$/i,
    // relative JSON-pointer: http://tools.ietf.org/html/draft-luff-relative-json-pointer-00
    "relative-json-pointer": /^(?:0|[1-9][0-9]*)(?:#|(?:\/(?:[^~/]|~0|~1)*)*)$/,
    // the following formats are used by the openapi specification: https://spec.openapis.org/oas/v3.0.0#data-types
    // byte: https://github.com/miguelmota/is-base64
    byte: f,
    // signed 32 bit integer
    int32: { type: "number", validate: j },
    // signed 64 bit integer
    int64: { type: "number", validate: V },
    // C-type float
    float: { type: "number", validate: w },
    // C-type double
    double: { type: "number", validate: w },
    // hint to the UI to hide input strings
    password: !0,
    // unchecked string payload
    binary: !0
  }, e.fastFormats = {
    ...e.fullFormats,
    date: t(/^\d\d\d\d-[0-1]\d-[0-3]\d$/, u),
    time: t(/^(?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)?$/i, l),
    "date-time": t(/^\d\d\d\d-[0-1]\d-[0-3]\d[t\s](?:[0-2]\d:[0-5]\d:[0-5]\d|23:59:60)(?:\.\d+)?(?:z|[+-]\d\d(?::?\d\d)?)$/i, D),
    // uri: https://github.com/mafintosh/is-my-json-valid/blob/master/formats.js
    uri: /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/)?[^\s]*$/i,
    "uri-reference": /^(?:(?:[a-z][a-z0-9+\-.]*:)?\/?\/)?(?:[^\\\s#][^\s#]*)?(?:#[^\\\s]*)?$/i,
    // email (sources from jsen validator):
    // http://stackoverflow.com/questions/201323/using-a-regular-expression-to-validate-an-email-address#answer-8829363
    // http://www.w3.org/TR/html5/forms.html#valid-e-mail-address (search for 'wilful violation')
    email: /^[a-z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?)*$/i
  }, e.formatNames = Object.keys(e.fullFormats);
  function r(A) {
    return A % 4 === 0 && (A % 100 !== 0 || A % 400 === 0);
  }
  const a = /^(\d\d\d\d)-(\d\d)-(\d\d)$/, n = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  function i(A) {
    const z = a.exec(A);
    if (!z)
      return !1;
    const J = +z[1], K = +z[2], re = +z[3];
    return K >= 1 && K <= 12 && re >= 1 && re <= (K === 2 && r(J) ? 29 : n[K]);
  }
  function u(A, z) {
    if (A && z)
      return A > z ? 1 : A < z ? -1 : 0;
  }
  const m = /^(\d\d):(\d\d):(\d\d)(\.\d+)?(z|[+-]\d\d(?::?\d\d)?)?$/i;
  function y(A, z) {
    const J = m.exec(A);
    if (!J)
      return !1;
    const K = +J[1], re = +J[2], ne = +J[3], ve = J[5];
    return (K <= 23 && re <= 59 && ne <= 59 || K === 23 && re === 59 && ne === 60) && (!z || ve !== "");
  }
  function l(A, z) {
    if (!(A && z))
      return;
    const J = m.exec(A), K = m.exec(z);
    if (J && K)
      return A = J[1] + J[2] + J[3] + (J[4] || ""), z = K[1] + K[2] + K[3] + (K[4] || ""), A > z ? 1 : A < z ? -1 : 0;
  }
  const p = /t|\s/i;
  function _(A) {
    const z = A.split(p);
    return z.length === 2 && i(z[0]) && y(z[1], !0);
  }
  function D(A, z) {
    if (!(A && z))
      return;
    const [J, K] = A.split(p), [re, ne] = z.split(p), ve = u(J, re);
    if (ve !== void 0)
      return ve || l(K, ne);
  }
  const k = /\/|:/, S = /^(?:[a-z][a-z0-9+\-.]*:)(?:\/?\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:]|%[0-9a-f]{2})*@)?(?:\[(?:(?:(?:(?:[0-9a-f]{1,4}:){6}|::(?:[0-9a-f]{1,4}:){5}|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}|(?:(?:[0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::)(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?))|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|[Vv][0-9a-f]+\.[a-z0-9\-._~!$&'()*+,;=:]+)\]|(?:(?:25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d\d?)|(?:[a-z0-9\-._~!$&'()*+,;=]|%[0-9a-f]{2})*)(?::\d*)?(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*|\/(?:(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)?|(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})+(?:\/(?:[a-z0-9\-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*)*)(?:\?(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?(?:#(?:[a-z0-9\-._~!$&'()*+,;=:@/?]|%[0-9a-f]{2})*)?$/i;
  function P(A) {
    return k.test(A) && S.test(A);
  }
  const g = /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/gm;
  function f(A) {
    return g.lastIndex = 0, g.test(A);
  }
  const h = -(2 ** 31), O = 2 ** 31 - 1;
  function j(A) {
    return Number.isInteger(A) && A <= O && A >= h;
  }
  function V(A) {
    return Number.isInteger(A);
  }
  function w() {
    return !0;
  }
  const N = /[^\\]\\Z/;
  function I(A) {
    if (N.test(A))
      return !1;
    try {
      return new RegExp(A), !0;
    } catch {
      return !1;
    }
  }
})(ka);
var Da = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.formatLimitDefinition = void 0;
  const t = yn, r = X, a = r.operators, n = {
    formatMaximum: { okStr: "<=", ok: a.LTE, fail: a.GT },
    formatMinimum: { okStr: ">=", ok: a.GTE, fail: a.LT },
    formatExclusiveMaximum: { okStr: "<", ok: a.LT, fail: a.GTE },
    formatExclusiveMinimum: { okStr: ">", ok: a.GT, fail: a.LTE }
  }, i = {
    message: ({ keyword: m, schemaCode: y }) => r.str`should be ${n[m].okStr} ${y}`,
    params: ({ keyword: m, schemaCode: y }) => r._`{comparison: ${n[m].okStr}, limit: ${y}}`
  };
  e.formatLimitDefinition = {
    keyword: Object.keys(n),
    type: "string",
    schemaType: "string",
    $data: !0,
    error: i,
    code(m) {
      const { gen: y, data: l, schemaCode: p, keyword: _, it: D } = m, { opts: k, self: S } = D;
      if (!k.validateFormats)
        return;
      const P = new t.KeywordCxt(D, S.RULES.all.format.definition, "format");
      P.$data ? g() : f();
      function g() {
        const O = y.scopeValue("formats", {
          ref: S.formats,
          code: k.code.formats
        }), j = y.const("fmt", r._`${O}[${P.schemaCode}]`);
        m.fail$data(r.or(r._`typeof ${j} != "object"`, r._`${j} instanceof RegExp`, r._`typeof ${j}.compare != "function"`, h(j)));
      }
      function f() {
        const O = P.schema, j = S.formats[O];
        if (!j || j === !0)
          return;
        if (typeof j != "object" || j instanceof RegExp || typeof j.compare != "function")
          throw new Error(`"${_}": format "${O}" does not define "compare" function`);
        const V = y.scopeValue("formats", {
          key: O,
          ref: j,
          code: k.code.formats ? r._`${k.code.formats}${r.getProperty(O)}` : void 0
        });
        m.fail$data(h(V));
      }
      function h(O) {
        return r._`${O}.compare(${l}, ${p}) ${n[_].fail} 0`;
      }
    },
    dependencies: ["format"]
  };
  const u = (m) => (m.addKeyword(e.formatLimitDefinition), m);
  e.default = u;
})(Da);
(function(e, t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const r = ka, a = Da, n = X, i = new n.Name("fullFormats"), u = new n.Name("fastFormats"), m = (l, p = { keywords: !0 }) => {
    if (Array.isArray(p))
      return y(l, p, r.fullFormats, i), l;
    const [_, D] = p.mode === "fast" ? [r.fastFormats, u] : [r.fullFormats, i], k = p.formats || r.formatNames;
    return y(l, k, _, D), p.keywords && a.default(l), l;
  };
  m.get = (l, p = "full") => {
    const D = (p === "fast" ? r.fastFormats : r.fullFormats)[l];
    if (!D)
      throw new Error(`Unknown format "${l}"`);
    return D;
  };
  function y(l, p, _, D) {
    var k, S;
    (k = (S = l.opts.code).formats) !== null && k !== void 0 || (S.formats = n._`require("ajv-formats/dist/formats").${D}`);
    for (const P of p)
      l.addFormat(P, _[P]);
  }
  e.exports = t = m, Object.defineProperty(t, "__esModule", { value: !0 }), t.default = m;
})(Rr, Rr.exports);
var Jc = Rr.exports;
const Wc = /* @__PURE__ */ jr(Jc), Qn = Wc(
  Gc(
    new Lc({
      allErrors: !0,
      $data: !0,
      strict: !0,
      strictTypes: !0,
      strictSchema: !0,
      strictRequired: !0,
      strictNumbers: !0,
      strictTuples: !0,
      coerceTypes: !0,
      removeAdditional: !0,
      useDefaults: !0
    })
  )
);
function Bc(e, t = 250) {
  const [r, a] = tr(e);
  return wr(() => {
    const n = setTimeout(() => {
      a(e);
    }, t);
    return () => {
      clearTimeout(n);
    };
  }, [e, t]), r;
}
const Xc = (e, t, r) => {
  var N;
  const a = Ja(jn(e)), [n, i] = tr(jn(e)), [u, m] = tr(null), [y, l] = tr(0), p = Bc(u, (r == null ? void 0 : r.debounceTime) || 500);
  (N = r == null ? void 0 : r.customKeywords) != null && N.length && Xa(Qn, r.customKeywords);
  const _ = Qn.compile(t), D = () => {
    i(a.current);
  }, k = (I) => {
    const A = _({ [I]: n[I].value }), z = _.errors || [], J = A ? {} : Yt(z, r == null ? void 0 : r.userDefinedMessages), K = V && J[I] || "";
    i((re) => ({
      ...re,
      [I]: {
        ...re[I],
        error: K
      }
    }));
  }, S = (I) => {
    k(I);
  }, P = (I) => {
    i((A) => {
      const z = { ...A };
      return Object.keys(I).forEach((J) => {
        var re;
        const K = J;
        z[K] = {
          ...z[K],
          value: It(I[K]),
          error: ((re = z[K]) == null ? void 0 : re.error) || ""
        };
      }), m({
        name: Object.keys(I)[0],
        editId: y
      }), l(y + 1), z;
    });
  }, g = (I) => Object.keys(I).reduce(
    (A, z) => {
      const J = z;
      return {
        ...A,
        [z]: {
          value: It(n[J].value),
          error: I[z] || ""
        }
      };
    },
    { ...n }
  ), f = () => {
    try {
      const I = Object.keys(n).reduce((A, z) => ({
        ...A,
        [z]: It(n[z].value)
      }), {});
      if (!_(I) && _.errors) {
        const A = Yt(
          _.errors,
          r == null ? void 0 : r.userDefinedMessages
        );
        return i(
          g(
            Object.keys(A).reduce((z, J) => ({
              ...z,
              [J]: It(A[J])
            }), {})
          )
        ), { isValid: !1, data: null };
      }
      return O(n, a.current) ? { isValid: !0, data: I } : { isValid: !1, data: null };
    } catch {
      return { isValid: !1, data: null };
    }
  }, h = (I, A) => Object.keys(I).some(
    (z) => I[z].value !== A[z].value
  ), O = (I, A) => {
    const z = Object.keys(I).some(
      (K) => I[K].error !== ""
    ), J = h(I, A);
    return !z && J;
  }, j = Rn(() => O(n, a.current), [n]), V = Rn(
    () => h(n, a.current),
    [n]
  ), w = (I) => {
    i(g(Yt(I, r == null ? void 0 : r.userDefinedMessages)));
  };
  return wr(() => {
    (r == null ? void 0 : r.shouldDebounceAndValidate) === !1 || !p || k(p.name);
  }, [p]), wr(() => {
    var I;
    (I = r == null ? void 0 : r.errors) != null && I.length && i(g(Yt(r == null ? void 0 : r.errors, r == null ? void 0 : r.userDefinedMessages)));
  }, [r == null ? void 0 : r.errors]), {
    reset: D,
    set: P,
    setErrors: w,
    validate: f,
    onBlur: S,
    isValid: j,
    isDirty: V,
    data: Object.keys(n).reduce((I, A) => ({
      ...I,
      [A]: It(n[A].value)
    }), {}),
    state: n
  };
};
export {
  Xc as default
};
